package cz.zcu.kiv.offscreen.graph;

import cz.zcu.kiv.offscreen.api.EdgeInterface;
import java.util.LinkedList;
import java.util.List;
import org.apache.log4j.Logger;

/**
 * This class represents edge.
 *
 * @author Jindra Pavlíková
 */
public class EdgeImpl implements EdgeInterface {

    private int edgeId;
    private String from;
    private String to;
    private List<String> packageConnections;
    private Logger logger = Logger.getLogger(EdgeImpl.class);

    /**
     * Inicialization of edge.
     *
     * @param edgeId id of edge
     * @param from name of vertex which leads from the edge
     * @param to name of vertex which leads to the edge
     */
    public EdgeImpl(int edgeId, String from, String to) {
        logger.trace("ENTRY");
        this.edgeId = edgeId;
        this.from = from;
        this.to = to;
        this.packageConnections = new LinkedList<String>();
        logger.trace("EXIT");
    }

    @Override
    public String getFrom() {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return from;

    }

    @Override
    public String getTo() {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return to;
    }

    @Override
    public int getId() {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return edgeId;
    }

    @Override
    public List<String> getPackageConnections() {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return this.packageConnections;
    }

    @Override
    public void setPackageConnection(List<String> packageConnections) {
        logger.trace("ENTRY");
        this.packageConnections = packageConnections;
        logger.trace("EXIT");
    }
    
   
}
