/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.zcu.kiv.offscreen.loader.configuration;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import javax.servlet.ServletContext;
import org.apache.log4j.Logger;

/**
 *
 * @author Jindra Pavlíková <jindra.pav2@seznam.cz>
 */
public class ConfigurationLoader {

    public static final String CONFIGURATION_FILENAME = "configuration.properties";
    public static final String PATH_TO_CONFIG_FILE = "/WEB-INF";
    public static final String PROP_STORAGE_LOCATION = "storageLocation";
    private static Logger logger = Logger.getLogger(ConfigurationLoader.class);

    private static Properties loadProperties(ServletContext context) throws IOException {
        logger.trace("ENTRY");
        Properties properties = new Properties();
        InputStream in = context.getResourceAsStream(PATH_TO_CONFIG_FILE + File.separator + CONFIGURATION_FILENAME);

        if (in != null) {
            properties.load(in);
        }
        logger.trace("EXIT");
        return properties;
    }

    public static String getStorageLocation(ServletContext context) throws IOException {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return loadProperties(context).getProperty(PROP_STORAGE_LOCATION);
    }
}
