/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.zcu.kiv.offscreen.servlets;

import cz.zcu.kiv.offscreen.loader.configuration.ConfigurationLoader;
import cz.zcu.kiv.offscreen.session.SessionManager;
import cz.zcu.kiv.offscreen.storage.FileManager;
import cz.zcu.kiv.offscreen.user.DB;
import cz.zcu.kiv.offscreen.user.Diagram;
import cz.zcu.kiv.offscreen.user.User;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;

/**
 *
 * @author Jindra Pavlíková <jindra.pav2@seznam.cz>
 */
public class SettingGraph extends HttpServlet {

    private Logger logger = Logger.getLogger(SettingGraph.class);

    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        //processRequest(request, response);
        logger.trace("ENTRY");
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/uploadComponent.jsp");
        String sessionValue = SessionManager.getSessionValue(request, "JSESSIONID");
        String storageLocation = ConfigurationLoader.getStorageLocation(request.getServletContext());
        logger.debug("session: " + sessionValue);
        
        if (sessionValue != null && !"".equals(sessionValue)) {
            FileManager fileManager = new FileManager(sessionValue, storageLocation);
            logger.debug("vytvoren file manager");
            if (!fileManager.isExistStorage()) {
                fileManager.createStorageDirectory();
                logger.debug("vytvoren storageDirectory");
            }

            request.setAttribute("componentNames", fileManager.getUploadedComponentsNames());
        }
        
        DB db = new DB(getServletContext()); 
        //User user = new User(db, 1);
        //System.out.println("NICK: " + user.getNick());
        
        
        ArrayList<Map<String, String>> list = new ArrayList<Map<String, String>>();
        if ( request.getSession().getAttribute("logged_user") == "1" ) {
        	Diagram diagram_list = new Diagram(db);
			list = diagram_list.getDiagramListByUserId( (int) request.getSession().getAttribute("logged_user_id"));		  
        }
        
        request.setAttribute("diagramNames", list);
        
        
        rd.forward(request, response);
        logger.trace("EXIT");
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        throw new UnsupportedOperationException();
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return "Short description";
    }// </editor-fold>
}
