/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.zcu.kiv.offscreen.servlets;

import java.io.File;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;

import cz.zcu.kiv.offscreen.loader.configuration.ConfigurationLoader;
import cz.zcu.kiv.offscreen.session.SessionManager;
import cz.zcu.kiv.offscreen.storage.FileManager;
import cz.zcu.kiv.offscreen.user.DB;
import cz.zcu.kiv.offscreen.user.Diagram;

/**
 *
 * @author Jindra PavlĂ­kovĂˇ <jindra.pav2@seznam.cz>
 */
public class ShowGraph extends HttpServlet {

    private Logger logger = Logger.getLogger(ShowGraph.class);

    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.trace("ENTRY");
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/index.jsp");
        rd.forward(request, response);
        logger.trace("EXIT");
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.trace("ENTRY");
        request.setCharacterEncoding("UTF-8");
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/index.jsp");
        String cookie_framework = "osgi";
        //
        if (request.getParameter("framework") != null ){
        	cookie_framework = request.getParameter("framework");
        }
        
        Cookie cookie = new Cookie("framework", cookie_framework);
        response.addCookie(cookie);
       
        
        //save new diagram
        if ( request.getParameter("diagram_name") != null && 
        	 request.getParameter("diagram_name").length()>0 && 
        	 request.getParameter("diagram_id") == null ) {

        	String sessionValue = SessionManager.getSessionValue(request, "JSESSIONID");
        	String storageLocation = ConfigurationLoader.getStorageLocation(request.getServletContext());
        	DB db = new DB(getServletContext());
        	

                	
            FileManager file_manage_without_id = new FileManager(sessionValue, storageLocation);
            
        	
        	Diagram diag = new Diagram(db);
        	HashMap<String, String> item_map = new HashMap<String, String>();
        	
        	String public_diag = "0";
        	if ( request.getParameter("public_diagram") != null && request.getParameter("public_diagram").compareTo("1") == 0 ) {
        		public_diag = "1";
        	}

        	
        	
        	item_map.put("diagram_name", request.getParameter("diagram_name") );
        	item_map.put("hash", sessionValue ) ;
        	item_map.put("user_id",  request.getSession().getAttribute("logged_user_id").toString() ) ;
        	item_map.put("component_count", Integer.toString(file_manage_without_id.getUploadedComponentsNames().size() ) ) ;
        	item_map.put("public", public_diag ) ;
        	diag.update(item_map);
        	
            
            
            String file_directory = sessionValue;
            file_directory = sessionValue + "_" + diag.getIdStr();
        	FileManager file_manage = new FileManager(file_directory, storageLocation);
        	if (file_manage.isExistStorage() == false){
        		file_manage.createStorageDirectory();
        	}
        	
        	//copy directory to directory with postfix "_<id_diagram>"
        	file_manage_without_id.copyUploadedComponents(storageLocation + File.separator + file_directory);

        	
        	//redirect to url, which shows graph
        	response.sendRedirect( getServletContext().getInitParameter("HOME_URL") + "ShowGraph?diagram_id=" + diag.getIdStr() + "&diagram_hash=" + sessionValue );
        	//end of servlet after redirect page
        	return;
        	        	
        	
        }else if ( request.getParameter("diagram_name") != null && 
        		   request.getParameter("diagram_id") != null   &&
        		   request.getSession().getAttribute("logged_user_id") != null ) {
        	System.out.println("DIAGRAM_NAMES NOT NULL	");
        	
        	
        	String sessionValue = SessionManager.getSessionValue(request, "JSESSIONID");
        	String storageLocation = ConfigurationLoader.getStorageLocation(request.getServletContext());
        	
        	DB db = new DB(getServletContext());
        	Diagram diag = new Diagram(db,Integer.parseInt(request.getParameter("diagram_id")));
        	HashMap<String, String> item_map = new HashMap<String, String>(); 
            HashMap<String, String> diag_param = (HashMap<String, String>) diag.getDiagramParam(Integer.parseInt(request.getParameter("diagram_id")));
            
            
            
            
            
        	boolean copy_diag = false;
        	if ( request.getParameter("copy_diag") != null && request.getParameter("copy_diag").compareTo("1") == 0 ) {
        		copy_diag = true;
        	}
        	if ( copy_diag )  {
        		Diagram copied_diag = new Diagram(db, Integer.parseInt(request.getParameter("diagram_id")));
        		HashMap<String, String> copied_diag_param = (HashMap<String, String>) copied_diag.getDiagramParam(Integer.parseInt(request.getParameter("diagram_id")));
                
                String hash_code = copied_diag_param.get("hash");
                String vertices_position = copied_diag_param.get("vertices_position");
        		FileManager copied_file_manage = new FileManager( hash_code + "_" + request.getParameter("diagram_id") , storageLocation);
        		if (copied_file_manage.isExistStorage() == false){
        			copied_file_manage.createStorageDirectory();
            	}
        		copied_file_manage.copyUploadedComponents(storageLocation + File.separator + sessionValue);
        		
        		
        		Diagram new_diag = new Diagram(db);
            	HashMap<String, String> new_item_map = new HashMap<String, String>();
           	
            	new_item_map.put("diagram_name", request.getParameter("diagram_name") );
            	new_item_map.put("hash", sessionValue ) ;
            	new_item_map.put("user_id",  request.getSession().getAttribute("logged_user_id").toString() ) ;
            	new_item_map.put("component_count", Integer.toString(copied_file_manage.getUploadedComponentsNames().size() ) ) ;
            	new_item_map.put("public", "0");
            	
            	new_diag.update(new_item_map);
            	
            	new_diag.updateVerticesPosition(vertices_position);
            	
                
                
                String file_directory = sessionValue;
                file_directory = sessionValue + "_" + new_diag.getIdStr();
            	FileManager file_manage = new FileManager(file_directory, storageLocation);
            	if (file_manage.isExistStorage() == false){
            		file_manage.createStorageDirectory();
            	}
            	
            	//copy directory to directory with postfix "_<id_diagram>"
            	copied_file_manage.copyUploadedComponents(storageLocation + File.separator + file_directory);

            	
            	//redirect to url, which shows graph
            	response.sendRedirect( getServletContext().getInitParameter("HOME_URL") + "ShowGraph?diagram_id=" + new_diag.getIdStr() + "&diagram_hash=" + sessionValue );
            	//end of servlet after redirect page
            	return;
        	}
                        
            
            String hash_code = diag_param.get("hash");
            String user_id = diag_param.get("user_id");
            System.out.println("user_id: " + user_id);
            if (Integer.parseInt(user_id) == Integer.parseInt( request.getSession().getAttribute("logged_user_id").toString() ) ){            
		        	
				FileManager file_manage = new FileManager(hash_code + "_" + request.getParameter("diagram_id"), storageLocation);
				
				String public_diag = "0";
				if ( request.getParameter("public_diagram") != null && request.getParameter("public_diagram").compareTo("1") == 0 ) {
					public_diag = "1";
				}
				
				item_map.put("component_count", Integer.toString(file_manage.getUploadedComponentsNames().size() ) ) ;
				item_map.put("diagram_name", request.getParameter("diagram_name"));
				item_map.put("public", public_diag);
				diag.update(item_map);
				
            } else{
            	System.out.println("Operation is not permitted.");
            	
            }
        	
        	
        } 
        
        
        
        
       
    	if ( request.getParameter("id_diagram") != null && 
    		 Integer.parseInt(request.getParameter("id_diagram") ) > 0 ) {
    		
    		request.getSession().setAttribute("id_diagram", request.getParameter("id_diagram"));
    		
    		
    		
    		//otestovat, zda je uživatel přihlášen
    		// zda je diagram s id X nahrán tímto uživatelem
    		
    	}
    
    	
    	
        boolean show_icon_save = false;
        if (request.getParameter("diagram_id")!= null && request.getParameter("diagram_hash")!= null ) {
        	show_icon_save = true;
        }
        
        request.setAttribute("show_icon_save", show_icon_save);
    	
   
       
        
        
        rd.forward(request, response);

        logger.trace("EXIT");
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return "Short description";
    }
}
