/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.zcu.kiv.offscreen.servlets.actions;

import cz.zcu.kiv.offscreen.loader.configuration.ConfigurationLoader;
import cz.zcu.kiv.offscreen.session.SessionManager;
import cz.zcu.kiv.offscreen.storage.FileManager;
import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;

/**
 *
 * @author Jindra Pavlíková <jindra.pav2@seznam.cz>
 */
public class DeleteAllComponents extends HttpServlet {

     private Logger logger = Logger.getLogger(DeleteAllComponents.class);
    
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/uploadComponent.jsp");
        String sessionValue = SessionManager.getSessionValue(request, "JSESSIONID");
        String storageLocation = ConfigurationLoader.getStorageLocation(request.getServletContext());
        
        String file_directory = sessionValue;
        if ( request.getParameter("diagram_id") != null ) {
        	file_directory = sessionValue + "_" + request.getParameter("diagram_id");
        }
        
        FileManager fileManager = new FileManager(file_directory, storageLocation);
        
        fileManager.deleteAllFiles();
        
        request.setAttribute("componentNames", fileManager.getUploadedComponentsNames());
        response.sendRedirect(getServletContext().getInitParameter("HOME_URL") + "UploadFiles");
       // rd.forward(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        throw new UnsupportedOperationException();
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
