/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.zcu.kiv.offscreen.servlets.actions;

import cz.zcu.kiv.offscreen.loader.configuration.ConfigurationLoader;
import cz.zcu.kiv.offscreen.storage.FileManager;
import cz.zcu.kiv.offscreen.session.SessionManager;
import cz.zcu.kiv.offscreen.user.DB;
import cz.zcu.kiv.offscreen.user.Diagram;

import java.io.IOException;
import java.util.HashMap;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;

/**
 *
 * @author Jindra Pavlíková <jindra.pav2@seznam.cz>
 */
public class DeleteComponent extends HttpServlet {
     private Logger logger = Logger.getLogger(DeleteComponent.class);
    


    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        
        String sessionValue = SessionManager.getSessionValue(request, "JSESSIONID");
        String storageLocation = ConfigurationLoader.getStorageLocation(request.getServletContext());

        String file_directory = sessionValue;
        String url_redirect = "";
        boolean right_delete_component = true;
        if (request.getParameter("diagram_id") != null && request.getParameter("diagram_hash") != null) {
        	file_directory = request.getParameter("diagram_hash") + "_" + request.getParameter("diagram_id");
        	url_redirect = "?diagram_id="+request.getParameter("diagram_id") + "&diagram_hash="+request.getParameter("diagram_hash");
        	
            DB db = new DB(getServletContext());
                        
            Diagram diagram = new Diagram(db, Integer.parseInt(request.getParameter("diagram_id")));
        	
            System.out.println("Diagram id: " + request.getParameter("diagram_id"));
            System.out.println("Diagram hash: " + request.getParameter("diagram_hash"));
            
            
            
            HashMap<String, String> diag_param = (HashMap<String, String>) diagram.getDiagramParam(Integer.parseInt(request.getParameter("diagram_id")));
            if (request.getSession().getAttribute("logged_user_id") == null){
        		right_delete_component = false;
            }else if ( Integer.parseInt(diag_param.get("user_id")) == Integer.parseInt(request.getSession().getAttribute("logged_user_id").toString())) {
            	System.out.println("Diagram id INT: " + Integer.parseInt(diag_param.get("user_id")));
            	System.out.println("Diagram sess id INT: " + Integer.parseInt(request.getSession().getAttribute("logged_user_id").toString()));
            	right_delete_component = true;
        	}else{
        		right_delete_component = false;
        	}
        }
        
        if ( right_delete_component ) {
	        FileManager fileManager = new FileManager(file_directory, storageLocation);
	        
	        fileManager.deleteFile(request.getParameter("name"));
	                
	        request.setAttribute("componentNames", fileManager.getUploadedComponentsNames());
        }
        response.sendRedirect(getServletContext().getInitParameter("HOME_URL") + "UploadFiles" + url_redirect);

    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        throw new UnsupportedOperationException();
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }
}
