package cz.zcu.kiv.offscreen.servlets.actions;

import java.io.IOException;                
import java.util.HashMap;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import cz.zcu.kiv.offscreen.loader.configuration.ConfigurationLoader;
import cz.zcu.kiv.offscreen.storage.FileManager;
import cz.zcu.kiv.offscreen.user.DB;
import cz.zcu.kiv.offscreen.user.Diagram;

/**
 * Class is for deleting diagram from database and from file system.
 * 
 * @author Daniel Bureš
 *
 */
public class DeleteDiagram extends HttpServlet{

    private Logger logger = Logger.getLogger(DeleteComponent.class);
  
    
    /**
     * Servlet deletes diagram from database and from file system.
     * Id of diagrams is loaded from get parameter in url.
     * In method is controlled logged user and user, who uploaded diagram.
     * 
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/uploadComponent.jsp");        
        String storageLocation = ConfigurationLoader.getStorageLocation(request.getServletContext());

        //id,ktere se ma odstranit
        String id_diagram  = request.getParameter("id_diagram");
        DB db = new DB(getServletContext());
        try{
        	Diagram diagram = new Diagram(db, Integer.parseInt(id_diagram));
        	
        	HashMap<String,String> diag_param = (HashMap<String, String>) diagram.getDiagramParam(Integer.parseInt(id_diagram));        	
        	
        	//kontrola id přihlášeného uživatele a uživatele, který nahrál diagram
        	if ( Integer.parseInt(diag_param.get("user_id")) == Integer.parseInt(request.getSession().getAttribute("logged_user_id").toString()) ) {
        		
        		FileManager fileManager = new FileManager( diag_param.get("hash") + "_" + diag_param.get("id"), storageLocation);
                fileManager.deleteAllFiles();
                fileManager.deleteDirectory();
                
        		diagram.delete();
        	}
        	
        	
        }catch(NumberFormatException e){
        	System.out.println("Nelze odstranit");
        	
        }catch(Exception e){
        	e.printStackTrace();
        }
        
        
        rd.forward(request, response);
    }
    
}
