package cz.zcu.kiv.offscreen.servlets.actions;

import cz.zcu.kiv.offscreen.user.DB;
import cz.zcu.kiv.offscreen.user.Diagram;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;

/**
 * Class is used for loading position of compoment in diagram by id and hash code.
 *
 * @author Daniel Bureš
 */
public class LoadDiagram extends HttpServlet {

    private Logger logger = Logger.getLogger(LoadDiagram.class);

    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.trace("ENTRY");
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
        try {
        	
        	
        	String output = "";
        	DB db = new DB(getServletContext());
        	Diagram diag = new Diagram(db);
        	HashMap<String,String> param = (HashMap<String, String>) diag.getDiagramParam( Integer.parseInt(request.getParameter("diagram_id")));
        	
        	output += param.get("vertices_position");
        	
        	
            out.write(output);


        } finally {
            out.close();
        }
        logger.trace("EXIT");
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        throw new UnsupportedOperationException();
    }
}
