package cz.zcu.kiv.offscreen.servlets.actions;

import java.io.IOException;
import java.util.HashMap;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import cz.zcu.kiv.offscreen.user.DB;
import cz.zcu.kiv.offscreen.user.Diagram;

/**
 * Class is used for saving position of components in diagram.
 * 
 * @author Daniel Bureš
 *
 */
public class SaveDiagram extends HttpServlet{
    private Logger logger = Logger.getLogger(SaveDiagram.class);
  
    
    /**
     * Method saves position of component, which are send by parameter in post method.
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/uploadComponent.jsp");

        //id of diagram, which will be updated
        String id_diagram  = request.getParameter("id_diagram");
        String vertices_position  = request.getParameter("vertices_position");
        DB db = new DB(getServletContext());
        try{
        	Diagram diagram = new Diagram(db, Integer.parseInt(id_diagram));
        	HashMap<String, String> diag_param = (HashMap<String, String>) diagram.getDiagramParam(Integer.parseInt(id_diagram));
        	if (Integer.parseInt(diag_param.get("user_id")) == Integer.parseInt(request.getSession().getAttribute("logged_user_id").toString())) {
        		diagram.updateVerticesPosition(vertices_position);
        	}
        	
        }catch(NumberFormatException e){
        	e.printStackTrace();
        }catch(Exception e){
        	e.printStackTrace();
        }
        
        rd.forward(request, response);
    }
}
