package cz.zcu.kiv.offscreen.servlets.actions;

import cz.zcu.kiv.offscreen.loader.configuration.ConfigurationLoader;
import cz.zcu.kiv.offscreen.session.SessionManager;
import cz.zcu.kiv.offscreen.storage.FileManager;
import cz.zcu.kiv.offscreen.user.DB;
import cz.zcu.kiv.offscreen.user.Diagram;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.log4j.Logger;

/**
 *
 * @author Jindra PavlĂ­kovĂˇ <jindra.pav2@seznam.cz>
 */
public class UploadFiles extends HttpServlet {

    private Logger logger = Logger.getLogger(UploadFiles.class);

    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
         logger.trace("ENTRY");
         
       
         
         doPost(request, response);
         logger.trace("EXIT");
         //throw new UnsupportedOperationException();
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        logger.trace("ENTRY");
        
        DB db = new DB(getServletContext());
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/uploadComponent.jsp");
        String error = null;
        String sessionValue = SessionManager.getSessionValue(request, "JSESSIONID");        
        String storageLocation = ConfigurationLoader.getStorageLocation(request.getServletContext());
        String diagram_id = request.getParameter("diagram_id");
        
        if (diagram_id != null) {
	        Diagram diagram_edit = new Diagram(db, Integer.parseInt(diagram_id));
	        HashMap<String, String> diag_param = (HashMap<String, String>) diagram_edit.getDiagramParam(Integer.parseInt(diagram_id));
	        
	        request.setAttribute("diagram_name", diag_param.get("name"));
	        request.setAttribute("diagram_user_id", diag_param.get("user_id"));
	        request.setAttribute("diagram_public_checked", (diag_param.get("public").compareTo("1") ==0?" checked=\"checked\" ": ""));	        
	        
        }else{
        	request.setAttribute("diagram_name", "");
        	request.setAttribute("diagram_public_checked", "");
        	request.setAttribute("diagram_user_id", "-1");
        }
        
        String file_directory = sessionValue;
        if ( request.getParameter("diagram_hash") != null ) {
        	sessionValue =  request.getParameter("diagram_hash");
        }
        
        if ( request.getParameter("diagram_id") != null ) {
        	file_directory = sessionValue + "_" + request.getParameter("diagram_id");
        }
        
        FileManager fileManager = new FileManager(file_directory , storageLocation);
        
        if (!fileManager.isExistStorage()) {
            fileManager.createStorageDirectory();
        }

        response.setContentType("text/html");
        boolean isMultipart = ServletFileUpload.isMultipartContent(request);

        if (!isMultipart) {
            request.setAttribute("error", "No components uploaded.");
        } else {
            error = fileManager.saveFile(request);
        }
        
    	       
        
        ArrayList<Map<String, String>> list = new ArrayList<Map<String, String>>();
        if ( request.getSession().getAttribute("logged_user") == "1" ) {
        	Diagram diagram_list = new Diagram(db);
			list = diagram_list.getDiagramListByUserId( (int) request.getSession().getAttribute("logged_user_id"));		  
        }
        
        
        request.setAttribute("diagramNames", list);
        
        
    	Diagram diagram_public_list_c = new Diagram(db);
    	ArrayList<Map<String, String>> diagram_public_list = new ArrayList<Map<String, String>>();
    	diagram_public_list = diagram_public_list_c.getDiagramPublicList();		  
            
        request.setAttribute("diagramPublic", diagram_public_list);
        
        request.setAttribute("componentNames", fileManager.getUploadedComponentsNames());
        request.setAttribute("errorMessage", error);
        rd.forward(request, response);        
        logger.trace("EXIT");
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        logger.trace("ENTRY");
        logger.trace("EXIT");
        return "Short description";
    }

    
}
