
/**
 * Funkce zavola servlet, ktery odstrani diagram z databáze a ze serveru. 
 * 
 * @param id_diagram - id diagramu
 */
function deleteDiagram(id_diagram){
	$.get("DeleteDiagram?id_diagram=" + id_diagram, function(data) {
		  $('#diagram_id_' + id_diagram).remove();
		  $('#public_diagram_id_' + id_diagram).remove();
		});
	
}

/**
 * Funkce zakoduje html zpravu.
 * 
 * @param html_str
 * @returns
 */
function encode_html(html_str){
	html_str = html_str.replace(/"/gi,  '&quote;');
	html_str = html_str.replace(/\n/gi, 'EOL');
	html_str = html_str.replace(/\r/gi, ' ');
	html_str = html_str.replace(/\t/gi, ' ');
	html_str = html_str.replace(/\\/gi, '&backslash;');
	
	return html_str;
}

/**
 * Funkce dekoduje html zpravu.
 * @param html_str
 * @returns
 */
function decode_html(html_str){
	html_str = html_str.replace(/&quote;/gi,     '"');
	html_str = html_str.replace(/EOL/gi,         '\n');
	html_str = html_str.replace(/&backslash;/gi, '\\');
	
	return html_str;
}

/**
 * Funkce ulozi obsah viewportu a rightpanelu do databaze.
 * 
 * @param id_diagram
 */
function save_diagram(id_diagram) {
	var viewport_html = $('#viewport').html();
	var rightpanel_html = $('#rightPanel').html();

	rightpanel_html = encode_html(rightpanel_html);
	viewport_html = encode_html(viewport_html);
	
	$.post('./SaveDiagram', { id_diagram: id_diagram, rightpanel_html: rightpanel_html ,viewport_html: viewport_html } );
	
	
}


/**
 * Funkce nacte viewport a rightpanel u diagramu z db a zobrazi ho
 * 
 * @param id_diagram
 */
function load_diagram(id_diagram){
	var viewport_html = '';
	var rightpanel_html = '';
	
	$.get('./LoadDiagram?id_diagram=' + id_diagram, function(data) {
			rightpanel_html = decode_html(data.rightpanel_html);
			viewport_html = decode_html(data.viewport_html);
		
			$('#viewport').html(viewport_html);
			$('#rightPanel').html(rightpanel_html);
		});
	
}

/**
 *  Funkce nalezne vsechny komponenty zobrazene ve viewportu a ulozi je do zpravy typu json a odesle servletu.
 * @param id_diagram
 */
function export_vertex_position(id_diagram){
	var vertex_position = new Array();
	var vertex_position_counter = 0;
	$('g.vertex').each(function(){
									vertex_position[vertex_position_counter] = ' {"id":"'+$(this).attr('id')+'" , ' + 
												   '  "transform":"'+$(this).attr('transform')+'" }';
									vertex_position_counter++;
									});
	
	vertex_position.join(',');
	
	vertex_position = '{"vertices_position": [ ' + vertex_position + ' ]}';
	
	$.post('./SaveDiagram', { id_diagram: id_diagram, vertices_position: vertex_position } )
		   .done(function() { alert("Diagram saved."); })
		   .fail(function() { alert("Error - Diagram not saved."); });
	
}

/**
 * Funkce zobrazi vyskakovaci okno s potvrzenim
 * 
 * @param id_diagram
 * @param diagram_hash
 * @returns {Boolean}
 */
function reset_diagram(id_diagram, diagram_hash){
	
	var really = confirm('Do you want reset components position and refresh page?');
	
	if (really == false) return false;
	
	$.post('./SaveDiagram', { id_diagram: id_diagram, vertices_position: "" } );
	
	return true;
	
	
}








