/**
 * Object which represent graph.
 */
var GraphManager = {
    graph: null,
    unconList: [],
    vertices_position: null,
    forceField: [],
    otherVertex: [],
    canvasSize: 0,
    
    // parametry layoutu
    inumber: 300, // pocet iteraci
    inumberClick: 20, // pocet iteraci u tlacitka
    restrength: 450, // odpudiva sila (prima umera)
    atstrength: 110, // pritazliva sila (neprima umera, nesmi byt 0)
    deffect: 200, // tlumeni sily (nesmi byt 0)
    borderRatio: 1, // hranice layoutu (cislo kterym se deli velikost canvasu)  
    				// tahle funkce se mi nelibi, je treba to vyresit jinak, nici to layout (nechat na 1)
    
    layouting: false,
    myVar: null,
    
    /**
     * 
     */
    init: function(){
        console.debug("ENTRY graphManager - init()");
        this.buildGraph.bind(this);
        this.forceDirectedLayoutOnClick = this.forceDirectedLayoutOnClick.bind(this);
        
        console.debug("EXIT graphManager - init()");
    },
    
    forceDirectedLayoutOnClick: function(){
    	
    	if (this.layouting == true){
    		$('#applyLayoutImg').attr('src', 'images/layout_off.png');
    		$('#applyLayout').css('stroke', 'red');
    		this.layouting = false;
    		clearInterval(this.myVar);
    	}
    	else{
    		$('#applyLayoutImg').attr('src', 'images/layout_on.png');
    		this.layouting = true;
    		this.myVar = window.setInterval(this.awesomeFirePenguin.bind(this), 10);
    	}
    
    },
    
    /**
     * 	Force directed layout for visible components
     */
    awesomeFirePenguin: function(){
    	//$('#rightPanel').append("l... <BR>");
    	
    	var canvas = this.canvasSize;
    	
    	var repulsiveStrength = this.restrength; // more is more
    	var attractiveStrength = this.atstrength; // more is less
    	var dampeningEffect = this.deffect;
    	var border = canvas/this.borderRatio;
    	
    	var visibleVertices = new Array();
    	var vertices = this.graph.vertices;
    	var counter = 0;
    	var otherVisibleVertices = new Array();
    	
    	//$('#rightPanel').append(vertices.length+"<BR>");
    	
    	// gets the visible components
    	for (var i = 0; i < vertices.length; i++){		
    		if (vertices[i].$selector.css('display') != 'none'){
    			//$('#rightPanel').append("add<BR>");
    			
    			visibleVertices[counter] = vertices[i];
    			counter++;
    		}
    		
    	}
    	
    	//$('#rightPanel').append(visibleVertices.length+"<BR>");
    	
    	for (var i = 0; i < this.graph.vertices.length; i++){    		   		
    		this.forceField[i][0] = 0;
    		this.forceField[i][1] = 0;
    	} 
    	
    	// calculate repulsive force
    	for (var i = 0; i < visibleVertices.length; i++){
    		
    		var currVertex = visibleVertices[i];    		
    		//var otherVertex = new Array();
    		
    		// other vertices
    		for (var j = 0; j < visibleVertices.length; j++){
    			otherVisibleVertices[j] = visibleVertices[j];
    		}    		
    		otherVisibleVertices.splice(i, 1);
    		
    		//$('#rightPanel').append(otherVisibleVertices.length+" - rf<BR>");
    		// iterate over other vertices
    		for (var j = 0; j < otherVisibleVertices.length; j++){
    			// currVertex position
    			var currX = currVertex.x;
    			var currY = currVertex.y;
    			
    			// otherVertex position
    			var otherX = otherVisibleVertices[j].x;
    			var otherY = otherVisibleVertices[j].y;
    			
    			// calculate force
    			var x = currX - otherX;
    			var y = currY - otherY;
    			
    			//$('#rightPanel').append(x+" | "+y+" - rf<BR>");
    			
    			var sum = Math.pow(x,2) + Math.pow(y,2);
    			var distance = Math.sqrt(sum);   			
    			
    			if (distance != 0){
    						
    				this.forceField[currVertex.id-1][0] += Math.floor((x * (repulsiveStrength / distance)));
        			this.forceField[currVertex.id-1][1] += Math.floor((y * (repulsiveStrength / distance)));
    			}   			
    		}
		
    		
    		//$('#rightPanel').append(this.forceField[i][0]+" | "+this.forceField[i][1]+" - rf<BR>");
    	}
    	
    	
    	// calculate attractive forces
    	for (var i = 0; i < visibleVertices.length; i++){
    		var currVertex = visibleVertices[i];
    		//$('#rightPanel').append(currVertex.id+"<BR>");
    		//$('#rightPanel').append(currVertex.edges.length+"<BR>");
    		
    		for (var j = 0; j < currVertex.edges.length; j++){
    			
    			var otherVertex; 
    			
    			if (currVertex.edges[j].to == currVertex){
    				otherVertex = currVertex.edges[j].from;
    			}  			
    			else {
    				otherVertex = currVertex.edges[j].to;
    			}
    			
    			if (otherVertex.$selector.css('display') == 'none'){
    				continue;
    			}
    			
    			// currVertex position
    			var currX = currVertex.x;
    			var currY = currVertex.y;
    			
    			// otherVertex position
    			var otherX = otherVertex.x;
    			var otherY = otherVertex.y;
    			
    			// calculate force
    			var x = currX - otherX;
                var y = currY - otherY;
                
                var sum = Math.pow(x, 2) + Math.pow(y, 2);                
                var distance = Math.sqrt(sum); 
                //$('#rightPanel').append(distance+"<BR>");
                this.forceField[visibleVertices[i].id-1][0] += Math.round(-( (x * (distance / attractiveStrength)))); 
                this.forceField[visibleVertices[i].id-1][1] += Math.round(-( (y * (distance / attractiveStrength))));
    			/*
                this.forceField[otherVertex.id-1][0] -= Math.round(-( (x * (distance / attractiveStrength)))); 
                this.forceField[otherVertex.id-1][1] -= Math.round(-( (y * (distance / attractiveStrength))));
               */
    		}
    		 
    		//$('#rightPanel').append(this.forceField[i][0]+" | "+this.forceField[i][1]+" - ff<BR>");
    	}
    	
    	// applying the force
    	for (var i = 0; i < this.graph.vertices.length; i++){
    		var currVertex = this.graph.vertices[i];
    		
    		var halfCan = canvas / 2;
    		
    		var deltaX = currVertex.x - halfCan;
    		var deltaY = currVertex.y - halfCan;
  		
    		// tohle drzi layout uprostred, chtelo by to vymyslet nejak lip, docela ho to kurvi
            /*
    		if (deltaX > 0) {
            	currVertex.x = Math.min(currVertex.x, (canvas/2)+border);
            } else {
            	currVertex.x = Math.max(currVertex.x, (canvas/2)-border);
            }
            if (deltaY > 0) {
            	currVertex.y = Math.min(currVertex.y, (canvas/2)+border);
            } else {
            	currVertex.y = Math.max(currVertex.y, (canvas/2)-border);
            }
            */
    		
            // kolecko
            
            var dist = Math.sqrt(Math.pow(deltaX,2)+Math.pow(deltaY,+2));
            var maxDist = Math.sqrt(Math.pow(border,2)+Math.pow(border,+2));
            
            if (dist > maxDist){
            	var ratio = maxDist / dist;
            	
            	var newX = deltaX * ratio;
            	var newY = deltaY * ratio;
            	
            	currVertex.x += newX - deltaX;
            	currVertex.y += newY - deltaY;
            }
    		
            
            // force dampening
    		var forceX = Math.floor(this.forceField[i][0]/dampeningEffect);
    		var forceY = Math.floor(this.forceField[i][1]/dampeningEffect);
    		
    		// adding a random effect
    		/*
    		forceX += -3+Math.floor((Math.random()*6)+1);
    		forceY += -3+Math.floor((Math.random()*6)+1);
    		*/
    		
    		//$('#rightPanel').append(forceX+" | "+forceY+" - <BR>");
    		
    		
    		// moving a component
    		
    		var spaceLizard = 1;
    		
    		if (Math.abs(forceX) > spaceLizard || Math.abs(forceY) > spaceLizard){
    			
    				currVertex.x += forceX;
            		currVertex.y += forceY;	
    						
    		}
    		
    			
         
    		// translating the graph
    		
    		currVertex.$selector.attr('transform', 'translate('+currVertex.x+','+currVertex.y+')');
        
			$('#rectTop' + (currVertex.id)).attr('transform','translate(' + (currVertex.x+currVertex.size-25)						
					+ ',' + currVertex.y + ')');
			
			$('#rectBot' + (currVertex.id)).attr('transform','translate(' + (currVertex.x+currVertex.size-5)						
					+ ',' + (currVertex.y) + ')');
			
			// translating edges
			
			   var newX;
               var newY;
               var lollipop;
               if ( currVertex.edges != null)
               for(var k = 0; k< currVertex.edges.length; k++){
                   var edge = currVertex.edges[k];
                   var sizeOfRectFrom = edge.from.size;
                   var sizeOfRectTo = edge.to.size;
                   if(edge.from.id == currVertex.id){
                       newX = currVertex.edges[k].to.x + sizeOfRectTo/2;
                       newY = currVertex.edges[k].to.y + 13;
                       lollipop = getLollipopPosition(currVertex.x + sizeOfRectFrom/2, currVertex.y +13 , newX, newY);
                       
                       edge.$selector.children("line").attr('x1', currVertex.x + sizeOfRectFrom/2);
                       edge.$selector.children("line").attr('y1', currVertex.y + 13);
                       edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
                       
                   } else {
                       newX = currVertex.edges[k].from.x + sizeOfRectFrom/2;
                       newY = currVertex.edges[k].from.y + 13;
                       lollipop = getLollipopPosition(newX, newY, currVertex.x + sizeOfRectTo/2, currVertex.y + 13);
                       
                       edge.$selector.children("line").attr('x2', currVertex.x + sizeOfRectTo/2);
                       edge.$selector.children("line").attr('y2', currVertex.y + 13);
                       edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
                   }
               }
					
    	}  	
    	
    },
    
    /**
     * Force Directed Layout
     */
    forceDirectedLayout: function(canvas) {
    	var repulsiveStrength = this.restrength; // more is more
    	var attractiveStrength = this.atstrength; // more is less
    	var dampeningEffect = this.deffect;
    	var border = canvas/this.borderRatio;
    	
    	//$('#rightPanel').append("s<BR>");
    	   	
    	
    	var length = this.graph.vertices.length;
    	// initialize repulsive forces
    	  	
    	for (var i = 0; i < length; i++){    		   		
    		this.forceField[i][0] = 0;
    		this.forceField[i][1] = 0;
    	}  	
  	
    	// calculate repulsive force
    	for (var i = 0; i < length; i++){
    		
    		var currVertex = this.graph.vertices[i];    		
    		//var otherVertex = new Array();
    		
    		// other vertices
    		for (var j = 0; j < length; j++){
    			this.otherVertex[j] = this.graph.vertices[j];
    		}    		
    		this.otherVertex.splice(i, 1);
    		

    		// iterate over other vertices
    		for (var j = 0; j < this.otherVertex.length; j++){
    			// currVertex position
    			var currX = currVertex.x;
    			var currY = currVertex.y;
    			
    			// otherVertex position
    			var otherX = this.otherVertex[j].x;
    			var otherY = this.otherVertex[j].y;
    			
    			// calculate force
    			var x = currX - otherX;
    			var y = currY - otherY;
    			
    			var sum = Math.pow(x,2) + Math.pow(y,2);
    			var distance = Math.sqrt(sum);   			
    			
    			if (distance != 0){
    						
    				this.forceField[i][0] += Math.floor((x * (repulsiveStrength / distance)));
        			this.forceField[i][1] += Math.floor((y * (repulsiveStrength / distance)));
    			}   			
    		}
		
    		
    		//$('#rightPanel').append(forceField[i][0]+" | "+forceField[i][1]+" - rf<BR>");
    	}
    	
    	// calculate attractive forces
    	for (var i = 0; i < length; i++){
    		var currVertex = this.graph.vertices[i];
    		//$('#rightPanel').append(currVertex.id+"<BR>");
    		//$('#rightPanel').append(currVertex.edges.length+"<BR>");
    		for (var j = 0; j < currVertex.edges.length; j++){
    			
    			var otherVertex;    			
    			if (currVertex.edges[j].to == currVertex){
    				otherVertex = currVertex.edges[j].from;
    			}  			
    			else {
    				otherVertex = currVertex.edges[j].to;
    			}
    			// currVertex position
    			var currX = currVertex.x;
    			var currY = currVertex.y;
    			
    			// otherVertex position
    			var otherX = otherVertex.x;
    			var otherY = otherVertex.y;
    			
    			// calculate force
    			var x = currX - otherX;
                var y = currY - otherY;
                
                var sum = Math.pow(x, 2) + Math.pow(y, 2);                
                var distance = Math.sqrt(sum); 
                //$('#rightPanel').append(distance+"<BR>");
                this.forceField[i][0] += Math.round(-( (x * (distance / attractiveStrength)))); 
                this.forceField[i][1] += Math.round(-( (y * (distance / attractiveStrength))));
    			/*
                this.forceField[otherVertex.id-1][0] -= Math.round(-( (x * (distance / attractiveStrength)))); 
                this.forceField[otherVertex.id-1][1] -= Math.round(-( (y * (distance / attractiveStrength))));
               */
    		}
    		 
    		//$('#rightPanel').append(forceField[i][0]+" | "+forceField[i][1]+" - ff<BR>");
    	}
   	
    	// applying the force
    	for (var i = 0; i < length; i++){
    		var currVertex = this.graph.vertices[i];
    		
    		var deltaX = currVertex.x - (canvas/2);
    		var deltaY = currVertex.y - (canvas/2);
  		
    		// tohle drzi layout uprostred, chtelo by to vymyslet nejak lip, docela ho to kurvi
            /*
    		if (deltaX > 0) {
            	currVertex.x = Math.min(currVertex.x, (canvas/2)+border);
            } else {
            	currVertex.x = Math.max(currVertex.x, (canvas/2)-border);
            }
            if (deltaY > 0) {
            	currVertex.y = Math.min(currVertex.y, (canvas/2)+border);
            } else {
            	currVertex.y = Math.max(currVertex.y, (canvas/2)-border);
            }
            */
    		//kolecko
            var dist = Math.sqrt(Math.pow(deltaX,2)+Math.pow(deltaY,+2));
            var maxDist = Math.sqrt(Math.pow(border,2)+Math.pow(border,+2));
            
            if (dist > maxDist){
            	var ratio = maxDist / dist;
            	
            	var newX = deltaX * ratio;
            	var newY = deltaY * ratio;
            	
            	currVertex.x += newX - deltaX;
            	currVertex.y += newY - deltaY;
            }
            
            // force dampening
    		var forceX = Math.floor(this.forceField[i][0]/dampeningEffect);
    		var forceY = Math.floor(this.forceField[i][1]/dampeningEffect);
    		
    		// adding a random effect
    		/*
    		forceX += -3+Math.floor((Math.random()*6)+1);
    		forceY += -3+Math.floor((Math.random()*6)+1);
    		*/
    		
    		//$('#rightPanel').append(forceX+" | "+forceY+" - asaf<BR>");
    		
    		// moving a component
    		currVertex.x += forceX;
    		currVertex.y += forceY;		
    		

            
    	}  	
      },
    
    /**
     * Create svg group for image of inretfaces.
     * parametres: size - 
     *             vertexId - vertex id
     * Return string with part of svg.
     */
    drawInterface: function(size, vertexId){
        console.debug("ENTRY graphManager - drawInterface()");
        var imageInterface = '<g class="interface" data-vertexId="' + vertexId + '" transform="translate(8,6)">\
                                 <rect width="10" height="15" x="0" y="0"/>\
                                 <rect width="6" height="3" x="-3" y="3"/>\
                                 <rect width="6" height="3" x="-3" y="9"/>\
                              </g>';
        return imageInterface;
        console.debug("EXIT graphManager - drawInterface()");
    },
    
    /**
     * Create graph from data which were sended by server.
     */
    buildGraph: function(){
        console.debug("ENTRY graphManager - buildGraph()");
        var svgBuff = '<svg id="svg1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">\
                        <g id="graph" transform="scale(1)" >';
        var vertexMap= new Array();
        var vertexBuff = "";
        var position_loaded = false;
        
        if ( this.graph != null ) {
	        var odm = Math.sqrt(this.graph.vertices.length);
	        var canvas = ((this.graph.vertices.length*75)/ Math.round(odm)) + 1000;
	        this.canvasSize = canvas;
	        this.graph.vertices.sort(function(a, b) {
	            return a.id > b.id;
	        });
	        for(var i = 0; i < this.graph.vertices.length; i++){
	           
	            var vertex = this.graph.vertices[i];
	            vertexMap[vertex.symbolicName] = vertex;
	            vertex.edges = new Array();
	            vertex.gridMark = new GridMarks(); 
	            
	            
	            
	            //pokud je nastavena pozice x y u prvku - nastavit tuto pozici
	            if ( this.vertices_position != null && this.vertices_position.vertices_position != null) {
	            	
	                $.each(this.vertices_position.vertices_position, function(i, item) {
	                    
	                    //console.log();
	                    if ( "vertex" + vertex.id == item.id){
	                    	console.log(item.transform);
	                    	
	                        var parts  = /translate\(\s*([^\s,)]+)[ ,]([^\s,)]+)/.exec(item.transform);
	                        
	                    	posX = parts[1];
	                    	posY = parts[2];
	                    	vertex.x = parseFloat(posX);
	                    	vertex.y = parseFloat(posY);
	                    	
	                    	position_loaded = true;
	                    	return false;//break;
	                    }
	                });
	            
	            }
	            
	            // nahodna pozice
	            if ( position_loaded == false ) {
		            vertex.x = Math.floor(Math.random()*canvas);
		            vertex.y = Math.floor(Math.random()*canvas);
	            }           	            
	            
	            
	            
	        }	        	       
	       
	        // initialize edges
	        for(var j = 0; j < this.graph.edges.length; j++){
	            var edge = this.graph.edges[j];
	            edge.from = vertexMap[edge.from];
	            edge.to = vertexMap[edge.to];
	            edge.from.edges.push(edge);
	            edge.to.edges.push(edge);
	                      
	        }     	        	        	        
	        
	        // calling force layout
	        if ( position_loaded == false ) {
	        	var avgX = 0, avgY = 0;
	        	
		        for (var x = 0; x < this.graph.vertices.length; x++){		        	
		        	this.forceField[x] = new Array();		        	
		        }
	        
		        for (var x = 0; x < this.inumber; x++){
		        	this.forceDirectedLayout(canvas);
		        }
	        }
	        
	        // fill the vertexBuffer
	        for(var i = 0; i < this.graph.vertices.length; i++){
	        	var vertex = this.graph.vertices[i];
	        	
	        	var sizeOfRect = getSizeOfRectangle(vertex.name);
	            vertex.size = sizeOfRect;
	            
	            vertexBuff += '<g class="vertex colorNormal" id="vertex'+vertex.id+'" transform="translate('+vertex.x+','+vertex.y+')">\
				                <rect width="' + (sizeOfRect+20) + '" height="26" rx="4" ry="4"/>\
	                                   <text x="' + sizeOfRect/2 +'" y="13" style="text-anchor: middle; dominant-baseline: baseline;">' + vertex.name + '</text>' + this.drawInterface(sizeOfRect, vertex.id) + '</g>';
	            	
	            // pridani malych ctvercu vpravo
	            vertexBuff += '<g class="vertex colorNormal" id="rectTop'+vertex.id+'" transform="translate('+ (vertex.x+(vertex.size)-25) +','+vertex.y+')">\
	                <g id="lolGL'+vertex.id+'" class="whiteColor" transform="translate(17,44) rotate(90,0,0) scale(0.8)">\
		                <line x1="-25" y1="5" x2="-30" y2="5" stroke="black"/>\
		            	<path class="SamplePath" d="M-42,-5 C-27,-5 -27,15 -42,15" stroke="black" />\
	                </g>\
	                <text id="rectTopText'+ vertex.id+'" x="13" y="12" style="text-anchor: middle; dominant-baseline: baseline;"></text>\
                </g>';

				vertexBuff += '<g class="vertex colorNormal" id="rectBot'+vertex.id+'" transform="translate('+ (vertex.x+(vertex.size)-5) +','+(vertex.y)+')">\
				<g id="lolGP'+vertex.id+'" class="whiteColor" transform="translate(38, 45) rotate(90,0,0) scale(0.8)">\
				                        <line x1="-25" y1="31" x2="-30" y2="31" stroke="black"/>\
				                        <circle cx="-42" cy="31" r="11" stroke="black" /> \
					                </g>\
					                <text id="rectBotText'+ vertex.id+'" x="13" y="12" style="text-anchor: middle; dominant-baseline: baseline;">  </text>\
							   </g>';
	        }
	        
	        // fill the edge buffer
	        for(var j = 0; j < this.graph.edges.length; j++){
	        	var edge = this.graph.edges[j];
	        	
	        	var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
	            var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
	            //transform="translate(' + (sizeOfRect2/2) + ', 13)"
	            var lollipop = getLollipopPosition(edge.from.x + sizeOfRectFrom/2, edge.from.y + 13, edge.to.x + sizeOfRectTo/2, edge.to.y + 13);
	            svgBuff += '<g class="edge" id="e' + edge.id + '">\
	                            <line x1="'+ (edge.from.x + sizeOfRectFrom/2) + '" y1="' + (edge.from.y + 13) + '" x2="'+ (edge.to.x + sizeOfRectTo/2) + '" y2="' + (edge.to.y + 13) + '"/>\
	                            <g class="lollipop" data-edgeId="' + edge.id + '" transform="rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')">\
	                               <path class="SamplePath" d="M0,-12 C16,-12 16,12 0,12"/>\
	                               <circle cx="0" cy="0" r="8" />\
	                            </g>\
	                        </g>';
	        }

	        
	        svgBuff += vertexBuff+'</g></svg>';
	        $("#viewport").append(svgBuff);
	        
	        this.setSizeOfSvg();
	        this.centerGraphInViewport(1);
	        configurationEdgeTooltip(".lollipop");
	        configurationVertexTooltip(".interface");
	        
	        var unCount = 0;	         
	        
	        for(var i = 0; i < this.graph.vertices.length; i++){
	        	var countFrom = 0;
		        var countTo = 0;
		        
		        var vertex = this.graph.vertices[i];
		        
		        // naplneni seznamu nepropojenych komponent
		        if (vertex.edges.length == 0){
		        	this.unconList[unCount] = vertex.id;
		        	$('#vertex'+vertex.id).hide();
		        	$('#rectTop'+vertex.id).hide();
		            $('#rectBot'+vertex.id).hide();
		        	unCount++;
		        }
		        
		        for(var j = 0; j < vertex.edges.length;j++){
		            if(vertex.id == vertex.edges[j].from.id){
		                countFrom++;
		            }
		        }
		        
		        countTo = vertex.edges.length - countFrom;
		       
		        document.getElementById("rectTopText" + vertex.id).textContent = countTo;
		        document.getElementById("rectBotText" + vertex.id).textContent = countFrom;		        
	        }
	        
	        //$('#rightPanel').append(unCount);
	        // vytvoreni objektu nepropojenych komp
	        
	        var unConSvg = '<svg class="right_panel_svg_group_component" xmlns="http://www.w3.org/2000/svg" version="1.1" width="202" height="60">\
						         <g transform="translate(20,10)" class="colorNormal vertex" id="unConnected">\
						            <g class="colorUnconnected" id="uncon">\
						                <rect ry="4" rx="4" height="40" width="190" y="0" x="-10" />\
						                <text id="unconText" y="20" x="-5" text-anchor: middle dominant-baseline="central">' + unCount + " unconnected components"'</text>\
						            </g>\
							    </g>\
							</svg>';
	        	        
	        $('#rightPanel').append('<div class="component" id="unconComps">');
            $('#unconComps').append(unConSvg);           
            
            
            $('#unconComps').append('<div id ="uncb" class="controlButton">');
            $('#unconComps').append('<ul class="colorUnconnected" id="unconCmpList"> </ul>');
            
           
            
            for(var i = 0; i < this.unconList.length; i++){
            	 var ind = this.unconList[i];           	
	        	 var name = this.graph.vertices[ind-1].name;
	        	 
            	 //$('#unconCmpList').append(this.graph.vertices[ind].name+'<BR>');
	        	 $('#unconCmpList').append('<li id="liuc' + ind + '"><p data-vertexId="' + ind + '" data-title="' + name + '">' + name + '</p><img class="" id="liuc_del_' + ind  + '" alt="delete" src="images/button_cancel.png"/></li>');
	        	 	        	 
	        	 
	        }
            
            
        
            // dbback
            $('#uncb').append('<div class="button buttonClassic" width="12" id="dbback">\n\
            <img src="" alt="->" title="Include unconnected components"/></div>');  
           
            // include all button
            $('#uncb').append('<div class="button buttonClassic" id="dbutt">\n\
            <img src="" alt="<-" title="Include unconnected components"/></div>');  
            
            // comp list button
            $('#uncb').append('<div class="button buttonClassic" id="cmpList">\n\
            <img src="" alt="list" title="Include unconnected components"/></div>'); 
            
                     
            $('#rightPanel').append('</div></div>');
            
            
            
            $('#unconCmpList').css('width', '250');
            $('#unconCmpList').hide();         
            
        }else{
        	alert('Error loading graph.'); 
        	window.location.href = HOME_URL;
        }    
	    disableLoader(); //disabled loader	        
        console.debug("EXIT graphManager - buildGraph()");
    },
    
    /**
     * Set size of svg according bounding box of svg.
     */
    setSizeOfSvg: function(){
        console.debug("ENTRY graphManager - setSizeOfSvg()");
        var svg = $("#svg1");
        var bbox = svg.get(0).getBBox();
        var viewportWidth = stringToInt(cutTwoLastCharacters($("#viewport").css("width")));
        var viewportHeight = stringToInt(cutTwoLastCharacters($("#viewport").css("height")));
        
        if(bbox.width < viewportWidth){
            svg.css("width", viewportWidth*1.5);
        } else {
            svg.css("width", bbox.width*1.5);
        }
        
        if(bbox.height < viewportHeight){
            svg.css("height", viewportHeight*1.5);
        } else {
            svg.css("height", bbox.height*1.5);
        }
        console.debug("EXIT graphManager - setSizeOfSvg()");
    },
    
    /**
     * Center graph in viewport.
     * parameters: currentZoom - current zoom
     */
    centerGraphInViewport: function(currentZoom){
        console.debug("ENTRY graphManager - centerGraphInViewport()");
        var svg = $("#svg1");
        var graph = $("#graph");
        var bboxSvg = svg.get(0).getBBox();
        var svgWidth = stringToInt(cutTwoLastCharacters(svg.css("width")));
        var svgHeight = stringToInt(cutTwoLastCharacters(svg.css("height")));
        
        var centerSvgX = svgWidth/2.0;
        var centerSvgY = svgHeight/2.0;
        
        var newPositionGraphX = centerSvgX - bboxSvg.width/2.0 - bboxSvg.x;
        var newPositionGraphY = centerSvgY - bboxSvg.height/2.0 - bboxSvg.y;
        var viewport = $("#viewport");
        
        viewport.scrollLeft(-(svgWidth-(viewport.width()-17))/2.0);
        viewport.scrollTop((svgHeight-(viewport.height()-17))/2.0);
        graph.attr("transform", "translate(" + newPositionGraphX/currentZoom + "," + newPositionGraphY/currentZoom + ")");
        
        console.debug("EXIT graphManager - centerGraphInViewport()");
        return "translate(" + newPositionGraphX/currentZoom + "," + newPositionGraphY/currentZoom + ")";
    }
};