/**
 * The class represents group.
 */
var Group = new Class({
    groupItems: null,
    groupSympol: null,
    countRequired: 0,
    countProvided: 0,
    idGroup: null,
    groupItemsLength: 0,
    providedPackage: null,
    requiredPackage: null,
    decompose: false,
    x:0,
    y:0,
    
    /**
     * Constructor. Initial setting.
     */
    initialize: function(groupSymbol, idGroup){
        this.groupItems = new Object();
        this.groupSymbol = groupSymbol;
        this.idGroup = idGroup;
        this.providedPackage = new Hash();
        this.requiredPackage = new Hash();
    },
    
    /**
     * Adds provided packages.
     * Parameters: exportPackages - package which be added.
     */
    addProvidedPackage: function(exportPackages){
        var frequency = 1;
        for (var i = 0; i < exportPackages.length; i++){
            if(this.providedPackage.contains(exportPackages[i])){
                frequency = this.providedPackage.getItem(exportPackages[i]) + 1;
                
            } 
            this.providedPackage.add(exportPackages[i], frequency);
            frequency = 1;
        }
    },
    
    /**
     * Adds required packages.
     * Parameters: importPackages - package which be added.
     */
    addRequiredPackage: function(importPackages){
        var frequency = 1;
        for (var i = 0; i < importPackages.length; i++){
            if(this.requiredPackage.contains(importPackages[i])){
                frequency = this.requiredPackage.getItem(importPackages[i]) + 1;
                  
                 
            }
            this.requiredPackage.add(importPackages[i], frequency);
            frequency = 1;
        }
    },
    
    /**
     * Delete provided packages.
     * Parameters: exportPackages - package which be deleted.
     */
    deleteProvidedPackage: function(exportPackages){
        var frequency = -1;
        for (var i = 0; i < exportPackages.length; i++){
            if(this.providedPackage.contains(exportPackages[i])){
                frequency = this.providedPackage.getItem(exportPackages[i]) - 1;
                if(frequency == 0){
                    this.providedPackage.remove(exportPackages[i]);
                } else {
                    this.providedPackage.add(exportPackages[i], frequency);
                }
                frequency = -1;
            }
        }
    },
    
    /**
     * Delete required packages.
     * Parameters: importPackages - package which be deleted.
     */
    deleteRequiredPackage: function(importPackages){
        var frequency = -1;
        for (var i = 0; i < importPackages.length; i++){
            if(this.requiredPackage.contains(importPackages[i])){
                frequency = this.requiredPackage.getItem(importPackages[i]) - 1;
                if(frequency == 0){
                    this.requiredPackage.remove(importPackages[i]);
                } else {
                    this.requiredPackage.add(importPackages[i], frequency);
                }
                frequency = -1;
            }
        }
    },
    
    /**
     * Adds new item to group.
     * Parameters: itemId - id of saved item (vertex)
     *             item - vertex which will be added
     */
    addToGroup: function(itemId, item){
        this.groupItemsLength++;
        this.groupItems[itemId] = item;
    },
    
    /**
     * Removes item from group.
     * Parameters: itemId - id of deleted item (vertex)
     */
    removeFromGroup: function(itemId){
        delete this.groupItems[itemId];
        this.groupItemsLength--;
    },
    
    /**
     * Gets count of item in group.
     */
    getGroupItemsLength: function(){
        return this.groupItemsLength;
    },
    
    toMyString: function(){
        console.info("ENTRY toMyString");
        for (var key in this.groupItems){
            if(this.groupItems.hasOwnProperty(key)){
                console.info(">>" + this.groupItems[key].name);
              
            }
        }
        console.info("EXIT toMyString");
    }
    
});
