/**
 * GroupManager caters to group.
 */
var GroupManager = new Class({
    groupList: null,
    length: 0,
    initialize: function(){
        this.groupList = new Object();
    },
   
    /**
    * Adds group to list of groups.
    * Parameters: idGroup - id of group
    *             group - group which will be added
    */
    addGroupToList: function(idGroup, group){
        this.groupList[idGroup] = group;
        this.length++;
    },
   
    /**
    * Removes group from list of groups.
    * Parameters: idGroup - id of group
    */
    removeGroupFromList: function(idGroup){
        delete this.groupList[idGroup];
        this.length--;
    },
    
    /**
     * Finds out if the group with given id is in list of existing group.
     * Parameters: idGroup - id of group
     * Returns true if the grou with given id is in list, in otherwise returns false.
     */
    existGroup: function(idGroup){
        console.info("->" + this.groupList[idGroup]);
        if(this.groupList[idGroup] == null || this.groupList[idGroup] == "undefined"){
            return false;
        }
        return true;
    },
    
    /**
     * Gets group with given id.
     */
    getGroup: function(idGroup){
        return this.groupList[idGroup];
    },
    
    /**
     * Get count of group in group list.
     */
    getLength: function(){
        return this.length;
    }
});