/**
 * The class represented hash table.
 */
var Hash = new Class({
    length: 0,
    array: null,
    
    /**
     * Constructor.
     */
    initialize: function(){
        this.length = 0;
        this.array = new Object();
    },
    
    /**
     * Add item.
     * Parameters: key - key of added item
     *             val - value of added item
     */
    add: function(key, val){
        if(!this.contains(key)){
            this.length++;
        }
        this.array[key]=val;
    }, 
    
    /**
     * Gets item with given key.
     * Parameters: key - key of searched item
     */
    getItem: function(key){
        return this.array[key];
    },
    
    /**
     * Remove item with given key.
     * Parameters: key - key of item
     */
    remove: function(key){
        var val = this.array[key];
        delete this.array[key];
        this.length--;
        return val;
    },
    
    /**
     * Gets count of item in "hash table".
     */
    getLength: function(){
        return this.length;
    },
    
    toString: function(){
        for (var key in this.array){
            if(this.array.hasOwnProperty(key)){
                console.info("---" + this.array[key]);
            }
        }
    }, 
    
    /**
     * Tests if the item with given key is in "hash table".
     * Returns true if the item with given key is in "hash table", in otherwise returns false.
     */
    contains: function(key){
        if(this.array[key] == "undefined" || this.array[key] == null){
            return false;
        }
        return true;
    }
});
    