/**
 * Ensures drag and drop of elements in graph.
 */
var ViewportManager = {
	CONST_EXPAND_ZONE_SIZE : 20,
	leftMouseButtonDown : false,
	$currentTarget : null,
	current : null,
	$svg : null,
	offsetX : 0,
	offsetY : 0,
	vertices : null,
	highlightEdge : null,
	highlightVertex : null,
	highlightVertexProv: null,
	highlightVertexReq: null,
	zoom : new Zoom(),
	clickedPosX : 0,
	clickedPosY : 0,
	oscarMike : false,
	lastColor : null,
	lastOpacity : null,
    
    /**
     * Highlights vertex from graph, which is chosen.
     */
	highlight : function(vertex) {
		this.oscarMike = false;

		this.lastColor = vertex.$selector.attr('class');
		this.lastOpacity = vertex.$selector.css('opacity');

        vertex.$selector.removeAttr("style");
        vertex.$selector.attr('class', 'vertex colorHighlight');
    },
    
    /**
	 *  Highlight required (clicked in graph)
	 */
    highlightReqGraph: function(e){   	
    	var obj = e.target.parentElement;
    	
    	if (obj.id == ""){
    		obj = obj.parentElement;
    	}
    	
    	var id = obj.id;
    	var vertexId = parseInt(id.substr(7)) - 1;
    	
    	var vertex = GraphManager.graph.vertices[vertexId];
    	
    	// Dishighlights one edge
		this.deleteBorder();
		this.highlightEdge = null;

		this.disableHighlightEdges();
    	
		if (vertex != this.highlightVertexReq) {	
			this.dimAll();
			
			this.highlightVertexReq = vertex;
			this.highlightVertex = vertex;
			
			$('#rectTop'+vertex.id).css('stroke','red');		
			$('#lolGL'+vertex.id).attr('class', 'detail colorHighReqR');
			
			vertex.$selector.attr('class', 'vertex colorNormal');
			vertex.$selector.css('stroke-width', '3');
			vertex.$selector.css('stroke','red');
			vertex.$selector.css('opacity','1');
			$('#rectTop'+vertex.id).css('opacity', '1' );
			$('#rectBot'+vertex.id).css('opacity', '1' );
			
			// highlight required
			for ( var i = 0; i < vertex.edges.length; i++) {
				var cedge = vertex.edges[i];
	
				if (cedge.to == vertex) {
					cedge.from.$selector.attr('class', 'vertex colorHighReqR');
					cedge.from.$selector.css('opacity', '1');
					$('#rectTop'+cedge.from.id).css('opacity', '1' );
					$('#rectBot'+cedge.from.id).css('opacity', '1' );
					
					cedge.$selector.css('stroke', 'red');					
					cedge.$selector.css('opacity', '1');
				} 
			}
	    	
			// Highlights connected vertices in the SeCo panel
			for ( var i = 0; i < vertex.edges.length; i++) {
				var edgeIdFrom = vertex.edges[i].from.id;
							
				$('#detailVertex' + (edgeIdFrom)).attr('class',
						'detail colorHighReqR');
				$('#li'+edgeIdFrom).attr('style', "BACKGROUND-COLOR: red");
			}
		}
		else{
			this.highlightVertexReq = null;
			this.highlightVertex = null;
		}
				
		this.highlightVertexProv = null;
		
    	//$('#rightPanel').append(id+'<BR>');
    },
	
    /**
	 *  Highlight required (clicked in SeCo)
	 */
    highlightReqGraphSeCo: function(e){   	
    	var obj = e.target.parentElement;
 		
    	var name = obj.id;
    	   	
    	var id = parseInt(name.substr(8));
    	
    	  	
    	
    	var vertex = GraphManager.graph.vertices[id-1];
    	
    	// Dishighlights one edge
		this.deleteBorder();
		this.highlightEdge = null;

		this.disableHighlightEdges();
    	
		if (vertex != this.highlightVertexReq) {	
			this.dimAll();
			
			this.highlightVertexReq = vertex;
			this.highlightVertex = vertex;
			
			$('#rectTop'+vertex.id).css('stroke','red');		
			$('#lolGL'+vertex.id).attr('class', 'detail colorHighReqR');
			$('#required'+vertex.id).attr('class', 'colorHighReqR');
			
			vertex.$selector.attr('class', 'vertex colorNormal');
			vertex.$selector.css('stroke-width', '3');
			vertex.$selector.css('stroke','red');
			vertex.$selector.css('opacity','1');
			$('#rectTop'+vertex.id).css('opacity', '1' );
			$('#rectBot'+vertex.id).css('opacity', '1' );
			
			// highlight required
			for ( var i = 0; i < vertex.edges.length; i++) {
				var cedge = vertex.edges[i];
	
				if (cedge.to == vertex) {
					cedge.from.$selector.attr('class', 'vertex colorHighReqR');
					cedge.from.$selector.css('opacity', '1');
					$('#rectTop'+cedge.from.id).css('opacity', '1' );
					$('#rectBot'+cedge.from.id).css('opacity', '1' );
					
					cedge.$selector.css('stroke', 'red');					
					cedge.$selector.css('opacity', '1');
				} 
			}
	    	
			// Highlights connected vertices in the SeCo panel
			for ( var i = 0; i < vertex.edges.length; i++) {
				var edgeIdFrom = vertex.edges[i].from.id;
							
				$('#detailVertex' + (edgeIdFrom)).attr('class',
						'detail colorHighReqR');
				$('#li'+edgeIdFrom).attr('style', "BACKGROUND-COLOR: red");
			}
			$('#detailVertex'+id).attr('class', 'detail colorNormal');
		}
		else{
			this.highlightVertexReq = null;
			this.highlightVertex = null;
		}
				
		this.highlightVertexProv = null;
		
    	//$('#rightPanel').append(id+'<BR>');
    },
    
	/**
	 *  Highlight provided (clicked in graph)
	 */
    highlightProvGraph: function(e){
    	var obj = e.target.parentElement;
    	
    	if (obj.id == ""){
    		obj = obj.parentElement;
    	}
    	
    	var id = obj.id;
    	var vertexId = parseInt(id.substr(7)) - 1;
    	
    	var vertex = GraphManager.graph.vertices[vertexId];
    	
    	// Dishighlights one edge
		this.deleteBorder();
		this.highlightEdge = null;

		this.disableHighlightEdges();
    	
		if (vertex != this.highlightVertexProv){	
			this.dimAll();
			this.highlightVertexProv = vertex;
			this.highlightVertex = vertex;
			
			$('#rectBot'+vertex.id).css('stroke','red');		
			$('#lolGP'+vertex.id).attr('class', 'detail colorHighProvB');
			
			vertex.$selector.attr('class', 'vertex colorNormal');
			vertex.$selector.css('stroke-width', '3');
			vertex.$selector.css('stroke','red');		
			vertex.$selector.css('opacity','1');		
			$('#rectTop'+vertex.id).css('opacity', '1' );
			$('#rectBot'+vertex.id).css('opacity', '1' );
			// highlight provided			
			
			for ( var i = 0; i < vertex.edges.length; i++) {
				var cedge = vertex.edges[i];
	
				if (cedge.from == vertex) {
					cedge.to.$selector.attr('class', 'vertex colorHighProvB');
					cedge.to.$selector.css('opacity', '1');
					$('#rectTop'+cedge.to.id).css('opacity', '1' );
					$('#rectBot'+cedge.to.id).css('opacity', '1' );
					
					cedge.$selector.css('stroke', 'blue');
					cedge.$selector.css('opacity', '1');
				} 
			}
	    	
			// Highlights connected vertices (provided) in the SeCo panel
			for ( var i = 0; i < vertex.edges.length; i++) {			
				var edgeIdTo = vertex.edges[i].to.id;
				
				$('#detailVertex' + (edgeIdTo)).attr('class',
						'detail colorHighProvB');	
				$('#li'+edgeIdTo).attr('style', "BACKGROUND-COLOR: #5896FF");
				
				
			}
		}
		else{
			this.highlightVertexProv = null;
			this.highlightVertex = null;
		}
				
		this.highlightVertexReq = null;
    	
    },
    
    /**
	 *  Highlight provided (clicked in SeCo)
	 */
    highlightProvGraphSeCo: function(e){
    	
    	var obj = e.target.parentElement;
 		
    	var name = obj.id;
    	   	
    	var id = parseInt(name.substr(8));
    	
    	var vertex = GraphManager.graph.vertices[id-1];
    	
    	// Dishighlights one edge
		this.deleteBorder();
		this.highlightEdge = null;

		this.disableHighlightEdges();
    	
    	
		
		if (vertex != this.highlightVertexProv){	
			this.dimAll();
			this.highlightVertexProv = vertex;
			this.highlightVertex = vertex;
			
			$('#rectBot'+vertex.id).css('stroke','red');		
			$('#lolGP'+vertex.id).attr('class', 'detail colorHighProvB');
			$('#provided'+vertex.id).attr('class', 'colorHighProvB');
			
			vertex.$selector.attr('class', 'vertex colorNormal');
			vertex.$selector.css('stroke-width', '3');
			vertex.$selector.css('stroke','red');		
			vertex.$selector.css('opacity','1');	
			$('#rectTop'+vertex.id).css('opacity', '1' );
			$('#rectBot'+vertex.id).css('opacity', '1' );
			// highlight provided			
			
			for ( var i = 0; i < vertex.edges.length; i++) {
				var cedge = vertex.edges[i];
	
				if (cedge.from == vertex) {
					cedge.to.$selector.attr('class', 'vertex colorHighProvB');
					cedge.to.$selector.css('opacity', '1');
					$('#rectTop'+cedge.to.id).css('opacity', '1' );
					$('#rectBot'+cedge.to.id).css('opacity', '1' );
					
					cedge.$selector.css('stroke', 'blue');
					cedge.$selector.css('opacity', '1');
				} 
			}
	    	
			// Highlights connected vertices (provided) in the SeCo panel
			for ( var i = 0; i < vertex.edges.length; i++) {			
				var edgeIdTo = vertex.edges[i].to.id;
				
				$('#detailVertex' + (edgeIdTo)).attr('class',
						'detail colorHighProvB');	
				$('#li'+edgeIdTo).attr('style', "BACKGROUND-COLOR: #5896FF");
				
				
			}
			$('#detailVertex'+id).attr('class', 'detail colorNormal');
		}
		else{
			this.highlightVertexProv = null;
			this.highlightVertex = null;
		}
				
		this.highlightVertexReq = null;
    	
    },
    
	/**
	 * Highlights vertices and edges connected to selected vertex
	 */
	highlightClckdVertex : function(vertex) {
		// Dishighlights one edge
		this.deleteBorder();
		this.highlightEdge = null;

		this.disableHighlightEdges();
		
		
		// Highlights the selected vertex and edges connected to it
		if (this.highlightVertex != vertex || vertex == this.highlightVertexProv || vertex == this.highlightVertexReq) {
			this.dimAll();
			
			this.highlightVertex = vertex;
			this.highlightVertexProv = null;
			this.highlightVertexReq = null;
			
			vertex.$selector.css('stroke', 'red');
			vertex.$selector.css('stroke-width', '3');
			vertex.$selector.css('opacity', '1');
			$('#rectTop'+vertex.id).css('opacity', '1' );
			$('#rectBot'+vertex.id).css('opacity', '1' );
			
			/*
			$('#rectBot'+vertex.id).css('stroke','red');
			$('#rectTop'+vertex.id).css('stroke','red');
*/
			$('#lolGL'+vertex.id).attr('class', 'detail colorHighReqR');
			$('#lolGP'+vertex.id).attr('class', 'detail colorHighProvB');
			
			// Highlights connected vertices and edges
			for ( var i = 0; i < vertex.edges.length; i++) {

				var cedge = vertex.edges[i];
				var idTo = cedge.to.id;
				var idFrom = cedge.from.id;				
				
				
				
				var groupList = OffScreenKiv.groupManager.groupList;	
				for (var key in groupList) {  
					//$('#rightPanel').append(key+'<BR>');
					
					var currGroup = groupList[key];
				
					var verList = currGroup.groupItems;
					
					for (var ver in verList) {				
						if (ver == idTo){
							//$('#rightPanel').append('aa<BR>');							
							$('#li'+ver).attr('style', "BACKGROUND-COLOR: #5896FF");
						}
						else if (ver == idFrom){
							$('#li'+ver).attr('style', "BACKGROUND-COLOR: red");
						}
					}
					
					//$('#rightPanel').append('<BR>');	
					
					//$('#gv_'+ key).attr('stroke', 'red');
					
							
				}  
				
				//var sessions = $('[id^="gv_"]');
			
				if (cedge.to == vertex) {
					cedge.from.$selector.attr('class', 'vertex colorHighReqR');
					cedge.from.$selector.css('opacity', '1');
					$('#rectTop'+cedge.from.id).css('opacity', '1' );
					$('#rectBot'+cedge.from.id).css('opacity', '1' );
					
					cedge.$selector.css('stroke', 'red');
					cedge.$selector.css('opacity', '1');
					
				} else {
					cedge.$selector.css('stroke', 'blue');
					cedge.$selector.css('opacity', '1');
					$('#rectTop'+cedge.to.id).css('opacity', '1' );
					$('#rectBot'+cedge.to.id).css('opacity', '1' );
					
					cedge.to.$selector.attr('class', 'vertex colorHighProvB');
					cedge.to.$selector.css('opacity', '1');
				}

				
			}

			// Highlights connected vertices in the SeCo panel
			for ( var i = 0; i < vertex.edges.length; i++) {
				var edgeIdFrom = vertex.edges[i].from.id;
				var edgeIdTo = vertex.edges[i].to.id;
				// $('#rightPanel').append(edgeId+'<BR>');
				$('#detailVertex' + (edgeIdFrom)).attr('class',
						'detail colorHighReqR');
				$('#detailVertex' + (edgeIdTo)).attr('class',
						'detail colorHighProvB');
				// $('#detailVertex' + (idd+1)).attr('class', 'detail
				// colorNormal');
			}

			
			

			
		} else {
			this.highlightVertex = null;
		}
	},

	/**
	 * Highlights vertices and edges connected to vertex selected in SeCo panel
	 */
	highlightClckdVertexSeCo : function(e) {
		// Dishighlights one edge
	
		this.deleteBorder();
		this.highlightEdge = null;

		this.disableHighlightEdges();
		
		var name = e.target.parentElement.id;
		var id = parseInt(name.substr(12));

		var vertex = GraphManager.graph.vertices[id-1];	

		// Highlights the selected vertex and edges connected to it
		if (this.highlightVertex != vertex || vertex == this.highlightVertexProv || vertex == this.highlightVertexReq) {
			this.dimAll();
			
			this.highlightVertex = vertex;
			this.highlightVertexProv = null;
			this.highlightVertexReq = null;
			
			vertex.$selector.css('stroke', 'red');
			vertex.$selector.css('stroke-width', '3');
			vertex.$selector.css('opacity', '1');
			$('#rectTop'+vertex.id).css('opacity', '1' );
			$('#rectBot'+vertex.id).css('opacity', '1' );
					
			$('#lolGL'+vertex.id).attr('class', 'detail colorHighReqR');
			$('#lolGP'+vertex.id).attr('class', 'detail colorHighProvB');
			$('#required'+vertex.id).attr('class', 'colorHighReqR');
			$('#provided'+vertex.id).attr('class', 'colorHighProvB');
			
			
			// Highlights connected vertices and edges
			for ( var i = 0; i < vertex.edges.length; i++) {

				var cedge = vertex.edges[i];
				var idTo = cedge.to.id;
				var idFrom = cedge.from.id;				
				
				
				
				var groupList = OffScreenKiv.groupManager.groupList;	
				for (var key in groupList) {  
					//$('#rightPanel').append(key+'<BR>');
					
					var currGroup = groupList[key];
				
					var verList = currGroup.groupItems;
					
					for (var ver in verList) {				
						if (ver == idTo){
							//$('#rightPanel').append('aa<BR>');							
							$('#li'+ver).attr('style', "BACKGROUND-COLOR: #5896FF");
						}
						else if (ver == idFrom){
							$('#li'+ver).attr('style', "BACKGROUND-COLOR: red");
						}
					}
					
					//$('#rightPanel').append('<BR>');	
					
					//$('#gv_'+ key).attr('stroke', 'red');
					
							
				}  
				
				//var sessions = $('[id^="gv_"]');
			
				if (cedge.to == vertex) {
					cedge.from.$selector.attr('class', 'vertex colorHighReqR');
					cedge.from.$selector.css('opacity', '1');
					$('#rectTop'+cedge.from.id).css('opacity', '1' );
					$('#rectBot'+cedge.from.id).css('opacity', '1' );
					
					cedge.$selector.css('stroke', 'red');
					cedge.$selector.css('opacity', '1');
					
				} else {
					cedge.$selector.css('stroke', 'blue');
					cedge.$selector.css('opacity', '1');
					$('#rectTop'+cedge.to.id).css('opacity', '1' );
					$('#rectBot'+cedge.to.id).css('opacity', '1' );
					
					cedge.to.$selector.attr('class', 'vertex colorHighProvB');
					cedge.to.$selector.css('opacity', '1');
				}

				
			}

			// Highlights connected vertices in the SeCo panel
			for ( var i = 0; i < vertex.edges.length; i++) {
				var edgeIdFrom = vertex.edges[i].from.id;
				var edgeIdTo = vertex.edges[i].to.id;
				// $('#rightPanel').append(edgeId+'<BR>');
				$('#detailVertex' + (edgeIdFrom)).attr('class',
						'detail colorHighReqR');
				$('#detailVertex' + (edgeIdTo)).attr('class',
						'detail colorHighProvB');
				// $('#detailVertex' + (idd+1)).attr('class', 'detail
				// colorNormal');
			}
			$('#detailVertex'+id).attr('class', 'detail colorNormal');
		} else {
			this.highlightVertex = null;
		}
		
	},
	
	// Dims the vertices
	dimAll: function(){
		for ( var i = 0; i < GraphManager.graph.vertices.length; i++){
			var vertex = GraphManager.graph.vertices[i];
			
			$('#vertex'+vertex.id).css('opacity', '0.5' );
			$('#rectTop'+vertex.id).css('opacity', '0.5' );
			$('#rectBot'+vertex.id).css('opacity', '0.5' );
		}
		
		for ( var i = 0; i < GraphManager.graph.edges.length; i++){
			var edge = GraphManager.graph.edges[i];
			
			edge.$selector.css('opacity', '0.5');
		}
	},
	
	/**
	 * Disables highlighting of edges, connected to the last selected vertex
	 */
	disableHighlightEdges : function() {
		if (this.highlightVertex != null) {
			var idSelected = this.highlightVertex.id;
			
			this.highlightVertex.$selector.css('stroke', '');
			this.highlightVertex.$selector.css('stroke-width', '1');
			$('#rectTop'+idSelected).css('stroke', '');
			$('#rectBot'+idSelected).css('stroke', '');
			
			$('#lolGL'+idSelected).attr('class', 'whiteColor');
			$('#lolGP'+idSelected).attr('class', 'whiteColor');
			
			$('#provided'+idSelected).attr('class', 'whiteColor');
			$('#required'+idSelected).attr('class', 'whiteColor');
			
			for ( var i = 0; i < this.highlightVertex.edges.length; i++) {

				var cedge = this.highlightVertex.edges[i];

				cedge.to.$selector.attr('class', 'vertex colorNormal');
				cedge.from.$selector.attr('class', 'vertex colorNormal');
				cedge.$selector.css('stroke', '');
			}
			
			for ( var i = 0; i < GraphManager.graph.vertices.length; i++){
				var vertex = GraphManager.graph.vertices[i];
				
				$('#vertex'+vertex.id).attr('class', 'vertex colorNormal' );
				$('#vertex'+vertex.id).css('opacity', '1' );
				$('#rectTop'+vertex.id).css('opacity', '1' );
				$('#rectBot'+vertex.id).css('opacity', '1' );
				
			}

			for ( var i = 0; i < GraphManager.graph.edges.length; i++){
				var edge = GraphManager.graph.edges[i];
				
				edge.$selector.css('opacity', '1');
			} 
			
			// Disables highlight in seco

			for ( var i = 0; i < this.highlightVertex.edges.length; i++) {
				var edgeIdFrom = this.highlightVertex.edges[i].from.id;
				var edgeIdTo = this.highlightVertex.edges[i].to.id;
				// $('#rightPanel').append(edgeId+'<BR>');
				$('#detailVertex' + (edgeIdFrom)).attr('class',
						'detail colorNormal');
				$('#detailVertex' + (edgeIdTo)).attr('class',
						'detail colorNormal');
				// $('#detailVertex' + (idd+1)).attr('class', 'detail
				// colorNormal');
			}						
			
			// Disables highlight of groups in SeCo
			var groupList = OffScreenKiv.groupManager.groupList;	
			for (var key in groupList) {  
				//$('#rightPanel').append(key+'<BR>');
				
				var currGroup = groupList[key];
			
				var verList = currGroup.groupItems;
				
				for (var ver in verList) {
						$('#li'+ver).attr('style', "BACKGROUND-COLOR: white");				
						$('#li'+ver).attr('style', "BACKGROUND-COLOR: white");
					
				}
							
			}  

		}
	},

	/**
     * Cancels highlighting of vertex after finish move.
     */
	disableHighlight : function(vertex) {

        vertex.$selector.attr('class', 'vertex colorNormal');
		if (this.oscarMike == true) {
			vertex.$selector.attr('class', this.lastColor);
			vertex.$selector.css('opacity', this.lastOpacity);
		}
		if (vertex == this.highlightVertex){
			vertex.$selector.css('stroke', 'red');
			vertex.$selector.css('stroke-width', '3');
		}

	},

	highlightGroupVertices : function(group) {
       // vertex.$selector.removeAttr("style");
     //   $(group).attr('class','group_vertices colorHighlight');
    },
    /**
     * Registretes event after mouseUp and mouseLeave, set current position of 
     * mouse cursor after click to mouse button.
     */
	vertexMousedownHandler : function(e) {
        console.debug("ENTRY vertexMousedownHandler");
        
        var currentVertex = e.target.parentElement;
       
		if ($.inArray('group_vertices', currentVertex.classList) > -1) {
        	this.current = currentVertex.id;
        } else {
        	
			if (currentVertex.id == '') {
	            currentVertex = currentVertex.parentElement;
	        }
	        
			id = getIndexFromId(currentVertex.id, 6) - 1;
	        this.current = GraphManager.graph.vertices[id];
			this.$currentTarget = this.current.$selector;
	        this.$currentTarget.css('cursor', 'pointer');
        } 
	        
		this.offsetX = e.pageX;
		this.offsetY = e.pageY;
       
		if (e.which == 1) {
           
            this.clickedPosX = e.pageX;
            this.clickedPosY = e.pageY;
            this.leftMouseButtonDown = true;
            this.current.$selector.mouseup(this.viewportEndDraggingHandler);
            this.$svg.mouseleave(this.viewportEndDraggingHandler);
            this.$svg.mouseup(this.viewportEndDraggingHandler);
            this.highlight(this.current);
        }
        console.debug("EXIT vertexMousedownHandler");
    },
    
    /**
     * Registrates event after mouseUp and mouseLeave, set current position of 
     * mouse cursor after click to mouse button.
     */
	groupVertexMousedownHandler : function(e) {
        console.debug("ENTRY groupVertexMousedownHandler_aaa");
        
        var currentVertex = e.target.parentElement;
       
		if ($.inArray('group_vertices', currentVertex.classList) > -1) {
        	this.current = currentVertex.id;
        	this.current = new Object();
        	var xforms = currentVertex.getAttribute('transform');
        	var parts  = /translate\(\s*([^\s,)]+)[ ,]([^\s,)]+)/.exec(xforms);
        	posX = parts[1];
        	posY = parts[2];
        	this.current.x = posX;
        	this.current.y = posY;
        	this.$currentTarget = $('#' + currentVertex.id);
        	
			OffScreenKiv.showComposeComponents($(this.$currentTarget[0]).attr(
					'id').substring(3), false);
            
		} else {

			if (currentVertex.id == '') {
	            currentVertex = currentVertex.parentElement;
	        }
	        
			// id = getIndexFromId(currentVertex.id,6)-1;
			// this.current = GraphManager.graph.vertices[id];
			this.$currentTarget = this.current.$selector;
	        this.$currentTarget.css('cursor', 'pointer');
        } 
	        
		this.offsetX = e.pageX;
		this.offsetY = e.pageY;
       
		if (e.which == 1) {
           
            this.clickedPosX = e.pageX;
            this.clickedPosY = e.pageY;
            this.leftMouseButtonDown = true;
            this.$svg.mouseleave(this.viewportEndDraggingHandler);
            this.$svg.mouseup(this.viewportEndDraggingHandler);
            this.highlightGroupVertices(this.$currentTarget);
        }
        console.debug("EXIT groupVertexMousedownHandler");
    },
    
       
    /**
     * Ensures move of elements in graph.
     */
    viewportMousemoveHandler: function (e) {
        
        if (this.leftMouseButtonDown) {
                    	
			if (TimeBarrier.wait()) {
                console.info("denied");
                return;
            }
            console.info("mouse - move");
            var diffX = this.offsetX - e.pageX;
            var diffY = this.offsetY - e.pageY;
            
            if((diffX != 0) || (diffY != 0)) {
				this.oscarMike = true;
                this.current.x = this.current.x-diffX/this.zoom.currentZoom;
                this.current.y = this.current.y-diffY/this.zoom.currentZoom;
                
                
                this.$currentTarget.attr('transform', 'translate('+this.current.x+','+this.current.y+')');
                 
                // posouvani malych ctvercu
				$('#rectTop' + (this.current.id)).attr('transform','translate(' + (this.current.x+this.current.size-25)						
						+ ',' + this.current.y + ')');
				
				$('#rectBot' + (this.current.id)).attr('transform','translate(' + (this.current.x+this.current.size-5)						
						+ ',' + (this.current.y) + ')');

                //pokud se jedna o skupinu komponent
                if ( this.$currentTarget.attr('class') == 'group_vertices' ) 
                {
                	
                //START************************************************************
                	var id_group_to_load = this.$currentTarget.attr('id').substring(3);
                	
                	group2 = OffScreenKiv.groupManager.getGroup(id_group_to_load);
                	
                	group2.x = posX;
                	group2.y = posY;
                	
					// nastavení pozice prvků
                	id_vert = 0;
                	
                	/*
                	$('ul[data-groupid=' + group_name + '] li').each(function() {    		
                		id_vert = $(this).find('p').attr('data-vertexid');*/
                	//	for( var ii = 0; ii< group2.groupItemsLength; ii++){
                	//	console.log(group2.groupItems[id_vert]);
                	
                	posX = this.current.x;
     	            posY = this.current.y;
     	            
                	posX_reset = posX;
     	            
                	$.each(group2.groupItems, function(index, value) {
                		  id_vert = index;
                		   //get current vertex
                		
            	            var newX;
            	            var newY;
            	            
            	            var lollipop;
            	            posX = posX_reset;
            	          //  posX = posX_reset;
            	          //  posX = parseFloat(posX);
            	          //  posY = parseFloat(posY);
            	            
            	           
            	         
            	            //posun pozice, aby byla komponenta vycentrovana
            	            hidden_component_width = $('g#vertex' + id_vert + ' rect').attr('width');
            	            console.log("width: " + hidden_component_width);
            	            //vystredeni na stred
            	            posX = posX  - (hidden_component_width/2) + 40;	            

            	    		group2.groupItems[id_vert].x = posX;
            	    		group2.groupItems[id_vert].y = posY;
            	            
            	            $currentTarget = $('g#vertex' + id_vert);
            	            
            	    		$currentTarget.attr('transform', 'translate('+posX+','+posY+')');
            	    		
            	    		//$currentTarget.trigger('click',{move_edges:true});
            	    		console.log('group_vertices');
            	            for(var i = 0; i< group2.groupItems[id_vert].edges.length; i++){
            	                var edge = group2.groupItems[id_vert].edges[i];
            	                var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
            	                var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
            	                if(edge.from.id == id_vert){
            	                    newX = group2.groupItems[id_vert].edges[i].to.x + sizeOfRectTo/2;
            	                    newY = group2.groupItems[id_vert].edges[i].to.y + 13;
            	                    lollipop = getLollipopPosition(posX + sizeOfRectFrom/2, posY +13 , newX, newY);
            	                    
            	                    edge.$selector.children("line").attr('x1', posX + sizeOfRectFrom/2);
            	                    edge.$selector.children("line").attr('y1', posY + 13);
            	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
            	                    
            	                } else {
            	                    newX = group2.groupItems[id_vert].edges[i].from.x + sizeOfRectFrom/2;
            	                    newY = group2.groupItems[id_vert].edges[i].from.y + 13;
            	                    lollipop = getLollipopPosition(newX, newY, posX + sizeOfRectTo/2, posY + 13);
            	                    
            	                    edge.$selector.children("line").attr('x2', posX + sizeOfRectTo/2);
            	                    edge.$selector.children("line").attr('y2', posY + 13);
            	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
            	                }
            	            }
            	                 
                	
                		});
                	
                	this.offsetX = e.pageX;
 	                this.offsetY = e.pageY;
 	                
                // END**************************************************************	
                }
                // posouvani a rotace cary
                else{
                
	                var newX;
	                var newY;
	                var lollipop;
	                if ( this.current.edges != null)
	                for(var i = 0; i< this.current.edges.length; i++){
	                    var edge = this.current.edges[i];
	                    var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
	                    var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
	                    if(edge.from.id == this.current.id){
	                        newX = this.current.edges[i].to.x + sizeOfRectTo/2;
	                        newY = this.current.edges[i].to.y + 13;
	                        lollipop = getLollipopPosition(this.current.x + sizeOfRectFrom/2, this.current.y +13 , newX, newY);
	                        
	                        edge.$selector.children("line").attr('x1', this.current.x + sizeOfRectFrom/2);
	                        edge.$selector.children("line").attr('y1', this.current.y + 13);
	                        edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                        
	                    } else {
	                        newX = this.current.edges[i].from.x + sizeOfRectFrom/2;
	                        newY = this.current.edges[i].from.y + 13;
	                        lollipop = getLollipopPosition(newX, newY, this.current.x + sizeOfRectTo/2, this.current.y + 13);
	                        
	                        edge.$selector.children("line").attr('x2', this.current.x + sizeOfRectTo/2);
	                        edge.$selector.children("line").attr('y2', this.current.y + 13);
	                        edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                    }
	                }
	                this.offsetX = e.pageX;
	                this.offsetY = e.pageY;
                }
            }
        }
    },

    
    /**
     * Ensures move of elements in graph.
     */
    viewportMoveHandler: function (x,y) {
        
            
            var diffX = this.offsetX - x;
            var diffY = this.offsetY - y;
            
            if((diffX != 0) || (diffY != 0)) {
                this.current.x = this.current.x-diffX/this.zoom.currentZoom;
                this.current.y = this.current.y-diffY/this.zoom.currentZoom;
                
                
                this.$currentTarget.attr('transform', 'translate('+this.current.x+','+this.current.y+')');
                

                var newX;
                var newY;
                var lollipop;
                
                for(var i = 0; i< this.current.edges.length; i++){
                    var edge = this.current.edges[i];
                    var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
                    var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
                    if(edge.from.id == this.current.id){
                        newX = this.current.edges[i].to.x + sizeOfRectTo/2;
                        newY = this.current.edges[i].to.y + 13;
                        lollipop = getLollipopPosition(this.current.x + sizeOfRectFrom/2, this.current.y +13 , newX, newY);
                        
                        edge.$selector.children("line").attr('x1', this.current.x + sizeOfRectFrom/2);
                        edge.$selector.children("line").attr('y1', this.current.y + 13);
                        edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
                        
                    } else {
                        newX = this.current.edges[i].from.x + sizeOfRectFrom/2;
                        newY = this.current.edges[i].from.y + 13;
                        lollipop = getLollipopPosition(newX, newY, this.current.x + sizeOfRectTo/2, this.current.y + 13);
                        
                        edge.$selector.children("line").attr('x2', this.current.x + sizeOfRectTo/2);
                        edge.$selector.children("line").attr('y2', this.current.y + 13);
                        edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
                    }
                }
                this.offsetX = x;
                this.offsetY = y;
            }
        
    },
    
    
    /**
     * Highlights the edge that was clicked
     */
    clickToEdge: function(e){
        this.deleteBorder();
        
        // disables highlited edges connected to last clicked vertex
	this.disableHighlightEdges();
	this.highlightVertex = null;

        var id = getIndexFromId(e.target.parentElement.parentElement.id, 1)-1;
        var edge = GraphManager.graph.edges[id];
        //console.info("id: " + id);
        //console.info("this.highlightEdge: " + this.highlightEdge);
        if(this.highlightEdge != edge){
            this.highlightEdge = edge;
            edge.from.$selector.css('stroke', 'red');
            edge.to.$selector.css('stroke', 'red');
            edge.$selector.css('stroke', 'red');
        }else {
            this.highlightEdge = null;
        }
    },
    
    /**
     * Stop highlighting edge.
     */
    deleteBorder: function(){
        if(this.highlightEdge != null){
            this.highlightEdge.from.$selector.css('stroke', '');
            this.highlightEdge.to.$selector.css('stroke', '');
            this.highlightEdge.$selector.css('stroke', '');
        }
    },
    
    /**
     * Event which will be executed after mouseup. 
     * Cancels hihghlighting of vertex which was moved.
     */
    viewportEndDraggingHandler: function (e) {
		// Highlighting connected vertices only on click (not on drag)
		if (this.oscarMike == false && this.offsetX != 0) {
			this.current.$selector.attr('class', 'vertex colorNormal');
			this.highlightClckdVertex(this.current);
			// $('#rightPanel').append(this.offsetX+'<BR>');
		}
        console.debug("ENTRY - viewportEndDraggingHandler");
        if (this.leftMouseButtonDown) {
            console.info("leftMouseButtonDown" + this.leftMouseButtonDown);
            this.leftMouseButtonDown = false;
            this.offsetX = 0;
            this.offsetY = 0;
                        
            this.$currentTarget.css('cursor', 'auto');
            this.disableHighlight(this.current);
            this.$svg.unbind('mouseup');
            
            if(OffScreenKiv.vertexSearchHighlighting[this.current.symbolicName] != undefined){
                this.current.$selector.css("fill", "orange");
            }
            
        
            
            this.$svg.mouseleave(function(){});
            
            
        }
        console.debug("EXIT - viewportEndDraggingHandler");
    },
    
    init: function(){
        this.highlightReqGraph = this.highlightReqGraph.bind(this);
	this.highlightProvGraph = this.highlightProvGraph.bind(this);
		
        this.vertexMousedownHandler = this.vertexMousedownHandler.bind(this);
        this.groupVertexMousedownHandler = this.groupVertexMousedownHandler.bind(this);
        this.viewportMousemoveHandler = this.viewportMousemoveHandler.bind(this);
        this.viewportEndDraggingHandler = this.viewportEndDraggingHandler.bind(this);
        this.revive = this.revive.bind(this);
        this.clickToEdge = this.clickToEdge.bind(this);
        this.addContextMenu = this.addContextMenu.bind(this);
        this.highlightClckdVertexSeCo = this.highlightClckdVertexSeCo.bind(this);
        this.highlightProvGraphSeCo = this.highlightProvGraphSeCo.bind(this);
        this.highlightReqGraphSeCo = this.highlightReqGraphSeCo.bind(this);
        
    },
    
    /**
     * Initial registration events on elements of graph.
     */
    revive: function() {
        this.$svg = $('#svg1');
        
        // nastavovani clicku
        $('#dbutt').click(OffScreenKiv.includeUncon);
		$('#dbback').click(OffScreenKiv.deleteUncon);
		$('#cmpList').click(OffScreenKiv.showUnconList);
		for ( var i = 0; i < GraphManager.unconList.length; i++){
			$('#liuc_del_'+GraphManager.unconList[i]).click(OffScreenKiv.deleteUnconItem);
			//$('#rightPanel').append(GraphManager.unconList[i]+'<BR>');
		}
        
		
		
		
        for(var i = 0; i < GraphManager.graph.vertices.length; i++){
            var vertex = GraphManager.graph.vertices[i];
            var id = '#vertex'+(i+1);
            vertex.$selector = $(id);
            if ($("input[name='actionMove']:checked").val() == '1'){
                vertex.$selector.mousedown(this.vertexMousedownHandler);
            }else if ($("input[name='actionMove']:checked").val() == '2'){
                vertex.$selector.mousedown(OffScreenKiv.detailHandler);
            }
            this.addContextMenu(id);
            vertex.$selector.mouseup(this.viewportEndDraggingHandler);

            $('#rectTop'+vertex.id).click(ViewportManager.highlightReqGraph);
            $('#rectBot'+vertex.id).click(ViewportManager.highlightProvGraph);

        }
        
        for(var j = 0; j < GraphManager.graph.edges.length; j++){
            var edge = GraphManager.graph.edges[j];
            var idEdge = '#e' + edge.id;
            edge.$selector = $(idEdge);
            edge.$selector.click(this.clickToEdge);
        }
        
        // $(window).mousemove(this.viewportMousemoveHandler);
        this.$svg.mousemove(this.viewportMousemoveHandler);
        this.$svg.bind('dragstart', function(event) {
            event.preventDefault();
        });
        
        
        // hack na vystredeni grafu
        $('#zoomOut').trigger('click');
   
    },
    
    /**
     * Add context menu to html.
     */
    addContextMenu: function(id){
        $(id).contextMenu({
            menu: 'myMenu'
        },
        function(action, el, pos) {
            OffScreenKiv.addVertexToGroup(action, el);
        });
            
    }
};



function loadGraphData(diagram_id, diagram_hash){

    //Function for loader support by jquery.
    $.fn.spin = function(opts) {
        this.each(function() {
            var $this = $(this),
            data = $this.data();

            if (data.spinner) {
                data.spinner.stop();
                delete data.spinner;
            }
            if (opts !== false) {
                data.spinner = new Spinner($.extend({
                    color: $this.css('color')
                }, opts)).spin(this);
            }
        });
        return this;
    };
    
    enableLoader();
    
    GraphManager.init();
    ViewportManager.init(); 
    OffScreenKiv.init();  
    
    var load_url = "LoadGraphData";
    var load_diagram_url = "LoadDiagram";
    
    if ( diagram_id != null) {
    	load_url += "?diagram_id=" + diagram_id;
    	load_diagram_url += "?diagram_id=" + diagram_id;
    }
    
    if ( diagram_hash != null ) {
    	load_url +=  "&diagram_hash=" + diagram_hash;
    	load_diagram_url += "&diagram_hash=" + diagram_hash;
    }

    
    /**
     * Gets data from server.
     */
    $.getJSON( load_diagram_url,
        function(data) { 
            GraphManager.vertices_position = data;
        });
    
    /**
     * Gets data from server.
     */
    $.getJSON( load_url,
        function(data) {
            GraphManager.graph = data;
            GraphManager.buildGraph();
            ViewportManager.revive();
        
        });
        
    $('#zoomIn').click(function(){
        ViewportManager.zoom.zoomIn();
    });
    
    $('#zoomOut').click(function(){
        ViewportManager.zoom.zoomOut();
    });
    
    $("input[name='actionMove']").change(function(){
        if ($("input[name='actionMove']:checked").val() == '1'){
            for(var i = 0; i < GraphManager.graph.vertices.length; i++){
                var vertex = GraphManager.graph.vertices[i];
                vertex.$selector.unbind('mousedown', OffScreenKiv.detailHandler);
                vertex.$selector.mousedown(ViewportManager.vertexMousedownHandler);
            }
        }else if ($("input[name='actionMove']:checked").val() == '2'){
            for(var j = 0; j < GraphManager.graph.vertices.length; j++){
                var vert = GraphManager.graph.vertices[j];
                vert.$selector.unbind('mousedown', ViewportManager.vertexMousedownHandler);
                vert.$selector.mousedown(OffScreenKiv.detailHandler);
            }
        }
    });
    
    $("#search").click(OffScreenKiv.search);
    $("#searchText").focusin(function(){
        if($(this).val() == "Search components..."){
            $(this).val("");
        }
    });
    
    $("#countOfFinded").click(OffScreenKiv.deselectHighlightSearchedVertices);
    $("#mostEdge").click(OffScreenKiv.excludeVerticesWithMostEdges);
    $("#vertexToGroup").click(OffScreenKiv.excludeVerticesWithMostEdgesToGroup);
    $('#applyLayout').click(GraphManager.forceDirectedLayoutOnClick);
    
    init_zoomKeys();
	
}

var ctrl_pressed = false;

function init_zoomKeys(){
	
	$(window).keydown(function (event){
		if(  event.which === 17 ) {
			ctrl_pressed = true;
			$('#zoom_help').show();
		}
	});
	$(window).keyup(function (event){
		if(  event.which === 17 ) {
			ctrl_pressed = false;
			$('#zoom_help').hide();
		}
	});
	
		$(window).keypress(function( event ) {
		
			if(  event.which === 43 ) {
				$('#zoomIn').trigger('click');
				 if (event.preventDefault) {
					 event.preventDefault();
		         } else {
		        	 event.returnValue = false;
		         }    
		
				
			}
			if(  event.which === 45 ) {
				$('#zoomOut').trigger('click');
				 if (event.preventDefault) {
					 event.preventDefault();
		         } else {
		        	 event.returnValue = false;
		         }
			}
		   
		});
	

		hookEvent('viewport', 'mousewheel', scroll_viewport_zooming);
		hookEvent('zoom_help', 'mousewheel', scroll_viewport_zooming);
	
}


function scroll_viewport_zooming(e)
{
  e = e ? e : window.event;  
  var raw = e.detail ? e.detail : e.wheelDelta;
  
  if(ctrl_pressed == true){
	  if (raw > 0){		  
		  $('#zoomOut').trigger('click');  
	  }
	  if (raw < 0){
		  $('#zoomIn').trigger('click'); 
	  }
	  cancelEvent(e);
  }
}



function hookEvent(element, eventName, callback)
{
  if(typeof(element) == "string")
    element = document.getElementById(element);
  if(element == null)
    return;
  if(element.addEventListener)
  {
    if(eventName == 'mousewheel')
      element.addEventListener('DOMMouseScroll', callback, false);  
    element.addEventListener(eventName, callback, false);
  }
  else if(element.attachEvent)
    element.attachEvent("on" + eventName, callback);
}
function unhookEvent(element, eventName, callback)
{
  if(typeof(element) == "string")
    element = document.getElementById(element);
  if(element == null)
    return;
  if(element.removeEventListener)
  {
    if(eventName == 'mousewheel')
      element.removeEventListener('DOMMouseScroll', callback, false);  
    element.removeEventListener(eventName, callback, false);
  }
  else if(element.detachEvent)
    element.detachEvent("on" + eventName, callback);
}
function MouseWheel(e)
{
  e = e ? e : window.event;
  
}
function cancelEvent(e)
{
  e = e ? e : window.event;
  if(e.stopPropagation)
    e.stopPropagation();
  if(e.preventDefault)
    e.preventDefault();
  e.cancelBubble = true;
  e.cancel = true;
  e.returnValue = false;
  return false;
}
