/**
 * This class represents creation of symbols.
 */
var MarkSymbol = new Class({
    testMarkSymbols: new Array("☺", "☻", "♥"),
    
    CONST_MARK_SYMBOLS: new Array("☺", "☻", "♥", "♦", "♣", "♠", "♫", "☼", "►", "◄", 
        "▲", "▼", "■", "▬", "░", "▒", "↕", "↑", "↓", "→", "←", "↔", "╣", "╩", "╠", 
        "╚", "╝", "║", "╔", "╦", "═", "╬", "╗", "┴", "┬", "∟", "┌", "├", "┤", 
        "⌂", "+", "-", "*", "÷", "×", "=", "±", "Ø", "~", "«", "»", "¤", "¶", "§",
        "‼", "!", "#", "$", "%", "&", "@", "A", "B", "C", "D", "E", "F", "G", "H", 
        "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W",
        "X", "Y", "Z",   "©", "®", "α", "β", "γ", "δ", "ε", "ζ", "η", "θ", "ι", "κ",
        "λ", "μ", "ν", "ξ", "π", "ρ", "σ", "τ", "υ", "φ", "χ", "ψ", "ω", "Ω", "Φ", 
        "Σ", "Λ", "Δ", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"),

    CONST_MARK_COLORS: new Array("#DC143C", "#B23AEE", "#63B8FF", "#3D9140", "#B3EE3A", 
        "#FFD700", "#B7B7B7", "#FF8000"),
    removeMarkSymbolMap: new Array(),
    symbolIndex: -1,
    colorIndex: -1,
    startColorIndex: 0,
    
      
    setLastSymbolIndex: function(index){
        this.symbolIndex = index();
    },
    
    /**
     * Returns symbol with unique char and color.
     */
    getMarkSymbol: function(){
        if(this.removeMarkSymbolMap.length > 0){
            return this.removeMarkSymbolMap.shift();//vyjme a vrati prvni prvek pole
        }
        
        this.symbolIndex++;
        this.colorIndex++;
        
        if(this.colorIndex == this.CONST_MARK_COLORS.length){
            this.colorIndex = 0;
        }
       
        if(this.symbolIndex == this.CONST_MARK_SYMBOLS.length){
            if(this.startColorIndex == this.CONST_MARK_COLORS.length){
                this.startColorIndex = 0;
            }
            
            this.symbolIndex = 0;
            this.startColorIndex++;
            this.colorIndex = this.startColorIndex;
            
        }
       
        return [this.CONST_MARK_SYMBOLS[this.symbolIndex], this.CONST_MARK_COLORS[this.colorIndex]];
    },
    
    
    getMarkSymbolTest: function(){
        this.symbolIndex++;
        this.colorIndex++;
        
        
        if(this.colorIndex == this.CONST_MARK_COLORS.length){
            this.colorIndex = 0;
        }
       
        if(this.symbolIndex == this.testMarkSymbols.length){
            if(this.startColorIndex == this.CONST_MARK_COLORS.length){
                this.startColorIndex = 0;
            }
            
            this.symbolIndex = 0;
            this.startColorIndex++;
            this.colorIndex = this.startColorIndex;
        }
       
        return [this.testMarkSymbols[this.symbolIndex], this.CONST_MARK_COLORS[this.colorIndex]];
    },
    
    /**
     * Save removed symbol (char + color) to the list of removes symbols.
     */
    removeSymbol: function(symbol){
        this.removeMarkSymbolMap.push(symbol);
    },
    
    toString: function(){
        console.info("ENTRY MarkSymbol.toString");
        for(var i = 0; i < this.removeMarkSymbolMap.length; i++){
            console.info(i);
            console.info("symbol: " + this.removeMarkSymbolMap[i]);
        }
        console.info("EXIT MarkSymbol.toString");
    }
});
