var OffScreenKiv = {
    chooseVertices: null,
    markSymbol: new MarkSymbol(),
    vertexSearchHighlighting: new Object(),
    groupManager: new GroupManager(),
        
    init: function(){
        this.detailHandler = this.detailHandler.bind(this);
        this.displayVertexInGraph = this.displayVertexInGraph.bind(this);
        this.notHighlightNeighbour = this.notHighlightNeighbour.bind(this);
        this.highlightAllNeighbour = this.highlightAllNeighbour.bind(this);
        this.highlightProvidedEvent = this.highlightProvidedEvent.bind(this);
        this.highlightRequiredEvent = this.highlightRequiredEvent.bind(this);
        this.displayIconEvent = this.displayIconEvent.bind(this);
        this.hideIcon = this.hideIcon.bind(this);
        this.deleteItemFromGroupEvent = this.deleteItemFromGroupEvent.bind(this);
        this.groupHighlightProvided = this.groupHighlightProvided.bind(this);
        this.groupDisHighlightProvided = this.groupDisHighlightProvided.bind(this);
        this.groupHighlightRequired = this.groupHighlightRequired.bind(this);
        this.groupDisHighlightRequired = this.groupDisHighlightRequired.bind(this);
        this.groupHighlightRequiredAndProvided = this.groupHighlightRequiredAndProvided.bind(this);
        this.groupDisHighlightRequiredAndProvided = this.groupDisHighlightRequiredAndProvided.bind(this);
        this.search = this.search.bind(this);
        this.deselectHighlightSearchedVertices = this.deselectHighlightSearchedVertices.bind(this);
        this.showIconsAllItemOfGroup = this.showIconsAllItemOfGroup.bind(this);
        this.hideIconsAllItemGroup = this.hideIconsAllItemGroup.bind(this);
        this.excludeVerticesWithMostEdges = this.excludeVerticesWithMostEdges.bind(this);
        this.excludeVerticesWithMostEdgesToGroup = this.excludeVerticesWithMostEdgesToGroup.bind(this);
        
        this.deleteWholeGroup = this.deleteWholeGroup.bind(this);
        
        this.includeUncon = this.includeUncon.bind(this); 
        this.deleteUncon = this.deleteUncon.bind(this);
        
        this.showUnconList = this.showUnconList.bind(this);
        this.deleteUnconItem = this.deleteUnconItem.bind(this);
    },
    
    /**
     * 
     */
    deleteUnconItem: function(e){
    	var ind = getIndexFromId(e.target.id, 9);
    	var liID = e.target.parentElement.id;
    	var list = GraphManager.unconList;
    	
    	var i = list.indexOf(ind);
    	list.splice(i,1);
    	document.getElementById("unconText").textContent = list.length+" unconnected components";
    	
    	//$('#rightPanel').append(ind+'<BR>');
    	$('#'+liID).hide();
    	
    	
    	$('#vertex'+ind).show();
    	$('#rectTop'+ind).show();
        $('#rectBot'+ind).show();
    	
    },
    
    /**
     * show/hide unconnected components in a list
     */
    showUnconList: function(e){
    	
    	//$('#rightPanel').append('imho');
    	$('#unconCmpList').toggle();
    },
    
    /**
     * hide unconnected components
     */
    
    deleteUncon: function(){
    	var list = GraphManager.unconList;
    	var vertices = GraphManager.graph.vertices;
    	
    	// pridani nepropojenych do seznamu
    	for (var i = 0; i < vertices.length; i++){
    		var curr = vertices[i];
    		
    		// test existence sousedu a viditelnosti
    		if (curr.edges.length == 0 && $('#vertex'+curr.id).css('display') != 'none'){
    			var lng = list.length;
    			list[lng] = curr.id;
    		}
    		
    	}
    	
    	// schova v grafu
    	for (var i = 0; i < list.length; i++){
    		$('#vertex'+list[i]).hide();
        	$('#rectTop'+list[i]).hide();
            $('#rectBot'+list[i]).hide();
            $('#liuc'+list[i]).show();            
    	}
    	    	
    	
    	//$('#unconComps').show();
    	//$('#dbback').hide();
    	document.getElementById("unconText").textContent = list.length+" unconnected components";
    },
    
    /**
     * include unconnected components
     */
    
    includeUncon: function(){
    	
    	var list = GraphManager.unconList;
    	
    	//ukaze v grafu a odstrani ze seznamu
    	for (var i = list.length-1; i >= 0; i--){
    		$('#vertex'+list[i]).show();
        	$('#rectTop'+list[i]).show();
            $('#rectBot'+list[i]).show();
            
            $('#liuc'+list[i]).hide();   
                        
            list.splice(i,1);
            
    	}
    	
    	document.getElementById("unconText").textContent = list.length+" unconnected components";
    	//$('#unconComps').hide();
    	//$('#dbback').show();
    	
    	//$('#rightPanel').append('ahoj <BR>');
    },
    
    
    
    /**
     * Counts dependencies of vertex with other vertices.
     * Parameters: vertex - vertex
     */
    countDependence: function(vertex){
        var countFrom = 0;
        var countTo = 0;
        for(var i = 0; i < vertex.edges.length;i++){
            if(vertex.id == vertex.edges[i].from.id){
                countFrom++;
            }
        }
        
        countTo = vertex.edges.length - countFrom;
        return {
            countFrom: countFrom, 
            countTo: countTo
        };
    },
    
    /**
     * Draw detail of vertex which will be added to the right panel.
     * Parameters: vertex - vertex
     * Retrn string with svg of vertex detail.
     */
    drawVertexDetail: function(vertex){
        
        var dependence = this.countDependence(vertex);
        var name = "";
        if(vertex.name.length > 20){
            name = (vertex.name).substring(0, 17) + "...";
        } else {
            name = vertex.name;
        }
        
        var svgVertexDetail = '<svg class="right_panel_svg_group_component" id="d' + vertex.id + '" xmlns="http://www.w3.org/2000/svg" version="1.1" width="202" height="60">\
                    <g transform="translate(60,10)" class="colorNormal vertex" id="component' + vertex.id + '">\
                            <g class="detail colorNormal" id="detailVertex' + vertex.id + '" data-vertexId="' + vertex.id + '">\
                                <rect ry="4" rx="4" height="40" width="150" y="0" x="-10" />\
                                <text y="20" x="-5" text-anchor: middle dominant-baseline="central">' + name + '</text>\
                            </g>\
                        <g id="required' + vertex.id + '" class="whiteColor">\
                            <line x1="-10" y1="5" x2="-30" y2="5" stroke="black"/>\
                            <path class="SamplePath" d="M-42,-5 C-27,-5 -27,15 -42,15" stroke="black" />\
                            <text id="lolipA" x="-42" y="5" dominant-baseline="central">' + dependence.countTo + '</text>\
                        </g>\
                        <g id="provided' + vertex.id + '" class="whiteColor">\
                            <line x1="-10" y1="35" x2="-30" y2="35" stroke="black"/>\
                            <circle cx="-42" cy="35" r="11" stroke="black" /> \
                            <text id="lolipB" x="-42" y="35" dominant-baseline="central">' + dependence.countFrom + '</text>\
                        </g>\
                    </g>\
                </svg>';
        return svgVertexDetail;
    },
    
    /**
     * Cancels highlighting of provided neighbours of given vertex.
     * Parameters: vertex - vertex
     *             id - id of element on which was be clicked
     */
    disHighlightProvided: function(parentId, vertex){
    	
    	for(var i = 0; i < vertex.edges.length; i++) {
    		var edgeId = vertex.edges[i].to.id;
    		    		
    		$('#detailVertex' + (edgeId)).attr('class', 'detail colorNormal');
    		
    	}
    	
        console.info("ENTRY disHighlightProvided");
        $('#' + parentId).attr('class', 'whiteColor');
        for(var k = 0; k < vertex.edges.length; k++){
            vertex.edges[k].to.$selector.attr('class', 'vertex colorNormal');
        }
        console.info("EXIT disHighlightProvided");
    },
    
    
    /**
     * Highlights of provided neighbour of given vertex.
     * Parameters: vertex - vertex
     *             id - id of element on which was be clicked
     */
    highlightProvided:function(parentId, vertex){
    	
    	var idd = getIndexFromId(parentId, 8) - 1;
    	
    	for(var i = 0; i < vertex.edges.length; i++) {
    		var edgeId = vertex.edges[i].to.id;
    		    		
    		$('#detailVertex' + (edgeId)).attr('class', 'detail colorHighlightProvided');
    		$('#detailVertex' + (idd+1)).attr('class', 'detail colorNormal');
    	}
    	
        $('#' + parentId).attr('class', 'colorHighlightProvided');
        this.deselectHighlightSearchedVertices();
        for(var i = 0; i < vertex.edges.length; i++){
            vertex.edges[i].to.$selector.attr('class', 'vertex colorHighlightProvided');
        }
    },
    
    /**
     * Cancels highlighting of required neighbour of given vertex.
     * Parameters: vertex - vertex
     *             id - id of element on which was be clicked
     */
    disHighlightRequired: function(id, vertex){

   	for(var i = 0; i < vertex.edges.length; i++) {
    		var edgeId = vertex.edges[i].from.id;
    		    		
    		$('#detailVertex' + (edgeId)).attr('class', 'detail colorNormal');   		
    	}
        console.info("ENTRY disHighlightRequired");
        $('#' + id).attr('class', 'whiteColor');
        for(var l = 0; l < vertex.edges.length; l++){
            vertex.edges[l].from.$selector.attr('class', 'vertex colorNormal');
        }
        console.info("EXIT disHighlightRequired");
    },
    
    /**
     * Highlights of required neighbour of given vertex.
     * Parameters: vertex - vertex
     *             id - id of element on which was be clicked
     */
    highlightRequired:function(parentId, vertex){
    	   	
    	var idd = getIndexFromId(parentId, 8) - 1;
    	    	
    	for(var i = 0; i < vertex.edges.length; i++) {
    		var edgeId = vertex.edges[i].from.id;
    		    		
    		$('#detailVertex' + (edgeId)).attr('class', 'detail colorHighlight');
    		$('#detailVertex' + (idd+1)).attr('class', 'detail colorNormal');
    	}
    	
    	    		
        $('#' + parentId).attr('class', 'colorHighlight'); // tohle je zvyrazneni lizatka
        this.deselectHighlightSearchedVertices();
        for(var j = 0; j < vertex.edges.length; j++){
            vertex.edges[j].from.$selector.attr('class', 'vertex colorHighlight');
        }
    },
    
    /**
     * Event calls action  disHighlightProvided or highlightProvided depending on what element was clicked.
     * Parameters: e - event 
     */
    highlightProvidedEvent: function(e){
        var parentId = e.target.parentElement.id;
        var id = getIndexFromId(parentId, 8) - 1;
        var vertex  = GraphManager.graph.vertices[id];
        this.deselectHighlightSearchedVertices();
        if($('#' + parentId).attr('class') != 'whiteColor'){
            this.disHighlightProvided(parentId, vertex);
        }else {
            this.highlightProvided(parentId, vertex);
        }
        
        if(($('#provided' + (id+1)).attr('class') != 'whiteColor') && ($('#required' + (id+1)).attr('class') != 'whiteColor')){
            $('#detailVertex' + (id+1)).unbind('click');
            $('#detailVertex' + (id+1)).click(this.notHighlightNeighbour);
        } else {
            $('#detailVertex' + (id+1)).unbind('click');
            $('#detailVertex' + (id+1)).click(this.highlightAllNeighbour);
        }
    },
    
    /**
     * Event calls action  disHighlightRequired or highlightRequired depending on what element was clicked.
     * Parameters: e - event 
     */    
    highlightRequiredEvent: function(e){
        var parentId = e.target.parentElement.id;
        var id = getIndexFromId(parentId, 8) - 1;
        var vertex  = GraphManager.graph.vertices[id];
        
        if($('#' + parentId).attr('class') != 'whiteColor'){
            this.disHighlightRequired(parentId, vertex);
        }else {
            this.highlightRequired(parentId, vertex);
        }
        
        if(($('#provided' + (id+1)).attr('class') != 'whiteColor') && ($('#required' + (id+1)).attr('class') != 'whiteColor')){
            $('#detailVertex' + (id+1)).unbind('click');
            $('#detailVertex' + (id+1)).click(this.notHighlightNeighbour);
        } else {
            $('#detailVertex' + (id+1)).unbind('click');
            $('#detailVertex' + (id+1)).click(this.highlightAllNeighbour);
        }
    },
    
    /**
     * Cancels all highlighting of neigbour given vertex.
     * Parameters: vertex - vertex
     *             id - id of element on which was be clicked
     */
    disHighlihgtAll: function(id, vertex){  	   		
    	
        for(var i = 0; i < vertex.edges.length; i++){
        	var edgeIdFrom = vertex.edges[i].from.id;
        	var edgeIdTo = vertex.edges[i].to.id;
        	
        	$('#detailVertex' + (edgeIdFrom)).attr('class', 'detail colorNormal');
    		$('#detailVertex' + (edgeIdTo)).attr('class', 'detail colorNormal');
        	
            vertex.edges[i].from.$selector.attr('class', 'vertex colorNormal');
            vertex.edges[i].to.$selector.attr('class', 'vertex colorNormal');
        }
        $('#provided'+ id).attr('class', 'whiteColor');
        $('#required'+ id).attr('class', 'whiteColor');
    },
    
    /**
     * Event calls action  disHighlihgtAll after click to given element.
     * Parameters: e - event 
     */
    notHighlightNeighbour: function(e){
        var id = getIndexFromId(e.target.parentElement.id, 12) - 1;
        var vertex  = GraphManager.graph.vertices[id];

        this.disHighlihgtAll((id+1), vertex);
        $('#' + e.target.parentElement.id).unbind('click', this.notHighlightNeighbour);
        $('#' + e.target.parentElement.id).click(this.highlightAllNeighbour);
    },
    
    /**
     * Highlights all neigbours given vertex.
     * Parameters: vertex - vertex
     *             id - id of element on which was be clicked
     */
    highlihgtAll: function(id, vertex){
        this.deselectHighlightSearchedVertices();
        
        
        //var idd = getIndexFromId(id, 8) - 1;
        
        for(var i = 0; i < vertex.edges.length; i++){
        	
        	var edgeIdFrom = vertex.edges[i].from.id;
        	var edgeIdTo = vertex.edges[i].to.id;
        	
        	$('#detailVertex' + (edgeIdFrom)).attr('class', 'detail colorHighlight');
    		$('#detailVertex' + (edgeIdTo)).attr('class', 'detail colorHighlightProvided');
    		$('#detailVertex' + (id)).attr('class', 'detail colorNormal');
    		
            vertex.edges[i].from.$selector.attr('class', 'vertex colorHighlight');
            vertex.edges[i].to.$selector.attr('class', 'vertex colorHighlightProvided');
            
        }
        $('#provided'+ id).attr('class', 'colorHighlightProvided');
        $('#required'+ id).attr('class', 'colorHighlight');
    },
    
    /**
     * Event calls action  highlihgtAll after click to given element.
     * Parameters: e - event 
     */
    highlightAllNeighbour: function(e){
        var id = getIndexFromId(e.target.parentElement.id, 12) - 1;
        var vertex  = GraphManager.graph.vertices[id];
        this.highlihgtAll((id+1), vertex);
       
        $('#' + e.target.parentElement.id).unbind('click', this.highlightAllNeighbour);
        $('#' + e.target.parentElement.id).click(this.notHighlightNeighbour);
    },

    /**
     * Deletes a whole group.
     * @param e
     */
    deleteWholeGroup: function(e){
    	
    	var liItem = e.target.parentElement;
    	var group = liItem.parentElement;
                        
        	                               
    	//show group of components in graph
    	$('#rightPanel .deleteItemGroup').each(function() {
    		
    		var tmpGroupID = this.parentElement.parentElement.parentElement.id;
    		    		   		
    		if(group.id == tmpGroupID || group.parentElement.id == tmpGroupID) {   			
    			$(this).trigger('click');    		
        		console.log('deleteItemGroup');        		
    		}  
    		
    	});    	    	
    },
    
    /**
     * Includes all components in the graph.
     * 
     */
    includeAllComponents: function(e){
    	//show component in graph
    	$('#rightPanel .controlButton div[id^="db"]').each(function() {
    		$(this).trigger('click');
    	});
    	
    	//show group of components in graph
    	$('#rightPanel .deleteItemGroup:visible').each(function() {
    		$(this).trigger('click');
    		console.log('deleteItemGroup');
    	});
    	$('#includeAllComponents').hide();
    },
    
    /**
     * Display vertex and its edges in graph if it was clicked on the button with cross.
     */
    displayVertexInGraph: function(e){
        var currentVertex = e.target;
        
        if(currentVertex.id == ''){
            currentVertex = currentVertex.parentElement;
        }
        
        var id = getIndexFromId(currentVertex.id, 2) - 1;
        var vertex  = GraphManager.graph.vertices[id];
        
        vertex.$selector.show();

        // display little rects
        $('#rectTop'+vertex.id).show();
        $('#rectBot'+vertex.id).show();

        for(var i = 0; i <  vertex.edges.length; i++){
            if(vertex.edges[i].to.id != vertex.id && 
            	(	vertex.edges[i].to.$selector.css('display') != 'none' ||
            		($('#rightPanel #li'+vertex.edges[i].to.id).length == 1 &&	
            		$('#rightPanel #li'+vertex.edges[i].to.id).is(':visible') == false))){
                vertex.edges[i].$selector.show();
            }
            
            if(vertex.edges[i].from.id != vertex.id && 
            		(vertex.edges[i].from.$selector.css('display') != 'none' ||
            	    ($('#rightPanel #li'+vertex.edges[i].to.id).length == 1 &&
                     $('#rightPanel #li'+vertex.edges[i].from.id).is(':visible') == false))){
                vertex.edges[i].$selector.show();
            }
            /* Tohle tady bylo, ale nevim proc, akorat to kazilo oznacovani pri vraceni do grafu
            vertex.edges[i].to.$selector.attr('class','vertex colorNormal');
            vertex.edges[i].from.$selector.attr('class','vertex colorNormal');
            */
        }
        
        $("#detailVertex" + vertex.id).qtip('destroy');
        for(var j = 0; j < vertex.edges.length; j++){
            var targetVertex = this.getEdgeOtherSide(vertex.edges[j], vertex);
            var markId = 'mark' + vertex.symbol[0]+ vertex.symbol[1];
            if(targetVertex.gridMark.existMark(markId)){
                targetVertex.gridMark.removeMark(markId);
            }
        }
        $('#c' + vertex.id).remove();
        vertex.excluded = false;
        this.markSymbol.removeSymbol(vertex.symbol);
        var itemId = vertex.symbol[1].substring(1) + vertex.symbol[0];
        this.deleteItemFromContextMenu(itemId);
        
        if ( $('#rightPanel .component').length == 0 && $('#rightPanel div[id^="group"]').length == 0 ) {
        	$('#includeAllComponents').hide();
        }
        
    },
       
    isOnOneSideOfEdge: function(vertex, edge ){
        return (edge.to.id == vertex.id) || (edge.from.id != vertex.id);
    },
    
    getEdgeOtherSide: function(edge, vertex){        
        return (edge.to.id != vertex.id) ? edge.to : edge.from;
    },
    
    /**
     * This method ensures display icon at the vertex neighbors
     */
    displayIconAction: function(vertex){
        
        for(var i = 0; i < vertex.edges.length; i++){
            var targetVertex = this.getEdgeOtherSide(vertex.edges[i], vertex);
            // var markId = vertex.id + 'mark' + targetVertex.id;
            var markId = 'mark' + vertex.symbol[0]+ vertex.symbol[1];
            if(!targetVertex.gridMark.existMark(markId)){
                var mark = new Mark(vertex.symbol, markId, targetVertex.$selector);
                targetVertex.gridMark.addMark(markId, mark);
            }
        } 
    },
       
    /**
     * Event calls action  displayIconAction after click to given element.
     * Parameters: e - event 
     */   
    displayIconEvent: function(e){
        var id = getIndexFromId(e.target.id, 1) - 1;
        //console.info(id + " - " + e.target.id);
        var vertex  = GraphManager.graph.vertices[id];
        var color = vertex.symbol[1];
        $('#' + e.target.id).attr('class', "button c" + color.substring(1, color.length));
        this.displayIconAction(vertex);
        $('#' + e.target.id).unbind('click');
        $('#' + e.target.id).click(this.hideIcon);
    },
    
    /**
     * This method ensures disappearance of icon at the vertex neighbors
     */
    hideIconEvent: function(vertex){
        for(var i = 0; i < vertex.edges.length; i++){
            var targetVertex = this.getEdgeOtherSide(vertex.edges[i], vertex);
            var markId = 'mark' + vertex.symbol[0]+ vertex.symbol[1];
            //console.debug("hideIcon"+targetVertex.gridMark.existMark(markId));
            if(targetVertex.gridMark.existMark(markId)){
                targetVertex.gridMark.removeMark(markId);
            }
        } 
    },
    
    /**
     * Event calls action  displayIconAction after click to given element. 
     * It ensures to display icon at all vertex neighbors in group.
     * Parameters: e - event 
     */
    showIconsAllItemOfGroup: function(e){
        var buttonSelector = $(e.target);
        var idGroup = buttonSelector.attr('data-groupId');
        var group = this.groupManager.getGroup(idGroup);
        var firstRun = true;
        var symbol;
        for(var key in group.groupItems){
            if(firstRun){
                symbol = group.groupItems[key].symbol;
                buttonSelector.attr('class', "button c" + symbol[1].substring(1, symbol[1].length));
                firstRun = false;
            }
          //  console.info(key + " - " + group.groupItems[key].name);
            
            this.displayIconAction(group.groupItems[key]);
        }
        buttonSelector.unbind('click', this.showIconsAllItemOfGroup);
        buttonSelector.click(this.hideIconsAllItemGroup);
    },
    
    /**
     * Event calls action  hideIconEvent after click to given element. 
     * It ensures to disappearance icon at all vertex neighbors in group.
     * Parameters: e - event 
     */
    hideIconsAllItemGroup: function(e){
        console.info("hideIconsAllItemGroup");
        var buttonId = e.target.id;
        var idGroup = $(e.target).attr('data-groupId');
        var group = this.groupManager.getGroup(idGroup);

        for(var key in group.groupItems){
            this.hideIconEvent(group.groupItems[key]);
        }
        
        $('#' + buttonId).attr('class', 'button buttonClassic');
        $('#' + buttonId).unbind('click', this.hideIconsAllItemGroup);
        $('#' + buttonId).click(this.showIconsAllItemOfGroup);
    },
    
    /**
     * Event calls action  hideIconEvent after click to given element. 
     * Parameters: e - event 
     */
    hideIcon: function(e){
        var buttonId = e.target.id;
        var id = getIndexFromId(buttonId, 1) - 1;
        var vertex  = GraphManager.graph.vertices[id];
        
        this.hideIconEvent(vertex);
        
        $('#' + buttonId).attr('class', 'button buttonClassic');
        $('#' + buttonId).unbind('click');
        $('#' + buttonId).click(this.displayIconEvent);
    },
      
      
    /**
     * Create detail of removed vertex from graph and registered all events.
     * Parameters: e - event 
     */
    detailHandler: function(e){
        if(e.which == 1){
            console.info("detailHandler");
            var currentVertex = e.target.parentElement;
            if(currentVertex.id == ''){
                currentVertex = currentVertex.parentElement;
            }
            id = getIndexFromId(currentVertex.id, 6) - 1;
            var vertex = GraphManager.graph.vertices[id];
            
            // pokud nula sousedu, nevytvaret detail, ale strcit do nepropojenych
            if (vertex.edges.length == 0){
            	//hide vertex
            	vertex.$selector.hide();                             
                $('#rectTop'+vertex.id).hide();
                $('#rectBot'+vertex.id).hide();
            	
                var list = GraphManager.unconList;
                list[list.length] = vertex.id;
                $('#liuc'+vertex.id).show();
                document.getElementById("unconText").textContent = list.length+" unconnected components";
                
            	return;
            }
            
            vertex.excluded = true;
            this.deselectHighlightSearchedVertices();
            
            this.hideEdges(vertex.edges);
            vertex.$selector.hide();
            
            // hide little rects
            $('#rectTop'+vertex.id).hide();
            $('#rectBot'+vertex.id).hide();
            
            var symbol = this.markSymbol.getMarkSymbol();
            vertex.symbol = symbol;
            this.addItemToContextMenu(symbol, vertex.id, vertex.name);
            $('#rightPanel').append('<div class="component" id="c' + vertex.id + '">');
            $('#c' + vertex.id).append(this.drawVertexDetail(vertex));
            $('#c' + vertex.id).append('<div id ="cb' + vertex.id + '" class="controlButton">');
            $('#cb' + vertex.id).append('<div class="button buttonClassic" id="b' + vertex.id +'">' + symbol[0] + '</div>');
            $('#cb' + vertex.id).append('<div class="button buttonClassic" id="db' + vertex.id +'">\n\
                  <img src="images/button_cancel.png" alt="odstranit" title="odstranit"/></div>');
            $('#c' + vertex.id).append('</div><br class="clean"/>');
            $('#rightPanel').append('</div>');

            //registration of event
            $('#b' + vertex.id).click(this.displayIconEvent);
            $('#db' + vertex.id).click(this.displayVertexInGraph);
            configurationVertexDetailTooltip('#detailVertex' + vertex.id);
            // assigning action to parts of detail
            
            
            $('#detailVertex' + vertex.id).click(ViewportManager.highlightClckdVertexSeCo);
            $('#provided' + vertex.id).click(ViewportManager.highlightProvGraphSeCo);
            $('#required' + vertex.id).click(ViewportManager.highlightReqGraphSeCo);
            
            
            /* puvodni
            $('#detailVertex' + vertex.id).click(this.highlightAllNeighbour);
            $('#provided' + vertex.id).click(this.highlightProvidedEvent);
            $('#required' + vertex.id).click(this.highlightRequiredEvent);
            */
            $('#includeAllComponents').show();
            
            // Excludes from graph with the correct highlight color
            $('#detailVertex' + vertex.id).attr('class', vertex.$selector.attr('class'));
        }
    },
    
    /**
     * Hides edges.
     * Parameters: edges - edges whic will be hidden
     */
    hideEdges: function(edges){
        for(var i = 0; i <  edges.length; i++){
            edges[i].$selector.hide();
        }  
    },
    
    /**
     * Adds item to context menu.
     * Parameters: symbol - symbol which will be in context menu.
     *             vertexId - id of vertex which is linked with item of context menu.
     */
    addItemToContextMenu: function(symbol, vertexId, vertexName){
        var color = symbol[1].substring(1);
        var itemId = color + symbol[0];
        $('#myMenu').append('<li id="' + itemId + '"  data-vertexId="' + vertexId + '"><a href="#' + itemId + 
        		         '" class="component_color"><img class="imgContextMenu" src="images/'+color +'.png" alt="'+color+'"/>' + symbol[0] + 
           		         '</a><a class="cont_menu_group" href="#" onclick="OffScreenKiv.show_description(\''+itemId+'\'); return false;">[+]</a><span class="contextMenuDescription" id="contMenu_'+vertexId+'" style="display:none">' + vertexName + '</span>'+
           		         '<span class="cleaner"></span></li>');
        
       // $('#myMenu li#'+itemId+' .cont_menu_group').unbind('mousedown').unbind('mouseup');
      
    },
    show_description: function (itemId) {
       if ( $('#myMenu li#'+itemId+' .contextMenuDescription:hidden').length ){    	   
    	   $('#myMenu li#'+itemId+' .contextMenuDescription').show();
    	   $('#myMenu li#'+itemId+' a.cont_menu_group').text('[-]');
       } else {	
           $('#myMenu li#'+itemId+' .contextMenuDescription').hide();
           $('#myMenu li#'+itemId+' a.cont_menu_group').text('[+]');
       }
       
       // set css height of li#idGroup by count li elements
       /*
       var count_in_li = $('#myMenu li#' + itemId + ' .contextMenuDescription').length;      
       $('#myMenu li#' + itemId).css('height', (22 + (count_in_li * 16)) + 'px'); */   
      
       var count_in_li = $('#myMenu li#' + itemId + ' .contextMenuDescription:not(:hidden)').length;      
       $('#myMenu li#' + itemId).css('height', (22 + (count_in_li * 16)) + 'px');
       console.log(count_in_li); 
       $('#myMenu li#'+itemId).show();
      
       
       
    },
    /**
     * Delete item from context menu.
     * Parameters: groupID - id item from context menu which will be deleted.
     */
    deleteItemFromContextMenu: function(groupID){
        $('#' + groupID).remove();
    },
    
    /**
     * Adds vertex to group.
     * Parameters: action - id of element from context menu
     *             elementId - id vertex element
     */
    addVertexToGroup: function(action, elementId){
        var elemId = elementId.attr('id');
        var idGroup = action;
        var vertex = GraphManager.graph.vertices[(getIndexFromId(elemId, 6) - 1)];
        this.deselectHighlightSearchedVertices();
        this.hideEdges(vertex.edges);
        $(elementId).hide();

        // hide little rects
        $('#rectTop'+vertex.id).hide();
        $('#rectBot'+vertex.id).hide();

        var group = null;
        var defaultVertex = GraphManager.graph.vertices[$("#" + idGroup).attr('data-vertexId')-1];
        defaultVertex.excluded = true;
        vertex.symbol = defaultVertex.symbol;
        var color = defaultVertex.symbol[1];
        var isSetClassOnButton = $('#b' + defaultVertex.id).hasClass('c' + color.substring(1, color.length));
           
        if(!this.groupManager.existGroup(idGroup)){
            $('#c' + defaultVertex.id).remove();
            group = new Group(defaultVertex.symbol, idGroup);
            group.addToGroup(defaultVertex.id, defaultVertex);
            group.addProvidedPackage(defaultVertex.exportedPackages);
            group.addRequiredPackage(defaultVertex.importedPackages);
            group.addProvidedPackage(vertex.exportedPackages);
            group.addRequiredPackage(vertex.importedPackages);
            this.createGroupSVG(group, defaultVertex, vertex);
            this.groupManager.addGroupToList(idGroup, group);
                        
        } else {
            group = this.groupManager.getGroup(idGroup);
            group.addProvidedPackage(vertex.exportedPackages);
            group.addRequiredPackage(vertex.importedPackages);
            $('#ul' + idGroup).append('<li id="li' + vertex.id + '"><p data-vertexId="' + vertex.id + '" data-title="' + vertex.name + '">' + vertex.name + '</p><img class="deleteItemGroup" id="li_del_' + vertex.id  + '" alt="delete" src="images/button_cancel.png"/></li>');
            configurationVertexDetailTooltip('#li' + vertex.id + " p");
        
        }
      
       
        var is_in_group = false;
        $.each(group.groupItems, function(index, value) {
            	if ( value.id  == vertex.id) {
            	  is_in_group = true;	
            	} 
        	});
        
        
        if ( is_in_group == false ) {
        	var style_display = ' style="display:none" ';
        	if ( $('#myMenu li#' + idGroup + ' .contextMenuDescription:not(:hidden)').length ) {
        		$('#myMenu li#' + idGroup + ' .contextMenuDescription:last').after('<span class="contextMenuDescription b" id="contMenu_'+vertex.id+'" >'+vertex.name+'</span>');
        	}else{
        		$('#myMenu li#' + idGroup + ' .contextMenuDescription:last').after('<span class="contextMenuDescription b" id="contMenu_'+vertex.id+'" '+style_display+'>'+vertex.name+'</span>');	
        	}
            
        }         
       
        //set css height of li#idGroup by count li elements
        var count_in_li = $('#myMenu li#' + idGroup + ' .contextMenuDescription:not(:hidden)').length;      
        $('#myMenu li#' + idGroup).css('height', (22 + (count_in_li * 16)) + 'px');        
        
        vertex.excluded = true;
        group.addToGroup(vertex.id, vertex);
        
       
        
        $('.deleteItemGroup').unbind('click',this.deleteItemFromGroupEvent);
        $('.deleteItemGroup').click(this.deleteItemFromGroupEvent);
        
        if(group.getGroupItemsLength() > 2){
            this.editHeightOfGroup(group);
        }
        this.updateCountOfProvidedAndRequired(group);
        var buttonGroupId = $("#b" + idGroup);
       
        if(isSetClassOnButton){
            this.displayIconAction(vertex);
            buttonGroupId.attr('class', 'button c'+idGroup.substring(0,idGroup.length-1));
            buttonGroupId.unbind('click');
            buttonGroupId.click(this.hideIconsAllItemGroup);
        }
        
        if($("#b" + idGroup).hasClass("c"+idGroup.substring(0,idGroup.length-1))){
            this.displayIconAction(vertex);
        }
        
        $('#gr' + group.idGroup).click(this.groupHighlightRequiredAndProvided);
        $('#provided' + group.idGroup).click(this.groupHighlightProvided);
        $('#required' + group.idGroup).click(this.groupHighlightRequired);
        
        $(".contextMenu").hide();
       // $(".contextMenuDescription").hide();
        
     // kontrola, zda je skupina komponent zobrazena v grafu 
     //  -> pokud ano zobrazit hrany vedouci z komponenty, ktera byla pridana do grafu
        
        if ( $('g#gv_'+group.idGroup).length > 0 ) {
        
        
        
        //show all edges removed vertex from group.
        //TODO: nastavit správnou pozici komponenty
        
        for(var i = 0; i <  vertex.edges.length; i++){
            if(vertex.edges[i].to.id != vertex.id && 
            	(	vertex.edges[i].to.$selector.css('display') != 'none' ||
            		($('#rightPanel #li'+vertex.edges[i].to.id).length == 1 &&	
            		$('#rightPanel #li'+vertex.edges[i].to.id).is(':visible') == false))){
                vertex.edges[i].$selector.show();
            }
            
            if(vertex.edges[i].from.id != vertex.id && 
            		(vertex.edges[i].from.$selector.css('display') != 'none' ||
            	    ($('#rightPanel #li'+vertex.edges[i].to.id).length == 1 &&
                     $('#rightPanel #li'+vertex.edges[i].from.id).is(':visible') == false))){
                vertex.edges[i].$selector.show();
            }
            vertex.edges[i].to.$selector.attr('class','vertex colorNormal');
            vertex.edges[i].from.$selector.attr('class','vertex colorNormal');
            
        }
        
        var xforms = $('#gv_'+ idGroup )[0].getAttribute('transform');
        var parts  = /translate\(\s*([^\s,)]+)[ ,]([^\s,)]+)/.exec(xforms);
    	posX = parts[1];
    	posY = parts[2];
    	//posX posY - souradnice
    	
    	posX_reset = posX;
    	    	
    	//nastavení pozice prvků
    	id_vert =vertex.id;
    	  		
    		
        var newX;
        var newY;
        
        var lollipop;
        posX = posX_reset;
        posX = parseFloat(posX);
        
        //posun pozice, aby byla komponenta vycentrovana
        hidden_component_width = $('g#vertex' + id_vert + ' rect').attr('width');
        if (group.decompose){
    	$('#gv_'+ idGroup).children(' rect').attr('height',group.groupItemsLength * 34 + 55);
    	//TODO: zobrazit komponentu pridanou do skupiny
    		posY = parseFloat(posY) + group.groupItemsLength * 26 +34;
        	moveElementTopSVG("graph", 'vertex' + id_vert);
        	$('g#vertex' + id_vert).show();
        }else{
        	posY = parseFloat(posY);
        }
    	
        //vystredeni na stred
        posX = posX  - (hidden_component_width/2) + 40;	            

		group.groupItems[id_vert].x = posX;
		group.groupItems[id_vert].y = posY ;
	
        
        $currentTarget = $('g#vertex' + id_vert);
		$currentTarget.attr('transform', 'translate('+posX+','+posY+')');
		$currentTarget.trigger('click',{move_edges:true});
        
        for(var i = 0; i< group.groupItems[id_vert].edges.length; i++){
            var edge = group.groupItems[id_vert].edges[i];
            var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
            var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
            if(edge.from.id == id_vert){
                newX = group.groupItems[id_vert].edges[i].to.x + sizeOfRectTo/2;
                newY = group.groupItems[id_vert].edges[i].to.y + 13;
                lollipop = getLollipopPosition(posX + sizeOfRectFrom/2, posY +13 , newX, newY);
                
                edge.$selector.children("line").attr('x1', posX + sizeOfRectFrom/2);
                edge.$selector.children("line").attr('y1', posY + 13);
                edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
                
                //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
                if ( $('g#vertex'+ edge.to.id ).css('display') != 'none' 
                	//|| $('#rightPanel #li'+edge.to.id).is(':visible') == false) 
                	|| 
                	  ( $('#rightPanel li#li'+edge.to.id).is(':visible') == false &&
                		$('#rightPanel li#li'+edge.to.id).length > 0  
                	   )
                	){
                	edge.$selector.show();	
                }
                
            } else {
                newX = group.groupItems[id_vert].edges[i].from.x + sizeOfRectFrom/2;
                newY = group.groupItems[id_vert].edges[i].from.y + 13;
                lollipop = getLollipopPosition(newX, newY, posX + sizeOfRectTo/2, posY + 13);
                
                edge.$selector.children("line").attr('x2', posX + sizeOfRectTo/2);
                edge.$selector.children("line").attr('y2', posY + 13);
                edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
                
              //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
                if ( $('g#vertex'+ edge.from.id ).css('display') != 'none' 
                	 ||  ($('#rightPanel #li'+edge.from.id).is(':visible') == false &&
            			$('#rightPanel li#li'+edge.from.id).length > 0 )
                	) {
                	edge.$selector.show();	
                }
            }
        }
		
        
        //END

        }
        
        
        
        
    },
    
    /**
     * Sort component in right panel by name ASC.
     */ 	
    sortByNameASC: function (){
    	$('#rightPanel .component, #rightPanel div[id^="group"]').sort(OffScreenKiv.sortComponentNameASC).appendTo('#rightPanel');
    	$('.sortComponents').removeClass('active');
    	$('#sortComponents_name_asc').addClass('active');
    },
    
    /**
     * Sort component in right panel by name DESC.
     */ 	
    sortByNameDESC: function (){
    	$('#rightPanel .component, #rightPanel div[id^="group"]').sort(OffScreenKiv.sortComponentNameDESC).appendTo('#rightPanel');
    	$('.sortComponents').removeClass('active');
    	$('#sortComponents_name_desc').addClass('active');
    },    
    
    sortComponentNameASC: function(a,b){
    	var $_a_item = $(a).find('g[id^="detailVertex"] text');
    	var $_b_item = $(b).find('g[id^="detailVertex"] text');
    	
    	var a_item_text = '';
    	var b_item_text = '';
    	
    	if ( $_a_item.length > 0 ) {
    		a_item_text = $_a_item.text().toLowerCase();    		
    	} else {
    		a_item_text = $(a).find('ul li:first p').text().toLowerCase(); 
    	}
    	
    	if ( $_b_item.length > 0 ) {
    		b_item_text = $_b_item.text().toLowerCase();
    	}else{
    		b_item_text = $(b).find('ul li:first p').text().toLowerCase(); 
    	} 
    	
        return a_item_text > b_item_text ? 1 : -1;
    },
    
    sortComponentNameDESC: function(a,b){  
    	var $_a_item = $(a).find('g[id^="detailVertex"] text');
    	var $_b_item = $(b).find('g[id^="detailVertex"] text');

    	var a_item_text = '';
    	var b_item_text = '';
    	
    	if ( $_a_item.length > 0 ) {
    		a_item_text = $_a_item.text().toLowerCase();    		
    	} else {
    		a_item_text = $(a).find('ul li:first p').text().toLowerCase();   	
    	}
    	
    	if ( $_b_item.length > 0 ) {   
    		b_item_text = $_b_item.text().toLowerCase();
    	}else{
    		b_item_text = $(b).find('ul li:first p').text().toLowerCase();   	
    	} 
    	
        return  a_item_text >= b_item_text ? -1 : 1;
    },
    
    
    /**
     * Sort component in right panel by count of components ASC.
     */ 	
    sortByCountComponentASC: function (){
    	$('#rightPanel .component, #rightPanel div[id^="group"]').sort(OffScreenKiv.sortCountComponentASC).appendTo('#rightPanel');
    	$('.sortComponents').removeClass('active');
    	$('#sortComponents_count_asc').addClass('active');    	
    },
    
    /**
     * Sort component in right panel by count of components DESC.
     */ 	
    sortByCountComponentDESC: function (){
    	$('#rightPanel .component, #rightPanel div[id^="group"]').sort(OffScreenKiv.sortCountComponentDESC).appendTo('#rightPanel');
    	$('.sortComponents').removeClass('active');
    	$('#sortComponents_count_desc').addClass('active');    	    	
    },
    
    
    sortCountComponentASC: function(a,b){
    	var $_a_item = $(a).find('g[id^="detailVertex"] text');
    	var $_b_item = $(b).find('g[id^="detailVertex"] text');
    	
    	var a_count_comp = 1;
    	var b_count_comp = 1;
    	
    	if ( $_a_item.length > 0 ) {
    		a_count_comp = 1;	
    	} else {
    		a_count_comp = $(a).find('ul li').length; 
    	}
    	
    	if ( $_b_item.length > 0 ) {
    		b_count_comp = 1;	
    	}else{
    		b_count_comp = $(b).find('ul li').length; 
    	} 
    	
        return a_count_comp > b_count_comp ? 1 : -1;
    },
    
    sortCountComponentDESC: function(a,b){  
    	var $_a_item = $(a).find('g[id^="detailVertex"] text');
    	var $_b_item = $(b).find('g[id^="detailVertex"] text');
    	
    	var a_count_comp = 1;
    	var b_count_comp = 1;
    	
    	if ( $_a_item.length > 0 ) {
    		a_count_comp = 1;	
    	} else {
    		a_count_comp = $(a).find('ul li').length; 
    	}
    	
    	if ( $_b_item.length > 0 ) {
    		b_count_comp = 1;	
    	}else{
    		b_count_comp = $(b).find('ul li').length; 
    	} 
    	
        return a_count_comp >= b_count_comp ? -1 : 1;
    },
    
    
    /**
     * Event, which ensures deleting of vertex from group and modified all highlighting.
     */
    deleteItemFromGroupEvent: function(e){
        var liItem = e.target.parentElement;
        var groupIdUl = liItem.parentElement.id;
        var itemId = liItem.id;
        $("#" + itemId + " p").qtip('destroy');
        $('#' + itemId).remove();
        var vertex = GraphManager.graph.vertices[(getIndexFromId(itemId, 2)-1)];
        
        var groupId = $('#' + groupIdUl).attr('data-groupId');
        var group = this.groupManager.getGroup(groupId);
         
        if($("#b" + groupId).hasClass("c"+groupId.substring(0,groupId.length-1))){
            for(var key in group.groupItems){
                this.hideIconEvent(group.groupItems[key]);
                
            }
        }
       
        
        $('#myMenu li#' + groupId + ' #contMenu_'+vertex.id).remove();
        //set css height of li#idGroup by count li elements
        var count_in_li = $('#myMenu li#' + groupId + ' .contextMenuDescription:not(:hidden)').length;            
        $('#myMenu li#' + groupId).css('height', (22 + (count_in_li * 16)) + 'px');
        
        vertex.excluded = false;
        var lengthGroup = group.getGroupItemsLength();
        group.removeFromGroup(vertex.id);
        if($("#b" + groupId).hasClass("c"+groupId.substring(0,groupId.length-1))){
            for(var key1 in group.groupItems){
                this.displayIconAction(group.groupItems[key1]);
                        
            }
        }
        lengthGroup = group.getGroupItemsLength();
        group.deleteProvidedPackage(vertex.exportedPackages);
        group.deleteRequiredPackage(vertex.importedPackages);
        this.updateCountOfProvidedAndRequired(group);
        
        if(lengthGroup >= 2){
            this.editHeightOfGroup(group);
        }
        
        //if length of group is 0, removed all html and svg elements linked with given group.
        if(lengthGroup <= 0){
            $('#group' + groupId).remove();
            this.groupManager.removeGroupFromList(groupId);
            this.deleteItemFromContextMenu(groupId);
            this.markSymbol.removeSymbol([groupId.substring(groupId.length-1),("#"+groupId.substring(0, groupId.length-1))]);
        }
        
        vertex.$selector.show();
        
        //show little rects
        $('#rectTop'+vertex.id).show();
        $('#rectBot'+vertex.id).show();
        
        //show all edges removed vertex from group.
        for(var i = 0; i <  vertex.edges.length; i++){
            if(vertex.edges[i].to.id != vertex.id && vertex.edges[i].to.$selector.css('display') != 'none'){
                vertex.edges[i].$selector.show();
            }
            if(vertex.edges[i].from.id != vertex.id && vertex.edges[i].from.$selector.css('display') != 'none'){
                vertex.edges[i].$selector.show();
            }
            /*
            vertex.edges[i].to.$selector.attr('class','vertex colorNormal');
            vertex.edges[i].from.$selector.attr('class','vertex colorNormal');
            */
        }
        
        //check count elements in right panel then hide button remove all
        if ( $('#rightPanel .component').length == 0 && $('#rightPanel div[id^="group"]').length == 0 ) {
        	$('#includeAllComponents').hide();
        }
        
    },
    
    /**
     * Creates all html and svg elements which represets given group.
     * Parameters: group - group
     *             defaultVertex - first vertex which will be added to the group
     *             vertex - second vertex
     */
    createGroupSVG: function(group, defaultVertex, vertex){
        $('#rightPanel').append('<div id="group' + group.idGroup + '">');
        this.drawGroup(group);
        $('#group' + group.idGroup).append('<ul data-groupID="' + group.idGroup + '" id="ul' + group.idGroup + '">\
               <li id="li' + defaultVertex.id + '"><p  data-vertexId="' + defaultVertex.id + '" data-title="' + defaultVertex.name + '">' + defaultVertex.name + '</p><img class="deleteItemGroup" id="li_del_' + defaultVertex.id  + '" alt="delete" src="images/button_cancel.png"/></li>\
               <li id="li' + vertex.id + '"><p data-vertexId="' + vertex.id + '" data-title="' + vertex.name + '">' + vertex.name + '</p><img class="deleteItemGroup" id="li_del_' + vertex.id  + '" alt="delete" src="images/button_cancel.png"/></li></ul><br class="clean"/></div>');
        $('#group' + group.idGroup).append('<div class="controlButton"><div data-groupId="'+ group.idGroup + '" class="button buttonClassic" id="b' + group.idGroup +'">' + defaultVertex.symbol[0] + '</div></div><br class="clean"/>');
        $('#b' + group.idGroup).click(this.showIconsAllItemOfGroup);
        configurationVertexDetailTooltip('#li' + defaultVertex.id + " p");
        configurationVertexDetailTooltip('#li' + vertex.id + " p");
    },
    
    /**
     * Create html and svg element for new item in group.
     * Parameters: group - group
     *             symbol - symbol representig group
     */
    createSvgForGroup: function(group,symbol){
        $('#rightPanel').append('<div id="group' + group.idGroup + '">');
        this.drawGroup(group);
        $('#group' + group.idGroup).append('<ul data-groupID="' + group.idGroup + '" id="ul' + group.idGroup + '">');
        $('#group' + group.idGroup).append('</ul><br class="clean"/></div><div class="controlButton"><div data-groupId="'+ group.idGroup + '" class="button buttonClassic" id="b' + group.idGroup +'">' + symbol[0] + '</div></div><br class="clean"/>');
        $('#b' + group.idGroup).click(this.showIconsAllItemOfGroup);
    },
    
    /**
     * Draw svg element for group.
     * Parameters: group - group     
     */
    drawGroup: function(group){
        $('#group' + group.idGroup).append('<svg class="right_panel_svg_group_component" id="svgGroup' + group.idGroup + '" xmlns="http://www.w3.org/2000/svg" version="1.1" width="73" height="57" \
        		xmlns:xlink="http://www.w3.org/1999/xlink">\
                <g id="gr' + group.idGroup + '" class="vertex colorNormal" transform="translate(60,10)">\
                    <rect id="rect'+ group.idGroup +'" ry="4" rx="4" height="56" width="20" y="0" x="-10" fill="' + group.groupSymbol[1] + '" stroke="black"/>\
                    <text y="12" x="0" fill="black" stroke="none" dominant-baseline="central" text-anchor="middle" font-size = "30">' + group.groupSymbol[0] +'</text>\
                    <a xlink:href="#" onclick="OffScreenKiv.drawGroupedVertices(\''+group.idGroup +'\'); return false">\
	                     <rect y="21" x="-7" width="14" height="14" style="fill:rgb(255,255,255);stroke-width:1;stroke:rgb(0,0,0)"/>\
	                     <line x1="-5" y1="28" x2="2" y2="24" style="stroke:rgb(33,33,33);stroke-width:2" />\
	                     <line x1="-5" y1="28" x2="2" y2="32" style="stroke:rgb(33,33,33);stroke-width:2" />\
	                     <line x1="-5" y1="28" x2="5" y2="28" style="stroke:rgb(33,33,3);stroke-width:2" />\
                    </a>\
                    <a xlink:href="#" onclick="OffScreenKiv.removeAllComponentFromGroup(\''+group.idGroup+'\'); return false">\
	                    <rect y="38" x="-7" width="14" height="14" style="fill:rgb(255,255,255);stroke-width:1;stroke:rgb(0,0,0)"/>\
	                    <line x1="-4" y1="41" x2="4" y2="49" style="stroke:rgb(202,0,0);stroke-width:2" />\
	                    <line x1="-4" y1="49" x2="4" y2="41" style="stroke:rgb(202,0,0);stroke-width:2" />\
                    </a>\
                    <g id="required' + group.idGroup + '" class="whiteColor">\
                       <line x1="-10" y1="5" x2="-30" y2="5" stroke="black"/>\
                       <path class="SamplePath" d="M-42,-5 C-27,-5 -27,15 -42,15" stroke="black" />\
                       <text id="lolipC" x="-42" y="5" text-anchor="middle" fill="black" dominant-baseline="central" font-size = "10">' + group.requiredPackage.getLength() + '</text>\
                    </g>\
                    <g id="provided' + group.idGroup + '" class="whiteColor">\
                        <line x1="-10" y1="31" x2="-30" y2="31" stroke="black"/>\
                        <circle cx="-42" cy="31" r="11" stroke="black" /> \
                        <text id="lolipD" x="-42" y="31" text-anchor="middle" fill="black" dominant-baseline="central" font-size = "10">' + group.providedPackage.getLength() + '</text>\
                    </g>\
                </g>'
            );
    },
    
    //Method is called if is clicked on icon left arrow in rightview
    drawGroupedVertices: function(group){  
    	var ns_str = 'http://www.w3.org/2000/svg';
    	
    	// ziskani html elementu, do ktereho se bude pridavat vytvoreny element  
    	var svgDocument = $('#svg1 #graph')[0];  	
    	
    	var svg_w = $('#svg1').width();
    	var svg_h_scroll_top =  $('#viewport').scrollTop();
    	var viewport_h =  $('#viewport').height();
    	var svg_w_scroll_left =   $('#viewport').scrollLeft() * -1; // mus� se vyn�sobit -1 proto�e vrac� z�pornou pozici
    	var viewport_w =  $('#viewport').width();
    	
    	
    	var group_selected = this.groupManager.getGroup(group); 
    	
    	var rand_x = Math.floor((Math.random()*200) - 100);
    	var rand_y = Math.floor((Math.random()*200) - 100);
    	
    	var pos_x = group_selected.x;
    	var pos_y = group_selected.y;
    	
    	
    	//obalujici element
    	var svg_elm_g = document.createElementNS(ns_str, 'g');
    	if(pos_x && pos_y){
    		svg_elm_g.setAttributeNS(null, 'transform', 'translate('+ pos_x +','+ pos_y+')');    		
    	} else{
    		svg_elm_g.setAttributeNS(null, 'transform', 'translate('+(svg_w - (svg_w_scroll_left  + viewport_w/2 ) - rand_x) +','+ (svg_h_scroll_top + viewport_h/2 - rand_y)+')');
    	}
    	
    	svg_elm_g.setAttributeNS(null, 'class', 'group_vertices');
    	svg_elm_g.setAttributeNS(null, 'id', 'gv_' + group);
    	
    	            	
    	//rectangle
    	var svg_elm_rect = document.createElementNS(ns_str, 'rect');
	    	svg_elm_rect.setAttributeNS(null,'rx', 4);
	    	svg_elm_rect.setAttributeNS(null,'ry', 4);
	    	svg_elm_rect.setAttributeNS(null,'height',50);
	    	svg_elm_rect.setAttributeNS(null,'width',80);
	    	svg_elm_rect.setAttributeNS(null,'stroke','black');
	    	svg_elm_rect.setAttributeNS(null,'fill','#CFEA9E');
	    	svg_elm_rect.setAttributeNS(null,'style','cursor:pointer');
	    	//svgDocument.appendChild(svg_elm_rect);
	    	svg_elm_g.appendChild(svg_elm_rect);
    	
    	var svg_elm_text = document.createElementNS(ns_str, 'text');    	
	    	svg_elm_text.setAttributeNS(null,'x', 40);
	    	svg_elm_text.setAttributeNS(null,'y', 38);
	    	svg_elm_text.setAttributeNS(null,'font-size',20);
	    	svg_elm_text.setAttributeNS(null,'fill','black');
	    	svg_elm_text.setAttributeNS(null,'text-anchor','middle');
	    	svg_elm_text.setAttributeNS(null,'dominant-baseline','central');
    	
	    	    	
	    	    
	    // symbol uvnitr bunky 
    	var innerText = document.createTextNode(group_selected.groupSymbol[0]);

    	svg_elm_text.appendChild(innerText);
    	
    	//pridani textu do skupiny
    	svg_elm_g.appendChild(svg_elm_text);
    	
    	//pridani do svg
    	svgDocument.appendChild(svg_elm_g);
    	
    	
    	var svg_elm_ab = document.createElementNS(ns_str, 'a'); 
            svg_elm_ab.setAttributeNS(ns_str,'xlink:href', '#');
	        svg_elm_ab.setAttributeNS(null, 'onclick', 'OffScreenKiv.removeAllComponentFromGroup(\''+group+'\'); return false;');
            
	    var svg_elm_r_inner_a = document.createElementNS(ns_str, 'rect');
	    svg_elm_r_inner_a.setAttributeNS(null,'rx', 4);
	    svg_elm_r_inner_a.setAttributeNS(null,'ry', 4);
	    svg_elm_r_inner_a.setAttributeNS(null,'x', 62);
	    svg_elm_r_inner_a.setAttributeNS(null,'y', 4);
	    svg_elm_r_inner_a.setAttributeNS(null,'height', 14);
	    svg_elm_r_inner_a.setAttributeNS(null,'width', 14);
	    svg_elm_r_inner_a.setAttributeNS(null,'stroke','black');
	    svg_elm_r_inner_a.setAttributeNS(null,'fill','#FFFFFF');
	    svg_elm_r_inner_a.setAttributeNS(null,'style','cursor:pointer');
	    
	    var svg_elm_l1_inner_a = document.createElementNS(ns_str, 'line');
	    svg_elm_l1_inner_a.setAttributeNS(null,'x1', 66);
	    svg_elm_l1_inner_a.setAttributeNS(null,'y1', 8);
	    svg_elm_l1_inner_a.setAttributeNS(null,'x2', 73);
	    svg_elm_l1_inner_a.setAttributeNS(null,'y2', 15);
	    svg_elm_l1_inner_a.setAttributeNS(null,'height', 14);
	    svg_elm_l1_inner_a.setAttributeNS(null,'width', 14);
	    svg_elm_l1_inner_a.setAttributeNS(null,'style','stroke:#CA0000;stroke-width:2');

	    var svg_elm_l2_inner_a = document.createElementNS(ns_str, 'line');
	    svg_elm_l2_inner_a.setAttributeNS(null,'x1', 73);
	    svg_elm_l2_inner_a.setAttributeNS(null,'y1', 8);
	    svg_elm_l2_inner_a.setAttributeNS(null,'x2', 66);
	    svg_elm_l2_inner_a.setAttributeNS(null,'y2', 15);
	    svg_elm_l2_inner_a.setAttributeNS(null,'height', 14);
	    svg_elm_l2_inner_a.setAttributeNS(null,'width', 14);
	    svg_elm_l2_inner_a.setAttributeNS(null,'style','stroke:#CA0000;stroke-width:2');
	        
	        
	    svg_elm_ab.appendChild(svg_elm_r_inner_a);
	    svg_elm_ab.appendChild(svg_elm_l1_inner_a);
	    svg_elm_ab.appendChild(svg_elm_l2_inner_a); 
	    
	    //pridani textu do skupiny
		svg_elm_g.appendChild(svg_elm_ab);
    	
		
    	var svg_elm_ab2 = document.createElementNS(ns_str, 'a'); 
    	svg_elm_ab2.setAttributeNS(ns_str,'xlink:href', '#');
    	svg_elm_ab2.setAttributeNS(null, 'onclick', 'OffScreenKiv.showComposeComponents(\''+group +'\');OffScreenKiv.showGroupInRightPanel(\''+group+'\'); return false;');
        
    var svg_elm_r_inner_a2 = document.createElementNS(ns_str, 'rect');
    svg_elm_r_inner_a2.setAttributeNS(null,'rx', 4);
    svg_elm_r_inner_a2.setAttributeNS(null,'ry', 4);
    svg_elm_r_inner_a2.setAttributeNS(null,'x', 42);
    svg_elm_r_inner_a2.setAttributeNS(null,'y', 4);
    svg_elm_r_inner_a2.setAttributeNS(null,'height', 14);
    svg_elm_r_inner_a2.setAttributeNS(null,'width', 14);
    svg_elm_r_inner_a2.setAttributeNS(null,'stroke','black');
    svg_elm_r_inner_a2.setAttributeNS(null,'fill','#FFFFFF');
    svg_elm_r_inner_a2.setAttributeNS(null,'style','cursor:pointer');
    
    //  čára v šipce směr: -
    var svg_elm_l1_inner_a2 = document.createElementNS(ns_str, 'line');
    svg_elm_l1_inner_a2.setAttributeNS(null,'x1', 44);
    svg_elm_l1_inner_a2.setAttributeNS(null,'y1', 11);
    svg_elm_l1_inner_a2.setAttributeNS(null,'x2', 53);
    svg_elm_l1_inner_a2.setAttributeNS(null,'y2', 11);
    svg_elm_l1_inner_a2.setAttributeNS(null,'height', 14);
    svg_elm_l1_inner_a2.setAttributeNS(null,'width', 14);
    svg_elm_l1_inner_a2.setAttributeNS(null,'style','stroke:#000000;stroke-width:2');
    
    // čára v šipce směr: \    
    var svg_elm_l2_inner_a2 = document.createElementNS(ns_str, 'line');
    svg_elm_l2_inner_a2.setAttributeNS(null,'x1', 48);
    svg_elm_l2_inner_a2.setAttributeNS(null,'y1', 6);
    svg_elm_l2_inner_a2.setAttributeNS(null,'x2', 53);
    svg_elm_l2_inner_a2.setAttributeNS(null,'y2', 11);
    svg_elm_l2_inner_a2.setAttributeNS(null,'height', 14);
    svg_elm_l2_inner_a2.setAttributeNS(null,'width', 14);
    svg_elm_l2_inner_a2.setAttributeNS(null,'style','stroke:#000000;stroke-width:2');

    //  čára v šipce směr: / 
    var svg_elm_l3_inner_a2 = document.createElementNS(ns_str, 'line');
    svg_elm_l3_inner_a2.setAttributeNS(null,'x1', 48);
    svg_elm_l3_inner_a2.setAttributeNS(null,'y1', 16);
    svg_elm_l3_inner_a2.setAttributeNS(null,'x2', 53);
    svg_elm_l3_inner_a2.setAttributeNS(null,'y2', 11);
    svg_elm_l3_inner_a2.setAttributeNS(null,'height', 14);
    svg_elm_l3_inner_a2.setAttributeNS(null,'width', 14);
    svg_elm_l3_inner_a2.setAttributeNS(null,'style','stroke:#000000;stroke-width:2');    
    
    
    svg_elm_ab2.appendChild(svg_elm_r_inner_a2);
    svg_elm_ab2.appendChild(svg_elm_l1_inner_a2);
    svg_elm_ab2.appendChild(svg_elm_l2_inner_a2);
    svg_elm_ab2.appendChild(svg_elm_l3_inner_a2);
    
    
    //pridani textu do skupiny
	svg_elm_g.appendChild(svg_elm_ab2);
    
    
	var svg_elm_ab3 = document.createElementNS(ns_str, 'a');
	svg_elm_ab3.setAttributeNS(ns_str,'xlink:href', '#');
	svg_elm_ab3.setAttributeNS(null, 'onclick', 'OffScreenKiv.showDecomposeComponents(\''+group+'\'); return false;');
  
    
    //ikonka pro rozlozeni komponent v grafu
    var svg_elm_r_inner_a3 = document.createElementNS(ns_str, 'rect');
    svg_elm_r_inner_a3.setAttributeNS(null,'rx', 4);
    svg_elm_r_inner_a3.setAttributeNS(null,'ry', 4);
    svg_elm_r_inner_a3.setAttributeNS(null,'x', 22);
    svg_elm_r_inner_a3.setAttributeNS(null,'y', 4);
    svg_elm_r_inner_a3.setAttributeNS(null,'height', 14);
    svg_elm_r_inner_a3.setAttributeNS(null,'width', 14);
    svg_elm_r_inner_a3.setAttributeNS(null,'stroke','black');
    svg_elm_r_inner_a3.setAttributeNS(null,'fill','#FFFFFF');
    svg_elm_r_inner_a3.setAttributeNS(null,'style','cursor:pointer');
    
    //kolečko
   // <circle cx="-42" cy="35" r="11" stroke="black" /> \
    var svg_elm_r_inner_c3 = document.createElementNS(ns_str, 'circle');
    svg_elm_r_inner_c3.setAttributeNS(null,'cx', 29);
    svg_elm_r_inner_c3.setAttributeNS(null,'cy', 11);
    svg_elm_r_inner_c3.setAttributeNS(null,'r', 5);
    svg_elm_r_inner_c3.setAttributeNS(null,'fill','yellow');
    svg_elm_r_inner_c3.setAttributeNS(null,'stroke','black');
    svg_elm_r_inner_c3.setAttributeNS(null,'class','decompose');
    
    var svg_elm_l3_inner_l3 = document.createElementNS(ns_str, 'line');    
    svg_elm_l3_inner_l3.setAttributeNS(null,'x1', 24);
    svg_elm_l3_inner_l3.setAttributeNS(null,'y1', 14);
    svg_elm_l3_inner_l3.setAttributeNS(null,'x2', 34);
    svg_elm_l3_inner_l3.setAttributeNS(null,'y2', 14);
    svg_elm_l3_inner_l3.setAttributeNS(null,'stroke','black');
    svg_elm_l3_inner_l3.setAttributeNS(null,'class','compose');
    svg_elm_l3_inner_l3.setAttributeNS(null,'style','stroke-width:2');    
    
    
    svg_elm_ab3.appendChild(svg_elm_r_inner_a3); 
    svg_elm_ab3.appendChild(svg_elm_r_inner_c3);
    
    svg_elm_ab3.appendChild(svg_elm_l3_inner_l3);
    
	
	
	//pridani textu do skupiny
	svg_elm_g.appendChild(svg_elm_ab3);	
	
	$('#gv_' + group + ' .compose').hide();
	$('#gv_' + group).mousedown(ViewportManager.groupVertexMousedownHandler);
	
	$('#gv_' + group).mouseup(ViewportManager.viewportEndDraggingHandler);
	
	this.moveElementAfter(svg_elm_g, group);
		    	
    },    
    
    /**
     * Zobrazení seskupených komponent v grafu.
     * 
     * @param group_name
     * @param decompose
     */
    showComposeComponents:function(group_name,  decompose){
    	group2 = this.groupManager.getGroup(group_name);
    	
    	group2.decompose = decompose;
    	
    	
    	$('#gv_' + group_name + ' .compose').hide();
    	$('#gv_' + group_name + ' .decompose').show();
    	
    	
    	var xforms = $('#gv_' + group_name)[0].getAttribute('transform');
    	var parts  = /translate\(\s*([^\s,)]+)[ ,]([^\s,)]+)/.exec(xforms);
    	posX = parts[1];
    	posY = parts[2];
    
    	   	
    	posX_reset = posX;
    	posY_reset = posY;
    	
    	//zv�t�en� seskupen� komponent
    	var rect = $('#gv_' + group_name).children('rect');
    	rect.attr('height', 50);

    	id_vert = 0;
    	
    	var component_max_width = 0;
    	$('ul[data-groupid=' + group_name + '] li').each(function() {
    		id_vert = $(this).find('p').attr('data-vertexid');
    		//posun pozice, aby byla komponenta vycentrovana
            hidden_component_width = $('g#vertex' + id_vert + ' rect').attr('width');
            if ( hidden_component_width > component_max_width) {
            	component_max_width	= hidden_component_width;            	
            }
    	});
    	
    	console.log("pos_X_reset: " + posX_reset);
    	//nastaveni pozice na 80
    	rect.attr('width', 80); 
    	posX_reset = parseFloat(posX_reset) + (parseFloat(component_max_width) / 2) - 40;
    	posX = posX_reset;
    	$('#gv_' + group_name).attr('transform','translate(' + posX_reset + ',' + posY_reset+ ')');
    	 
    	group2.x = posX;
    	group2.y = posY;
    	
    	
    	//nastaveni pozice prvku
    	id_vert = 0;
    	
    	$('ul[data-groupid=' + group_name + '] li').each(function() {    		
    		id_vert = $(this).find('p').attr('data-vertexid');
    		console.log(group2.groupItems[id_vert]);
    	      		
	       	
	            var newX;
	            var newY;
	            
	            var lollipop;
	            posX = posX_reset;
	            posX = parseFloat(posX);
	            posY = parseFloat(posY);
	            	            
	            //posun pozice, aby byla komponenta vycentrovana
	            hidden_component_width = $('g#vertex' + id_vert + ' rect').attr('width');
	            
	            //vystredeni na stred
	            posX = posX  - (hidden_component_width/2) + 40;	            

	    		group2.groupItems[id_vert].x = posX;
	    		group2.groupItems[id_vert].y = posY;
	            
	            $currentTarget = $('g#vertex' + id_vert);
	    		$currentTarget.attr('transform', 'translate('+posX+','+posY+')');
	    		$currentTarget.trigger('click',{move_edges:true});
	            
	            for(var i = 0; i< group2.groupItems[id_vert].edges.length; i++){
	                var edge = group2.groupItems[id_vert].edges[i];
	                var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
	                var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
	                if(edge.from.id == id_vert){
	                    newX = group2.groupItems[id_vert].edges[i].to.x + sizeOfRectTo/2;
	                    newY = group2.groupItems[id_vert].edges[i].to.y + 13;
	                    lollipop = getLollipopPosition(posX + sizeOfRectFrom/2, posY +13 , newX, newY);
	                    
	                    edge.$selector.children("line").attr('x1', posX + sizeOfRectFrom/2);
	                    edge.$selector.children("line").attr('y1', posY + 13);
	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                    
	                    //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
	                    if ( $('g#vertex'+ edge.to.id ).css('display') != 'none' 
	                    	//|| $('#rightPanel #li'+edge.to.id).is(':visible') == false) 
	                    	|| 
	                    	  ( $('#rightPanel li#li'+edge.to.id).is(':visible') == false &&
	                    		$('#rightPanel li#li'+edge.to.id).length > 0  
	                    	   )
	                    	){
	                    	edge.$selector.show();	
	                    }
	                    
	                } else {
	                    newX = group2.groupItems[id_vert].edges[i].from.x + sizeOfRectFrom/2;
	                    newY = group2.groupItems[id_vert].edges[i].from.y + 13;
	                    lollipop = getLollipopPosition(newX, newY, posX + sizeOfRectTo/2, posY + 13);
	                    
	                    edge.$selector.children("line").attr('x2', posX + sizeOfRectTo/2);
	                    edge.$selector.children("line").attr('y2', posY + 13);
	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                    
	                  //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
	                    if ( $('g#vertex'+ edge.from.id ).css('display') != 'none' 
	                    	 ||  ($('#rightPanel #li'+edge.from.id).is(':visible') == false &&
                    			$('#rightPanel li#li'+edge.from.id).length > 0 )
	                    	) {
	                    	edge.$selector.show();	
	                    }
	                }
	            }
	                  
	              
	            
	            //$(this).find('img').trigger('click');
	            
	            //skryte komponenty
	            $currentTarget.hide();
	            //$currentTarget.show();
            
	    		
	    		
    		//movecomponent
    		});
    	
    	
    	moveElementTopSVG("graph", "gv_"+group_name);
    	$('#rightPanel div#group' + group_name).hide();
    	
    	
    },
    
    
    // Provede rozlozeni skupiny komponent v grafu
    // zobrazi komponenty pod sebou
    //only_move = true pote se provede pouze presun 
    showDecomposeComponents:function(group_name){
    	
    	group2 = this.groupManager.getGroup(group_name);
    	
    	if ( group2.decompose == true) {
    		this.showComposeComponents(group_name,false);
    		return true;
    	}

    	group2.decompose = true;
    	
    	$('#gv_' + group_name + ' .decompose').hide();
    	$('#gv_' + group_name + ' .compose').show();
    	
    	
    	var xforms = $('#gv_' + group_name)[0].getAttribute('transform');
    	var parts  = /translate\(\s*([^\s,)]+)[ ,]([^\s,)]+)/.exec(xforms);
    	posX = parts[1];
    	posY = parts[2];
    
    	
    	var _pos_Y = parseFloat(posY) + 60;
    	
    	posX_reset = posX;
    	posY_reset = posY;
    	
    	
    	group2.x = posX;
    	group2.y = posY;
    	
    	
    	
    	//zv�t�en� seskupen� komponent
    	var rect = $('#gv_' + group_name).children('rect');
    	var height_grouped_component = group2.groupItemsLength * 34 + 55;
    	rect.attr('height', height_grouped_component); 
    	
    	//maximalni sirka komponenty ve skupine - podle teto sirky se nastavi sirka cele skupiny
    	var component_max_width = 0;
    	
    	//nastaveni pozice prvku
    	id_vert = 0;
    	
    	$('ul[data-groupid=' + group_name + '] li').each(function() {    		
    		id_vert = $(this).find('p').attr('data-vertexid');
    		console.log(group2.groupItems[id_vert]);
    	    
    		var graph_elmnt = document.getElementById("graph");
    		var item = document.getElementById("vertex"+id_vert);   
        	graph_elmnt.removeChild(item);
        	graph_elmnt.appendChild(item);
    		    		
	            var newX;
	            var newY;
	            
	            var lollipop;
	            posX = posX_reset;
	            posX = parseFloat(posX);
	            //posY = parseFloat(posY);
	            
	            posY = _pos_Y;
	            _pos_Y = _pos_Y + 26;
	            
	            //posun pozice, aby byla komponenta vycentrovana
	            hidden_component_width = $('g#vertex' + id_vert + ' rect').attr('width');
	            if ( hidden_component_width > component_max_width) {
	            	component_max_width	= hidden_component_width;            	
	            }
	            	
	            //vystredeni na stred
	            posX = posX  - (hidden_component_width/2) + 40;	            

	    		group2.groupItems[id_vert].x = posX;
	    		group2.groupItems[id_vert].y = posY;
	            
	            $currentTarget = $('g#vertex' + id_vert);
	    		$currentTarget.attr('transform', 'translate('+posX+','+posY+')');
	    		$currentTarget.trigger('click',{move_edges:true});
	            
	            for(var i = 0; i< group2.groupItems[id_vert].edges.length; i++){
	                var edge = group2.groupItems[id_vert].edges[i];
	                var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
	                var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
	                if(edge.from.id == id_vert){
	                    newX = group2.groupItems[id_vert].edges[i].to.x + sizeOfRectTo/2;
	                    newY = group2.groupItems[id_vert].edges[i].to.y + 13;
	                    lollipop = getLollipopPosition(posX + sizeOfRectFrom/2, posY +13 , newX, newY);
	                    
	                    edge.$selector.children("line").attr('x1', posX + sizeOfRectFrom/2);
	                    edge.$selector.children("line").attr('y1', posY + 13);
	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                    
	                    //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
	                    if ( $('g#vertex'+ edge.to.id ).css('display') != 'none' 
	                    	//|| $('#rightPanel #li'+edge.to.id).is(':visible') == false) 
	                    	|| 
	                    	  ( $('#rightPanel li#li'+edge.to.id).is(':visible') == false &&
	                    		$('#rightPanel li#li'+edge.to.id).length > 0  
	                    	   )
	                    	){
	                    	edge.$selector.show();	
	                    }
	                    
	                } else {
	                    newX = group2.groupItems[id_vert].edges[i].from.x + sizeOfRectFrom/2;
	                    newY = group2.groupItems[id_vert].edges[i].from.y + 13;
	                    lollipop = getLollipopPosition(newX, newY, posX + sizeOfRectTo/2, posY + 13);
	                    
	                    edge.$selector.children("line").attr('x2', posX + sizeOfRectTo/2);
	                    edge.$selector.children("line").attr('y2', posY + 13);
	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                    
	                  //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
	                    if ( $('g#vertex'+ edge.from.id ).css('display') != 'none' 
	                    	 ||  ($('#rightPanel #li'+edge.from.id).is(':visible') == false &&
                    			$('#rightPanel li#li'+edge.from.id).length > 0 )
	                    	) {
	                    	edge.$selector.show();	
	                    }
	                }
	            }
	            
	           
	            $currentTarget.show();
            
	    		
	    		
    		//movecomponent
    		});
    	
    	// puvodni sirka 80, pricte se polovina
    	posX_reset = posX_reset - (component_max_width / 2) + 40;
    	
    	$('#gv_' + group_name).attr('transform','translate(' + posX_reset + ',' + posY_reset+ ')');
    	rect.attr('width', component_max_width); 

    	//skryti skupiny v rightpanelu
    	$('#rightPanel div#group' + group_name).hide();

    },
    
    
    
    moveElementAfter:function(group_elm, group_name){
    	console.log(group_elm);
    	var xforms = group_elm.getAttribute('transform');
    	var parts  = /translate\(\s*([^\s,)]+)[ ,]([^\s,)]+)/.exec(xforms);
    	posX = parts[1];
    	posY = parts[2];
    	//posX posY - souradnice
    	
    	posX_reset = posX;
    	
    	group2 = this.groupManager.getGroup(group_name);
    	group2.x = posX;
    	group2.y = posY;
    	//nastaven� pozice prvk�
    	id_vert = 0;
    	
    	$('ul[data-groupid=' + group_name + '] li').each(function() {    		
    		id_vert = $(this).find('p').attr('data-vertexid');
    		console.log(group2.groupItems[id_vert]);
    		
	            var newX;
	            var newY;
	            
	            var lollipop;
	            posX = posX_reset;
	            posX = parseFloat(posX);
	            posY = parseFloat(posY);
	            
	            //posun pozice, aby byla komponenta vycentrovana
	            hidden_component_width = $('g#vertex' + id_vert + ' rect').attr('width');
	            
	            //vystredeni na stred
	            posX = posX  - (hidden_component_width/2) + 40;	            

	    		group2.groupItems[id_vert].x = posX;
	    		group2.groupItems[id_vert].y = posY;
	            
	            $currentTarget = $('g#vertex' + id_vert);
	    		$currentTarget.attr('transform', 'translate('+posX+','+posY+')');
	    		$currentTarget.trigger('click',{move_edges:true});
	            
	            for(var i = 0; i< group2.groupItems[id_vert].edges.length; i++){
	                var edge = group2.groupItems[id_vert].edges[i];
	                var sizeOfRectFrom = getSizeOfRectangle(edge.from.name);
	                var sizeOfRectTo = getSizeOfRectangle(edge.to.name);
	                if(edge.from.id == id_vert){
	                    newX = group2.groupItems[id_vert].edges[i].to.x + sizeOfRectTo/2;
	                    newY = group2.groupItems[id_vert].edges[i].to.y + 13;
	                    lollipop = getLollipopPosition(posX + sizeOfRectFrom/2, posY +13 , newX, newY);
	                    
	                    edge.$selector.children("line").attr('x1', posX + sizeOfRectFrom/2);
	                    edge.$selector.children("line").attr('y1', posY + 13);
	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                    
	                    //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
	                    if ( $('g#vertex'+ edge.to.id ).css('display') != 'none' 
	                    	//|| $('#rightPanel #li'+edge.to.id).is(':visible') == false) 
	                    	|| 
	                    	  ( $('#rightPanel li#li'+edge.to.id).is(':visible') == false &&
	                    		$('#rightPanel li#li'+edge.to.id).length > 0  
	                    	   )
	                    	){
	                    	edge.$selector.show();	
	                    }
	                    
	                } else {
	                    newX = group2.groupItems[id_vert].edges[i].from.x + sizeOfRectFrom/2;
	                    newY = group2.groupItems[id_vert].edges[i].from.y + 13;
	                    lollipop = getLollipopPosition(newX, newY, posX + sizeOfRectTo/2, posY + 13);
	                    
	                    edge.$selector.children("line").attr('x2', posX + sizeOfRectTo/2);
	                    edge.$selector.children("line").attr('y2', posY + 13);
	                    edge.$selector.children("g").attr('transform', 'rotate(' + lollipop.angle + ',' + lollipop.x + ',' + lollipop.y  + ') translate('+ lollipop.x + ',' + lollipop.y  + ')');
	                    
	                  //hrana k vrcholu se zobrazi pouze pokud je vrchol zobrazen
	                    if ( $('g#vertex'+ edge.from.id ).css('display') != 'none' 
	                    	 ||  ($('#rightPanel #li'+edge.from.id).is(':visible') == false &&
                    			$('#rightPanel li#li'+edge.from.id).length > 0 )
	                    	) {
	                    	edge.$selector.show();	
	                    }
	                }
	            }
	                  
	            
	            //skryti komponenty
	            $currentTarget.hide();
	            //$currentTarget.show();
            
	    		
	    		
    		//movecomponent
    		});
    	
    	$('#rightPanel div#group' + group_name).hide();
    	//skryt� prvk�
    	
    	
    	// Setting
    	//myElement.setAttribute('transform','translate(30,100)');
    },

    
    /**
     * Zobrazeni skupiny komponent v pravem sloupci.
     */
    showGroupInRightPanel:function(group_name){
    	$('#rightPanel #group'+group_name).show();
    	
    	//odstraneni skupiny komponent
    	$('#graph #gv_'+group_name).remove();
    	
    	//skryt� 
    	group2 = this.groupManager.getGroup(group_name);
    	   	
    	$('ul[data-groupid=' + group_name + '] li').each(function() {    		
    		id_vert = $(this).find('p').attr('data-vertexid');
    		//console.log(group2.groupItems[id_vert]);
    		 	            
	            for(var i = 0; i< group2.groupItems[id_vert].edges.length; i++){
	                var edge = group2.groupItems[id_vert].edges[i];
	               
	                if(edge.from.id == id_vert){	                   
	                    edge.$selector.hide();
	                } else {	                  
	                    edge.$selector.hide();
	                }
	            }
	                  
	                  
    		});
    	
    },
    
    /**
     * Odstraneni vsech komponent ze skupiny
     * @param group
     */
    removeAllComponentFromGroup: function(group){    	
    	
    	//show group of components in graph
    	$('#rightPanel #group'+group+' .deleteItemGroup').each(function() {
    		$(this).trigger('click');    		
    	});
    	
    	$('#svg1 #gv_' + group).remove();

    },    
    
    /**
     * Count height of group in dependency of count of item in group.
     * Parameters: group - group
     */
    countHeightOfGroup: function(group){
        var heightOneItem = 17;
        var height = heightOneItem*group.getGroupItemsLength();
        return height;
    },
    
    /**
     * Edit height of group in dependency of count of item in group.
     * Parameters: group - group
     */
    editHeightOfGroup: function(group){
        var height = this.countHeightOfGroup(group);
        var svg_new_height = height;
        var new_height = height;
        if ( svg_new_height < 60 ) {
        	svg_new_height = 70;
        	new_height = 56;
        }else{
        	svg_new_height += 18;        	
        }
        $("#svgGroup" + group.idGroup).attr('height', svg_new_height);
        $("#gr" + group.idGroup).children('rect').attr('height', new_height);
    }, 
    
    /**
     * Update count of provided end required packages.
     */
    updateCountOfProvidedAndRequired: function(group){
        $("#provided" + group.idGroup).children('text').text(group.providedPackage.getLength());
        $("#required" + group.idGroup).children('text').text(group.requiredPackage.getLength());
    },
    
    /**
     * Cancels highlighting of all neighbors (provided) of vertex in group.
     * Parameters: e - event
     */
    groupDisHighlightProvided: function(e){
        console.debug('ENTRY groupDisHightlightProvided');
        var providedElement = e.target.parentElement.id;
        var id = providedElement.substr(8);
        var group = this.groupManager.getGroup(id);
        for (var key in group.groupItems){
            if(group.groupItems.hasOwnProperty(key)){
                this.disHighlightProvided(providedElement, group.groupItems[key]);
            }
        }
        
        $('#' + providedElement).unbind('click', this.groupDisHightlightProvided);
        $('#' + providedElement).click(this.groupHighlightProvided);
        
        if(($('#provided' + id).attr('class') != 'whiteColor') && ($('#required' + id).attr('class') != 'whiteColor')){
            $('#gr' + id).unbind('click',this.groupHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupDisHighlightRequiredAndProvided);
        } 
        else {
            $('#gr' + id).unbind('click', this.groupDisHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupHighlightRequiredAndProvided);
        }
        console.debug('EXIT groupDisHightlightProvided');
    },
    
    /**
     * Highlights  all neighbors (provided) of vertex in group.
     * Parameters: e - event
     */
    groupHighlightProvided: function(e){
        console.debug("ENTRY groupHighlightProvided");
        var providedElement = e.target.parentElement.id;
        var id = providedElement.substr(8);
        var group = this.groupManager.getGroup(id);
        for (var key in group.groupItems){
            if(group.groupItems.hasOwnProperty(key)){
                this.highlightProvided(providedElement, group.groupItems[key]);
            }
        }
        
        $('#' + providedElement).unbind('click',this.groupHighlightProvided);
        $('#' + providedElement).click(this.groupDisHighlightProvided);
        
        if(($('#provided' + id).attr('class') != 'whiteColor') && ($('#required' + id).attr('class') != 'whiteColor')){
            $('#gr' + id).unbind('click',this.groupHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupDisHighlightRequiredAndProvided);
        } else {
            $('#gr' + id).unbind('click', this.groupDisHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupHighlightRequiredAndProvided);
        }
        console.debug("EXIT groupHighlightProvided");
    },
    
    
    /**
     * Cancels highlighting of all neighbors (required) of vertex in group.
     * Parameters: e - event
     */
    groupDisHighlightRequired: function(e){
        console.info('ENTRY groupDisHightlightRequired');
        var providedElement = e.target.parentElement.id;
        var id = providedElement.substr(8);
        var group = this.groupManager.getGroup(id);
        for (var key in group.groupItems){
            if(group.groupItems.hasOwnProperty(key)){
                this.disHighlightRequired(providedElement, group.groupItems[key]);
            }
        }
        
        $('#' + providedElement).unbind('click', this.groupDisHightlightRequired);
        $('#' + providedElement).click(this.groupHighlightRequired);
        
        if(($('#provided' + id).attr('class') != 'whiteColor') && ($('#required' + id).attr('class') != 'whiteColor')){
            $('#gr' + id).unbind('click',this.groupHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupDisHighlightRequiredAndProvided);
        } 
        else {
            $('#gr' + id).unbind('click', this.groupDisHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupHighlightRequiredAndProvided);
        }
        console.info('EXIT groupDisHightlightRequired');
    },
    
    /**
     * Highlights  all neighbors (required) of vertex in group.
     * Parameters: e - event
     */
    groupHighlightRequired: function(e){
        console.info("ENTRY groupHighlightRequired");
        var providedElement = e.target.parentElement.id;
        var id = providedElement.substr(8);
        var group = this.groupManager.getGroup(id);
        for (var key in group.groupItems){
            if(group.groupItems.hasOwnProperty(key)){
                this.highlightRequired(providedElement, group.groupItems[key]);
            }
        }
        
        $('#' + providedElement).unbind('click',this.groupHighlightRequired);
        $('#' + providedElement).click(this.groupDisHighlightRequired);
        
        if(($('#provided' + id).attr('class') != 'whiteColor') && ($('#required' + id).attr('class') != 'whiteColor')){
            $('#gr' + id).unbind('click',this.groupHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupDisHighlightRequiredAndProvided);
        } else {
            $('#gr' + id).unbind('click', this.groupDisHighlightRequiredAndProvided);
            $('#gr' + id).click(this.groupHighlightRequiredAndProvided);
        }
        console.info("EXIT groupHighlightRequired");
    },
    
    /**
     * Highlights  all neighbors of vertex in group.
     * Parameters: e - event
     */
    groupHighlightRequiredAndProvided: function(e){
        console.info("ENTRY groupHighlightRequiredAndProvided");
        var providedElement = e.target.parentElement.id;
        if(providedElement.indexOf("gr") != -1){
            var id = providedElement.substr(2);
            var group = this.groupManager.getGroup(id);
            for (var key in group.groupItems){
                if(group.groupItems.hasOwnProperty(key)){
                    this.highlihgtAll(id, group.groupItems[key]);
                }
            }
        
            $('#' + providedElement).unbind('click',this.groupHighlightRequiredAndProvided);
            $('#' + providedElement).click(this.groupDisHighlightRequiredAndProvided);
            $('#required' + id).unbind('click',this.groupHighlightRequired);
            $('#required' + id).click(this.groupDisHighlightRequired);
            $('#provided' + id).unbind('click',this.groupHighlightProvided);
            $('#provided' + id).click(this.groupDisHighlightProvided);
        }
        console.info("EXIT groupHighlightRequiredAndProvided");
    },
    
    /**
     * Cancels highlighting of all neighbors of vertex in group.
     * Parameters: e - event
     */
    groupDisHighlightRequiredAndProvided: function(e){
        console.info("ENTRY groupDisHighlightRequiredAndProvided");
        var providedElement = e.target.parentElement.id;
        if(providedElement.indexOf("gr") != -1){
            var id = providedElement.substr(2);
            var group = this.groupManager.getGroup(id);
            for (var key in group.groupItems){
                if(group.groupItems.hasOwnProperty(key)){
                    this.disHighlihgtAll(id, group.groupItems[key]);
                }
            }
        
            $('#' + providedElement).unbind('click',this.groupDisHighlightRequiredAndProvided);
            $('#' + providedElement).click(this.groupHighlightRequiredAndProvided);
            
            $('#required' + id).unbind('click',this.groupDisHighlightRequired);
            $('#required' + id).click(this.groupHighlightRequired);
            $('#provided' + id).unbind('click',this.groupDisHighlightProvided);
            $('#provided' + id).click(this.groupHighlightProvided);
            console.info("EXIT groupDisHighlightRequiredAndProvided");
        }
    },
    
    /**
     * Cancels highlighting of vertices which were searched.
     */
    deselectHighlightSearchedVertices: function(){
        for(var key in this.vertexSearchHighlighting){
            this.vertexSearchHighlighting[key].removeAttr("style");
            delete this.vertexSearchHighlighting[key];
        }
        $("#countOfFinded").html("0");
    },
    
    /**
     * Highlights all vertex if their name contains searched string.
     */
    search: function(){
        var vertices = GraphManager.graph.vertices;
        var text = $("#searchText").val();
        this.deselectHighlightSearchedVertices();
        if(text == ""){
            $("#searchText").qtip({
                content: {
                    text: "Please fill out this field."
                },
                style: {
                    classes: "ui-tooltip-green ui-tooltip-rounded ui-tooltip-shadow"
                }
            }).qtip("show");
            
            $(window).mousemove(function(){
                setTimeout("OffScreenKiv.hideTooltip()", 2000);
                $(this).unbind("mousemove");
            });
            return;
        }
        var countOfFinded = 0;
        for(var i = 0; i < vertices.length; i++){
            if(vertices[i].name.toLowerCase().indexOf(text.toLowerCase()) >= 0 && vertices[i].excluded != true){
                $(vertices[i].$selector).css("fill", "orange");
                this.vertexSearchHighlighting[vertices[i].symbolicName] = vertices[i].$selector;
                countOfFinded++;
            }
        }
        
        $("#countOfFinded").html(countOfFinded);
    },
    
    /**
     * Hide tooltip of search textfield.
     */
    hideTooltip: function(){
        $("#searchText").qtip("hide");
        $("#searchText").qtip("destroy");
    },
    
    /**
     * Excludes vertices whith the most edges from graph to the right panel.
     */
    excludeVerticesWithMostEdges: function(){
        var vertices = GraphManager.graph.vertices;
        var sortedMappingToVertex = new Array(vertices.length);
        
        console.info(GraphManager.graph.vertices.toString());
        for(var j = 0; j < vertices.length; j++){
            sortedMappingToVertex[j] = j;
        }
        sortedMappingToVertex.sort(function(a, b) {
            if(vertices[a].edges.length > vertices[b].edges.length){
                return -1;
            }
            if(vertices[a].edges.length == vertices[b].edges.length){
                return 0;
            }
            return 1;
        });
        var countExcludedVertices = Math.round(sortedMappingToVertex.length*0.15);
        var selector;
        var vertex;
        if(countExcludedVertices >= 1){
            $('input[name="actionMove"]:eq(1)').click();
        }
        
        for(var i = 0; i < countExcludedVertices; i++){
            vertex = vertices[sortedMappingToVertex[i]];
            if(!vertex.excluded){
                selector = $("#vertex"+vertex.id);
                var e = jQuery.Event("mousedown");
                e.which = 1;
                e.target = selector.children(0).get(0);
                selector.trigger(e);
            }
        }
    },
    
    /**
     * Merge vertices whith the most edges to one group and excludes them from graph to the right panel.
     */
    excludeVerticesWithMostEdgesToGroup: function(){
        var vertices = GraphManager.graph.vertices;
        var sortedMappingToVertex = new Array(vertices.length);
        
        console.info(GraphManager.graph.vertices.toString());
        for(var j = 0; j < vertices.length; j++){
            sortedMappingToVertex[j] = j;
        }
        
        sortedMappingToVertex.sort(function(a, b) {
            if(vertices[a].edges.length > vertices[b].edges.length){
                return -1;
            }
            if(vertices[a].edges.length == vertices[b].edges.length){
                return 0;
            }
            return 1;
        });
        var countExcludedVertices = Math.round(sortedMappingToVertex.length*0.15);
        var vertex;
        if ( countExcludedVertices >= 1 ) {
            $('input[name="actionMove"]:eq(1)').click();
        }
        
        var symbol = this.markSymbol.getMarkSymbol();
        var group;
        var idGroup;
        for(var i = 0; i < countExcludedVertices; i++){
            vertex = vertices[sortedMappingToVertex[i]];
            if(!vertex.excluded){
                vertex.symbol = symbol;
                idGroup = symbol[1].substring(1, symbol[1].length)+symbol[0];
                if(i == 0){
                    this.addItemToContextMenu(symbol, vertex.id, vertex.name);
                    group = new Group(vertex.symbol, idGroup);
                    this.groupManager.addGroupToList(idGroup, group);
                    this.createSvgForGroup(group, symbol);
                }
                this.addVertexToGroup(idGroup, $("#vertex"+vertex.id));
            }
        }
    }
};
