/**
 * The class which ensures zoom.
 */
var Zoom = new Class ({
    CONST_ZOOM_100: 1,
    CONST_ZOOM_INDEX_100: 8,
    currentZoom: 0,
    currentZoomIndex: 0,
    
    CONST_ZOOM_VALUES: [10, 25, 40, 50, 60, 70, 80, 90, 100, 125, 150, 200, 300, 400, 500],
    height: 0,
    width: 0,
    mouseX: 0,
    mouseY: 0,
    
    
    /**
     * Constructor. Initial setting.
     */
    initialize: function(){
        console.debug("ENTRY Zoom: initialize");
        this.currentZoom = this.CONST_ZOOM_100;
        this.currentZoomIndex = this.CONST_ZOOM_INDEX_100;
       
        $(document).mousemove(function(e) {
            mouseX = e.pageX;
            mouseY = e.pageY - 100; //odecteni horniho okraje od viewportu
        }).mouseover();
        
        console.debug("EXIT Zoom: initialize");
    },
    
    /**
     * Get current zoom value from string.
     * Parameters: scale - string which will be parsed
     * Returns float value of zoom.
     */
    getZoomValue: function(scale){
        console.debug("ENTRY Zoom: getZoomValue");
        var currentScale = $("#scale").attr('transform');
        console.debug("EXIT Zoom: getZoomValue");
        return scaleInt = parseFloat(currentScale.substring(6,(currentScale.length-1))) + scale;
    },
    
    /**
     * Gets zoom step (no per cent).
     * Parameters: zoomStepInPercent - zoom step in per cent
     */
    getZoomStep: function(zoomStepInPercent){
        console.debug("ENTRY Zoom: getZoomStep");
        console.debug("EXIT Zoom: getZoomStep");
        return zoomStepInPercent/100.0;  
    },
    
    /**
     * This method ensures zoom in.
     */
    zoomIn: function(){
        console.debug("ENTRY Zoom: zoomIn");
        if(this.currentZoomIndex >= this.CONST_ZOOM_VALUES.length-1){
            return;
        }
        
        var viewport_pos_top_bef_zoom = $('#viewport').scrollTop();//pozice odshora
        var viewport_pos_left_bef_zoom = $('#viewport').scrollLeft();//pozice odshora
        var svg_width_bef = $('#svg1').width();//pozice odshora
        var svg_height_bef = $('#svg1').height();//pozice odshora
        
        
        $("#zoomOut").removeAttr("disabled");
        $("#zoomOut img").attr("src", "images/zoom_out.png");
        this.currentZoomIndex++;
        var zoomStepInPercent = this.CONST_ZOOM_VALUES[this.currentZoomIndex];
        this.currentZoom = this.getZoomStep(zoomStepInPercent);
        var graph = $("#graph");
        graph.attr('transform', 'scale('+ this.currentZoom + ')');
        
        GraphManager.setSizeOfSvg();
        graph.attr('transform', 'scale('+ this.currentZoom + ') ' +  GraphManager.centerGraphInViewport(this.currentZoom));
        $("#zoomValue").html(this.CONST_ZOOM_VALUES[this.currentZoomIndex] + "%");
        
        
        var viewport_pos_top_after_zoom = $('#viewport').scrollTop();    //pozice odshora
        var viewport_pos_left_after_zoom = $('#viewport').scrollLeft();  //pozice odshora
                     
        
        //pokud se rozsiruje #svg1
       if ( viewport_pos_top_bef_zoom != viewport_pos_top_after_zoom ) {        	
            var svg_height_after = $('#svg1').height();//pozice odshora
           
            var new_viewport_top = (mouseY + viewport_pos_top_bef_zoom ) / svg_height_bef;
      
        	new_viewport_top = (new_viewport_top * svg_height_after) - mouseY ;
        	
        	var diff_konst = 0;
        	if (mouseX < ($('#viewport').height() / 2) ){  
        		diff_konst = diff_konst * -1;        		
        	}
        	$('#viewport').scrollTop( (new_viewport_top)  + diff_konst * new_viewport_top);
        	        	
        }
        
        
        
        if ( viewport_pos_left_bef_zoom != viewport_pos_left_after_zoom ) {
        	var viewport_width = $('#viewport').width();
        	
        	var svg_width_after = $('#svg1').width();//pozice odshora
                        
            viewport_pos_left_bef_zoom *= -1;
            var new_viewport_left = (viewport_width - mouseX + viewport_pos_left_bef_zoom ) / svg_width_bef;
            
            new_viewport_left = (new_viewport_left * svg_width_after) - (viewport_width - mouseX);

            var diff_konst = 0;
        	if (mouseY < ($('#viewport').width() / 2) ){  
        		diff_konst = diff_konst * -1;        		
        	}
        	new_viewport_left *=-1;
        	$('#viewport').scrollLeft( new_viewport_left  - (diff_konst * new_viewport_left));
        }
        
        if(this.currentZoomIndex >= this.CONST_ZOOM_VALUES.length-1){
            $("#zoomIn").attr("disabled", "disabled");
            $("#zoomIn img").attr("src", "images/zoom_in_disabled.png");
        }
       
        console.debug("EXIT Zoom: zoomIn");
    },
    
    /**
     * This method ensures zoom out.
     */
    zoomOut: function(){
        console.debug("ENTRY Zoom: zoomOut");
        if(this.currentZoomIndex <= 0){
            return;
        }
        

        var viewport_pos_top_bef_zoom = $('#viewport').scrollTop();//pozice odshora
        var viewport_pos_left_bef_zoom = $('#viewport').scrollLeft();//pozice odshora
        var svg_width_bef = $('#svg1').width();//pozice odshora
        var svg_height_bef = $('#svg1').height();//pozice odshora
        
        
        $("#zoomIn").removeAttr("disabled");
        $("#zoomIn img").attr("src", "images/zoom_in.png");
        this.currentZoomIndex--;
        var zoomStepInPercent = this.CONST_ZOOM_VALUES[this.currentZoomIndex];
        this.currentZoom = this.getZoomStep(zoomStepInPercent);
        
        var graph = $("#graph");
        graph.attr('transform', 'scale('+ this.currentZoom + ')');
        
        GraphManager.setSizeOfSvg();
        graph.attr('transform', 'scale('+ this.currentZoom + ') ' +  GraphManager.centerGraphInViewport(this.currentZoom));
        $("#zoomValue").html(this.CONST_ZOOM_VALUES[this.currentZoomIndex] + "%");
        
        
        var viewport_pos_top_after_zoom = $('#viewport').scrollTop();    //pozice odshora
        var viewport_pos_left_after_zoom = $('#viewport').scrollLeft();  //pozice odshora
        
        
        
        if ( viewport_pos_top_bef_zoom != viewport_pos_top_after_zoom ) {
        	
            var svg_height_after = $('#svg1').height();//pozice odshora
           
            var new_viewport_top = (mouseY + viewport_pos_top_bef_zoom ) / svg_height_bef;
         
        	new_viewport_top = (new_viewport_top * svg_height_after) - mouseY;
        
        	$('#viewport').scrollTop( new_viewport_top );
        	
        }
        
        if ( viewport_pos_left_bef_zoom != viewport_pos_left_after_zoom ) {
        	var viewport_width = $('#viewport').width();
        	
        	var svg_width_after = $('#svg1').width();//šířka
                        
            viewport_pos_left_bef_zoom *= -1;
            var new_viewport_left = (viewport_width - mouseX + viewport_pos_left_bef_zoom ) / svg_width_bef;
            
            new_viewport_left = (new_viewport_left * svg_width_after) - (viewport_width - mouseX);

        	$('#viewport').scrollLeft( new_viewport_left * -1 );
        }
        
        if(this.currentZoomIndex <= 0){
            $("#zoomOut").attr("disabled", "disabled");
            $("#zoomOut img").attr("src", "images/zoom_out_disabled.png");
        }
        console.debug("EXIT Zoom: zoomOut");
    },
 
 
/**
 * Cut two last character from string.
 * parameters: string - string which will be cutted.
 * Return cutted string.
 */
    cutTwoLastCharacters: function(string){
        console.debug("ENTRY Zoom: cutTwoLastCharacters");
        console.debug("EXIT Zoom: cutTwoLastCharacters");
        return string.substring(0,string.length-2);
    },
    
/**
 * Parse string to int.
 * parameters: string - string which will be converted to int
 * Retunt int.
 */
    stringToInt: function(string){
        console.debug("ENTRY Zoom: stringToInt");
        console.debug("EXIT Zoom: stringToInt");
        return parseInt(string);
    },
    
    /**
     * Set size of svg element to the variable.
     */
    setSvgSize: function(){
        console.debug("ENTRY Zoom: setSvgSize");
        if(this.height == 0 && this.width == 0){
            this.height = this.stringToInt(this.cutTwoLastCharacters($("#svg1").css('height')));
            this.width = this.stringToInt(this.cutTwoLastCharacters($("#svg1").css('width')));
        }
        console.debug("EXIT Zoom: setSvgSize");
    },
    
    /**
     * Set size of svg element after zoom.
     */
    setCurrentSvgSize: function(){
        console.debug("ENTRY Zoom: setCurrentSvgSize");
        $("#svg1").css('height', this.height*this.currentZoom);
        $("#svg1").css('width', this.width*this.currentZoom);
        console.debug("EXIT Zoom: setCurrentSvgSize");
    }
});