package cz.zcu.kiv.comav.loaders.sofa2;

import java.io.IOException;
import java.net.URI;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.handlers.HandlerUtil;

import cz.zcu.kiv.comav.core.export.handlers.CommonLoaderHandler;
import cz.zcu.kiv.comav.core.export.loaders.ComponentLoader;
import cz.zcu.kiv.comav.core.export.utils.ComAVException;
import cz.zcu.kiv.comav.loaders.sofa2.wizard.LoaderWizard;

public class Handler extends CommonLoaderHandler {

	public Handler() {
		// TODO Auto-generated constructor stub
	}

	@Override
	public boolean loaderExecute(ExecutionEvent event) throws ComAVException {
		boolean ret = false;

		LoaderWizard wizard = new LoaderWizard();
		WizardDialog dialog = new WizardDialog(
				HandlerUtil.getActiveShell(event), wizard);

		if (dialog.open() == WizardDialog.CANCEL)
			return false;

		projectName = wizard.getProjectName();
		location = wizard.getProjectLocation();
		ComponentLoader loader = wizard.getLoader();

		try {
			loader.load(new URI[] {wizard.getAssembly()});
		} catch (IOException e) {
			throw new ComAVException("Could not load data from bundle.", e);
		}

		compModel = loader.getModel();
		componentList = loader.getComponents();

		if (compModel != null) {
			ret = true;
		}
		return ret;
	}

}
