package cz.zcu.kiv.comav.loaders.sofa2.wizard;

import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class ProjectNamePage extends WizardPage {
	private Text projectNameTextField;
	private Composite container;
	private Button local;
	private Button remote;

	public ProjectNamePage() {
		super("SOFA 2 project");
		setTitle("SOFA 2 project");
		setDescription("Please select name for your new project and type of source.");
	}

	@Override
	public void createControl(Composite parent) {
		container = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 2;

		// First row
		Label projectNameLabel = new Label(container, SWT.NULL);
		projectNameLabel.setText("Project name");

		projectNameTextField = new Text(container, SWT.BORDER | SWT.SINGLE);
		projectNameTextField.setText("");
		projectNameTextField.addKeyListener(new KeyListener() {

			@Override
			public void keyPressed(KeyEvent e) {
			}

			@Override
			public void keyReleased(KeyEvent e) {
				if (!projectNameTextField.getText().isEmpty()) {
					setPageComplete(true);
				}
				else
					setPageComplete(false);
			}

		});
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		projectNameTextField.setLayoutData(gd);

		// second row		
	    Button[] radios = new Button[] {local, remote};
		Label labelSelect = new Label(container, SWT.NONE);
		labelSelect.setText("Select the type of source data");

		local = new Button(container, SWT.RADIO);
		local.setSelection(true);
		local.setText("Load from local directory");
		
	    // third row 
		Label labelEmpty = new Label(container, SWT.NONE);
		labelEmpty.setText("");
		remote = new Button(container, SWT.RADIO);
		remote.setText("Load from SOFA directory");
		
		// Required to avoid an error in the system
		setControl(container);
		setPageComplete(false);
	}
	
	public IWizardPage getNextPage() {
		
		if (remote.getSelection()) {
			return ((LoaderWizard)getWizard()).getRemotePage();
		}
		if (local.getSelection()) {
			return ((LoaderWizard)getWizard()).getLocalPage();
		}
		
		return null;
	}

	public String getProjectName() {
		return projectNameTextField.getText();
	}
	
	public boolean getRemote() {
		if (remote.getSelection()) {
			return true;
		}
		else {
			return false;
		}		
	}
}