package cz.zcu.kiv.comav.loaders.sofa2.wizard;

import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class SelectLocalProjectPage extends WizardPage {
	private Text projectLocationTextField;
	private Composite container;	

	protected SelectLocalProjectPage() {
		super("Choose project source");
		setTitle("Choose local directory");
		setDescription("You can choose any directory, that contains at least one assembly and all required architectures and frames.");
	}

	@Override
	public void createControl(Composite parent) {
		container = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 3;
		
			// First
			Label label1 = new Label(container, SWT.NULL);
			label1.setText("Insert path to bundle");

			projectLocationTextField = new Text(container, SWT.BORDER | SWT.SINGLE);
			projectLocationTextField.setText("");
			projectLocationTextField.addKeyListener(new KeyListener() {

				@Override
				public void keyPressed(KeyEvent e) {
					// noop
				}

				@Override
				public void keyReleased(KeyEvent e) {
					if (!projectLocationTextField.getText().isEmpty()) {
						setPageComplete(true);
					}
					else
						setPageComplete(false);
				}

			});
			GridData gd = new GridData(GridData.FILL_HORIZONTAL);
			projectLocationTextField.setLayoutData(gd);
			final Button button = new Button(container, SWT.NONE);
			button.setText("...");
			button.addMouseListener(new MouseListener() {

				@Override
				public void mouseUp(MouseEvent e) {
					DirectoryDialog dlg = new DirectoryDialog(button.getShell());
					dlg.setText("Choose directory");
					dlg.setMessage("Directory should be SOFA workspace.");
					String dir = dlg.open();
					if (dir == null)
						return;
					projectLocationTextField.setText(dir);
					if (!projectLocationTextField.getText().isEmpty()) {
						setPageComplete(true);
					}
					else
						setPageComplete(false);
				}

				@Override
				public void mouseDown(MouseEvent e) {
					// noop
				}

				@Override
				public void mouseDoubleClick(MouseEvent e) {
					// noop
				}
			});		
			// Required to avoid an error in the system
			
		setControl(container);		
		setPageComplete(false);
	}	
	
	public IWizardPage getNextPage() {		
		return ((LoaderWizard)getWizard()).getAssemblyPage();
	}
	
	public String getProjectLocation() {
		return projectLocationTextField.getText();
	}
}
