<%-- 
    Document   : index
    Created on : 19.2.2012, 10:27:13
    Author     : Cincila
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" type="text/css" href="styles/basic.css" media="screen" />
        <title>Vizualizace</title>

        <script type="text/javascript" src="js/jquery-1.7.1.js"></script>
        <script type="text/javascript" src="js/diagram.js"></script>
        <script type="text/javascript" src="js/user.js"></script>
    </head>
    <body>
        <div id="envelope">
            <header id="header">
                <img src="images/logo.png" alt="logo" title="ZČU"/>
                <h2 class="color-blue">Visualization of large component diagrams </h2>

				<jsp:include page="logged_user.jsp" />
				
            </header>
            <nav id="navigation">
                <ul id="navOfTech">
                </ul>
            </nav>
            <div id="content">
            
            	<jsp:include page="logged_user_menu.jsp" />
            
                <c:if test="${not empty errorMessage}">
                    <p class="errorMessage">${errorMessage}</p>
                </c:if>
                
                <div id="uloadComponent">
                
                
                    <h5>Upload components: </h5>
                    
                    <form action='UploadFiles' method='post' enctype='multipart/form-data'>
                        <input id="uploadFile" name='uploads[]' type=file multiple required="required"/>
                        <br/>
                        <input type='submit' value="Upload" class="load">
                    </form>
                    <hr class="verticalSeparator"/>
                     <h5>Choose framework: </h5>
                        <% if ( request.getParameter("diagram_id") != null ){ %>
	                    	<form action='ShowGraph?diagram_id=<%= request.getParameter("diagram_id") %>&diagram_hash=<%= request.getParameter("diagram_hash") %>' method='post'>
	                    		<input type="hidden" name="diagram_id" value="<%=  request.getParameter("diagram_id") %>" />
	                    		<div class="diagram">
								<%
								
								System.out.println(request.getAttribute("diagram_user_id").toString());
								
								if (request.getSession().getAttribute("logged_user_id") != null &&
										request.getAttribute("diagram_user_id") != null && 
										request.getAttribute("diagram_user_id").toString().compareTo(request.getSession().getAttribute("logged_user_id").toString()) == 0 ) { %>
										
		                    		<h6>Edit diagram name:</h6>
									<input type="text" name="diagram_name" id="input_diagram_name" value="${diagram_name}" />
									<br />							
									<br />
									<h6>Public diagram:</h6><input type="checkbox" name="public_diagram" value="1"  ${diagram_public_checked} />
								<% } else if (request.getSession().getAttribute("logged_user_id") != null ){%>
									<h6>Edit diagram name:</h6>
									<input type="text" name="diagram_name" id="input_diagram_name" value="${diagram_name}" />
									<br />							
									<br />
									<h6>Copy diagram:</h6><input type="checkbox" name="copy_diag" value="1" />
								<% } %>
								<br />							
								<br />
								</div>	
																
                    	<% }else{ %>
                    		<form action='ShowGraph' method='post'>
                    		
                    			    <% if ( request.getSession().getAttribute("logged_user") == "1" ){ %>
										<div class="diagram">
											<h6>Diagram name:</h6>
											<input type="text" name="diagram_name" id="input_diagram_name" />
											<br />							
											<br />
											
											<h6>Public diagram:</h6><input type="checkbox" name="public_diagram" value="1" ${diagram_public_checked} />
											<br />							
											<br />
										</div>										                
					                <% } %>
                    		
                    	<% } %>
                        <select name="framework" id="framework" >
                            <option value="osgi">OSGi</option>
                            <option value="ejb3">EJB3</option>
                            <option value="sofa2">SOFA2</option>
                        </select>
                        <br/>
                        <br/>
                        <input type='submit' value="Start visualization" class="formButton" ${not empty componentNames ? "" : "disabled='disabled'"}>
                    </form>
                    
                    <c:if test="${not empty componentNames}">
                        <hr class="verticalSeparator"/>
                        <h5>Uploaded components: </h5>
                        <ul id="uploadedComponent">
                            
                                <% if (request.getParameter("diagram_id") == null) {
                                	request.setAttribute("url_diagram_id", "");
                                	%>
                                	<li id="deleteAll">Delete all <a href="DeleteAllComponents"><img src="images/button_cancel.png" alt="odstranit" class="imgDelete"/></a></li>
                                	<%
                                }else{
                                	request.setAttribute("url_diagram_id", "&diagram_id="+ request.getParameter("diagram_id") +  "&diagram_hash="+ request.getParameter("diagram_hash"));
                                }
                                
                                %>
                                    <c:forEach items="${componentNames}" var="componentName">
                                <li id="${componentName}">${componentName}                                
                                <% if (request.getParameter("diagram_id") == null || ( request.getSession().getAttribute("logged_user_id") != null &&
										request.getAttribute("diagram_user_id") != null && 
										request.getAttribute("diagram_user_id").toString().compareTo(request.getSession().getAttribute("logged_user_id").toString()) == 0  )) { %>
                                	<a href="DeleteComponent?name=${componentName}<%= request.getAttribute("url_diagram_id") %>"><img src="images/button_cancel.png" alt="odstranit" class="imgDelete"/></a></li>
                                <% } %>
                                
                                    </c:forEach>
                        </ul>
                    </c:if>
                    
           
                </div>
            </div>
        </div>
    </body>
</html>
